#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                  CRONTAB CONFIGURATION FILES                   #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 15/04/2014     #####
####                                                                #####
#########################################################################

$cwd = $0;
$cwd =~ s/(([^\\\/]+)$)//;
require "$cwd"."init.pl";

# Print out a content-type for HTTP/1.0 compatibility
print "Content-type: text/html\n\n";

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);

    # Un-Webify plus signs and %-encoding
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    # Stop people from using subshells to execute commands
    # Not a big deal when using sendmail, but very important
    # when using UCB mail (aka mailx).
    # $value =~ s/~!/ ~!/g; 

    # Uncomment for debugging purposes
#    print "Setting $name to $value<P>";
	
    $FORM{$name} = $value;
}

$cronw3perl = "cron-w3perl".$plext;
$fileconf = $cgipath.$dirsep.$FORM{'configfile'};
$fileconf =~ s/$plext$//;
$pos = rindex($fileconf,$dirsep);
$fileconf = substr($fileconf,$pos,length($fileconf));
$loadconf = $w3perlpathres.$fileconf;
&load($loadconf);
#&loadvar($varforms);

&securecgi if ($ENV{'HTTP_REFERER'} !~ /$cgiurl/);

#########################################################################
###                            LAUNCH                                 ###
#########################################################################

if ($ENV{'QUERY_STRING'} =~ /display/) {

#$hiddentag = "<INPUT NAME=\"script\" TYPE=\"hidden\" VALUE=\"$FORM{'script'}\"><BR>\n";
#$hiddentag .= "<INPUT NAME=\"configfile\" TYPE=\"hidden\" VALUE=\"$FORM{'configfile'}\"><BR>\n";
#$hiddentag .= "<INPUT NAME=\"version\" TYPE=\"hidden\" VALUE=\"1\">";

$filename = $pathsetup."crontab".$htmlext;

# MAJ de $loadconf et de $w3perlpath$dirsep$dirconfig$dirsep$FORM{'configfile'}$plext !

$FORM{'inc_launch_time'} += 12 if ($FORM{'scripthourap'} == 12);

# Rewrite de $loadconf

open(FILE,"$loadconf");
@lines = (<FILE>);
close FILE;

open(FILE,">$loadconf") || die "Can't open $loadconf";
foreach $line (@lines) {
    ($val1,$val2) = split(/\s+/,$line);

    if ($val1 =~ /actif/i) {
	$line =~ s/$val2/$FORM{$val1}/ if ($FORM{$val1} == 1);
	$line =~ s/$val2/0/ if ($FORM{$val1} != 1);
	}
    if ($val1 =~ /launch/i) {
	$line =~ s/$val2/$FORM{$val1}/ if ($FORM{$val1} ne '');
    }

    print FILE "$line";
}
close(FILE);

# Rewrite de $w3perlpath$dirconfig$dirsep$FORM{'configfile'}$plext

$filetmp = "$w3perlpath$dirconfig$fileconf$plext ";

$FORM{'hour_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'day_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'week_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'month_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'agent_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'refer_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'error_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'session_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'url_launch_time'} = $FORM{'inc_launch_time'};
$FORM{'history_launch_time'} = $FORM{'inc_launch_time'};

open(FILE,"$filetmp");
@lines = (<FILE>);
close FILE;

open(FILE,">$filetmp") || die "Can't open $filetmp";
foreach $line (@lines) {
    chop($line);

    if ($line =~ /actif/) {
	($val1,$val2) = split(/\s+=\s+/,$line);
	$val1 =~ s/\$//;
	if ($val2 ne '' && $val2 =~ /\d;/) {
	    $val2 =~ s/;//;
	    $line =~ s/$val2/$FORM{$val1}/ if ($FORM{$val1} == 1);
	    $line =~ s/$val2/0/ if ($FORM{$val1} != 1);	
	}
    }
    if ($line =~ /launch/i) {
	($val1,$val2) = split(/\s+=\s+/,$line);
	$val1 =~ s/\$//;
	if ($val2 ne '' && $val2 =~ /\d;/) {
	    $val2 =~ s/;//;
	    $line =~ s/$val2/$FORM{$val1}/ if ($FORM{$val1} ne '');
	}
    }
    print FILE "$line\n";
}
close(FILE);

$pathcgi .= "w3perl$dirsep";

#

$comment = "Your configuration file $filetmp have been updated. <BR>You should now COPY it in $cgipath$dirsep$FORM{'configfile'}. (I can't do the copy for security restriction)";

$string = "$FORM{'inc_launch_time_min'} $FORM{'inc_launch_time'} * * * $cgipath$dirsep$cronw3perl";
$string .= " -c $cgipath$dirsep$FORM{'configfile'}" if ($FORM{'configfile'} ne "config$plext");
$string .= "$plext " if ($FORM{'configfile'} !~ /$plext$/);
$string .= " -e";

&error_open_admin($filename) if (!(-r $filename));
open(FILE,"$filename") || die "Can't open $filename\n";
while (<FILE>) {
#    s/<!-- HELP -->/$helpurl/;
    s/<!-- BG -->/$bkg/;
    s/<!-- CSS -->/$cssurl/;
    s/<!-- LINE -->/$bkgline/;
    s/<!-- REFER_ADMIN_PAGE -->/$FORM{'referer_page'}/;
    s/<!-- bkglink -->/$bkglink/;
    s/<!-- bkgback -->/$bkgback/;
#    s/<!-- HIDDEN -->/$line2/;
#    s/<!-- configfile -->/$FORM{'configfile'}/;
#    s/<!-- cgiurl -->/$cgiurl/;
#    s/<!-- w3perlurl -->/$w3perlurl/;
#    s/<!-- hidden -->/<!-- hidden -->\n$hiddentag/;
    s/<!-- COMMENT -->/$comment/;
    s/<!-- DISPLAY -->/$string/;
    print;

#print "$tmp1 - $oldvalue{$tmp1}\n";
}
close (FILE);



exit;
}

#########################################################################
###                            DISPLAY                                ###
#########################################################################

# Get the input

$filename = $pathsetup."cron".$htmlext; 

$file = $FORM{'configfile'}; 

open(FILE,"$loadconf");
@lines = (<FILE>);
close FILE;

foreach $line (@lines) {
    chop($line);
    ($val1,$val2) = split(/\t/,$line);

    if ($val1 =~ /^logfile/i) {
	$logfile = $val2;
    }
    if ($val1 =~ /^server_used/i) {
	$server_used = $val2;
    }

    if ($val1 =~ /^refererlog/i) {
	$refererlog = $val2;
    }

    if ($val1 =~ /^agentlog/i) {
	$agentlog = $val2;
    }

    if ($val1 =~ /^errorlog/i) {
	$errorlog = $val2;
    }

    if ($val1 =~ /^struct_logfile/i) {
	$stringlogfile = $val2;
    }

}


$hidden = "<INPUT NAME=configfile TYPE=hidden VALUE=\"$file\">\n";
$hidden .= "<INPUT NAME=referer_page TYPE=hidden VALUE=\"$FORM{'referer_page'}\">\n";

# ouvrir le fichier de config et regarder quels sont les scripts actifs...

#&load($loadconf);

$temps = $oldvalue{'inc_launch_time'}*60+$oldvalue{'inc_launch_time_min'};
$oldvalue{'inc_launch_time'} -= 12 if ($oldvalue{'inc_launch_time'} > 11);
$oldvalue{'scripthourap'} = 0 if ($temps <= 720);
$oldvalue{'scripthourap'} = 12 if ($temps > 720);

$out2 = 0;
open(FILE,$filename);
while (<FILE>) {
    $out = 0;
    s/<!-- HELP -->/$helpurl/;
    s/<!-- BG -->/$bkg/;
    s/<!-- CSS -->/$cssurl/;
    s/<!-- LINE -->/$bkgline/;
    s/<!-- REFER_ADMIN_PAGE -->/$FORM{'referer_page'}/;
    s/<!-- WARNING -->/$string_err/;
    s/<!-- DISPLAY -->/$string/;
    s/<!-- HIDDEN -->/$hidden/;
    $line = $_;

    $out2 = 1 if ($_ =~ /BEGIN_ERROR_ACTIF/ && $server_used == 4);
    $out2 = 0 if ($_ =~ /END_ERROR_ACTIF/ && $server_used == 4);

    $out2 = 1 if ($_ =~ /BEGIN_MAIL/ && $server_used == 9);
    $out2 = 0 if ($_ =~ /END_MAIL/ && $server_used == 9);
    $out2 = 1 if ($_ =~ /BEGIN_MAIL/ && $server_used == 10);
    $out2 = 0 if ($_ =~ /END_MAIL/ && $server_used == 10);
    $out2 = 1 if ($_ =~ /BEGIN_MAIL/ && $server_used == 11);
    $out2 = 0 if ($_ =~ /END_MAIL/ && $server_used == 11);
    $out2 = 1 if ($_ =~ /BEGIN_MAIL/ && $server_used == 12);
    $out2 = 0 if ($_ =~ /END_MAIL/ && $server_used == 12);
	
    $out2 = 1 if ($_ =~ /BEGIN_AGENT_ACTIF/ && ($logfile eq "CLF" && $refererlog eq ''));
    $out2 = 0 if ($_ =~ /END_AGENT_ACTIF/ && ($logfile eq "CLF" && $refererlog eq ''));
    $out2 = 1 if ($_ =~ /BEGIN_REFER_ACTIF/ && ($logfile eq "CLF" && $agentlog eq ''));
    $out2 = 0 if ($_ =~ /END_REFER_ACTIF/ && ($logfile eq "CLF" && $agentlog eq ''));

    $out2 = 0 if ($_ =~ /BEGIN_AGENT_ACTIF/ && $server_used == 0 && $stringlogfile =~ /\%agent/);
    $out2 = 1 if ($_ =~ /END_AGENT_ACTIF/ && $server_used == 0 && $stringlogfile =~ /\%agent/);
    $out2 = 0 if ($_ =~ /BEGIN_REFER_ACTIF/ && $server_used == 0 && $stringlogfile =~ /\%referer/);
    $out2 = 1 if ($_ =~ /END_REFER_ACTIF/ && $server_used == 0 && $stringlogfile =~ /\%referer/);

    $out2 = 1 if ($_ =~ /BEGIN_AGENT_ACTIF/ && ($logfile eq "Squid-Common" && $refererlog eq ''));
    $out2 = 0 if ($_ =~ /END_AGENT_ACTIF/ && ($logfile eq "Squid-Common" && $refererlog eq ''));
    $out2 = 1 if ($_ =~ /BEGIN_REFER_ACTIF/ && ($logfile eq "Squid-Common" && $agentlog eq ''));
    $out2 = 0 if ($_ =~ /END_REFER_ACTIF/ && ($logfile eq "Squid-Common" && $agentlog eq ''));

    $out2 = 1 if ($_ =~ /BEGIN_AGENT_ACTIF/ && ($logfile eq "Cups"));
    $out2 = 0 if ($_ =~ /END_AGENT_ACTIF/ && ($logfile eq "Cups"));
    $out2 = 1 if ($_ =~ /BEGIN_REFER_ACTIF/ && ($logfile eq "Cups"));
    $out2 = 0 if ($_ =~ /END_REFER_ACTIF/ && ($logfile eq "Cups"));

    $out2 = 1 if ($_ =~ /BEGIN_AGENT_ACTIF/ && (($server_used >= 9 && $server_used <= 12) || $server_used == 7 || $server_used == 14 || $server_used == 16));
    $out2 = 0 if ($_ =~ /END_AGENT_ACTIF/ && (($server_used >= 9 && $server_used <= 12) || $server_used == 7 || $server_used == 14 || $server_used == 16));
    $out2 = 1 if ($_ =~ /BEGIN_REFER_ACTIF/ && (($server_used >= 9 && $server_used <= 12) || $server_used == 7 || $server_used == 14 || $server_used == 16));
    $out2 = 0 if ($_ =~ /END_REFER_ACTIF/ && (($server_used >= 9 && $server_used <= 12) || $server_used == 7 || $server_used == 14 || $server_used == 16));

    $out2 = 1 if ($_ =~ /BEGIN_ERROR_ACTIF/ && ($server_used >= 7 && $server_used <= 12 || $server_used == 14 || $server_used == 16));
    $out2 = 0 if ($_ =~ /END_ERROR_ACTIF/ && ($server_used >= 7 && $server_used <= 12 || $server_used == 14 || $server_used == 16));

    $out2 = 1 if ($_ =~ /BEGIN_URL_ACTIF/ && ($server_used >= 7 && $server_used <= 12 || $server_used == 14 || $server_used == 16));
    $out2 = 0 if ($_ =~ /END_URL_ACTIF/ && ($server_used >= 7 && $server_used <= 12 || $server_used == 14 || $server_used == 16));
    $out2 = 1 if ($_ =~ /BEGIN_URL_ACTIF/ && ($logfile eq "Cups" || $logfile eq "Dhcp"));
    $out2 = 0 if ($_ =~ /END_URL_ACTIF/ && ($logfile eq "Cups" || $logfile eq "Dhcp"));

    if ($out2 == 0) {
    if ($line =~ /(NAME=")([\w]+)".*("radio").*(VALUE=")([0-9a-zA-Z_]+)(")/i) {
	print "$`$1$2\" TYPE=$3 $4$5$6 CHECKED$'" if ($5 eq $oldvalue{$2});
	print "$`$1$2\" TYPE=$3 $4$5$6$'" if ($5 ne $oldvalue{$2});
	$out = 1;
    }

    if ($line =~ /(NAME=")([\w]+)".*("checkbox").*(VALUE=")([0-9a-zA-Z_]+)(")/i) {
	print "$`$1$2\" TYPE=$3 $4$5$6 CHECKED$'" if ($5 eq $oldvalue{$2});
	print "$`$1$2\" TYPE=$3 $4$5$6$'" if ($5 ne $oldvalue{$2});
	$out = 1;
    }

    if ($line =~ /<SELECT NAME="([0-9a-zA-Z_]+)"/ && $line !~ /HIDDEN/i) {
	$val = $1;
    }

    if ($line =~ /OPTION VALUE="([0-9a-zA-Z_]+)">/i) {
	print "$`OPTION VALUE=\"$1\" SELECTED>$'" if ($1 eq $oldvalue{$val});
	print "$`OPTION VALUE=\"$1\">$'" if ($1 ne $oldvalue{$val});
	$out = 1;
    }
    }

#    $out = &option($_,$out,$FORM{'action'}) if ($out2 == 0);
#    print "BB $line - $out - $out2" if ($out == 0 && $out2 == 0);
    print "$line" if ($out == 0 && $out2 == 0);
}
close (FILE);
