#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                       HISTORY STATS                            #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 15/04/2014     #####
####                                                                #####
#########################################################################

$verdate = "15/04/14";

############ script to launch daily at 00 hour 01 minute  ##########

$cwd = $0;
$cwd =~ s/(([^\\\/]+)$)//;
require "$cwd"."libw3perl.pl";

$pos = rindex($conf_file,$dirsep);
$vtmp = substr($conf_file,$pos+1,length($conf_file));
#$pos = rindex($0,"-");
#$vtmp .= substr($0,$pos+1,length($0));
$vtmp .= $scriptname;
$vtmp =~ s/$plext//g;
$status_script = 0;

$starttime = time();

$scriptname = "cron-history.pl";

# calculer le temps mis pour le calcul
$startrun = "$hour:$minute:$second";
if ($opt_y eq '') {
    print "<DIV CLASS=\"launch_script\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg = "CPU stats : $version\n";
    &output_log($msg);
    print "</DIV><P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}
print "<DIV ID=\"TOGGLE_$scriptname\" STYLE=\"display:inline\">\n" if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y ne '');

#$yesterday = &yesterday_date($day,$countmonth,$year);

#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h == 1) {
      print STDOUT "Usage : \n";
      print STDOUT "        -c <file>             : load configuration file\n";
#      print STDOUT "        -d <nbdays>           : number of days to scan\n";
      print STDOUT "        -g <";      
      for ($i=0;$i<$#graphic;$i++) {
      print STDOUT "$graphic[$i] ";
      } 
      print STDOUT "$graphic[$#graphic]";
      print STDOUT "> : graphic output (choose one)\n";
      print STDOUT "        -l <";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      } 
      print STDOUT "$lang[$#lang]";
      print STDOUT ">            : language output (comma split)\n";            
      print STDOUT "        -x                    : show default value for flag options\n";
      print STDOUT "        -v                    : version\n"; 
      print STDOUT "\n";
      exit;
}


if ($opt_v == 1) {
      print "$scriptname version $version $verdate\n";
      exit;
}

if ($opt_x == 1) {
      print STDOUT "Default : \n";
      print STDOUT "          -c            : $configfile\n";
#      print STDOUT "          -d <nbdays>   : $nbdays\n";
      print STDOUT "          -g <graphic>  : $graphic[0]\n";
      print STDOUT "          -l <language> : ";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      }
      print STDOUT "$lang[$#lang]\n";      
      print STDOUT "          -v            : $version\n";
      exit;
}

if ($opt_l ne '') {
  @lang = split(/, /,$opt_l);
  for ($i=0;$i<=$#lang;$i++) {
      $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext;
      $tmp = $pathinit.$tmp;
      require "$tmp";
  }
  if ($lang[0] eq '') {
      print STDERR "\nNone of your language choices have been yet translated !\n";
      exit; 
      }
}

if ($opt_g ne '') {
  if ($opt_g eq "3d")  {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 1;
  }
  if ($opt_g eq "fill") {
      $bargraph = 0;
      $linegraph = 1;
      $fillgraph = 1;
  }
  if ($opt_g eq "line") {
      $bargraph = 0;
      $linegraph = 1;
  }
  if ($opt_g eq "bar") {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 0;
  }
}

#if ($opt_d ne '') {
#$nbdays = $opt_d; 
#}

if ($opt_p ne '') {
$precision = $opt_p; 
}

#################################################################
####          debut de l'initialisation                   #######
#################################################################

&MakeDirectories;

&load_basic_stats;

###

$linkdirdate = $data;

$file1 = $path.$dirgraph.$dirsep."cpu".$gifext;
$file1x = $path.$dirgraph.$dirsep."cpux".$gifext;
$file1y = $path.$dirgraph.$dirsep."cpuy".$gifext;
$linkfile1 = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."cpu".$gifext;
$linkfile1x = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."cpux".$gifext;
$linkfile1y = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."cpuy".$gifext;

$others = "others".$gifext;

#################################################################
####                   date de ce jour                    #######
#################################################################

### today date

$month_number = $month_equiv{$month};
$month_number--;
$today = $day." ".$month." ".$year;

$year_now = $year;

### nombre de jour entre le 1er janvier et $today

$timesec = time;
($date,$datehour,$datemisc) = &get_time($timesec);

($jour_of_year_end) = split(/ /,$datemisc);

#print STDERR "JOUR_OF_YEAR_END : $jour_of_year_end\n";

### date il y a $nbdays jours

if ($nbdays != 0 ) {

$pastday = $day  - $nbdays; 
$pastyear = $year;
$pastmonth = $month_nb[$month_number];

while ($pastday < 1) {
  $month_number--;
  if ($month_number < 0) {
      $pastyear--;
      $month_number = 11;
   }
   $pastmonth = $month_nb[$month_number];
   $pastday = $pastday + $month_of_year{$pastmonth};
}

$pasttoday = $pastday." ".$pastmonth." ".$pastyear;         
  
}

#################################################################
#####               computing history stats                ######
#################################################################

if (!(-f $history)) {
    print "No $history file found\n";
    exit;
} 

 open(INFILE,"$history"); # || die "Error, unable to open $history\n";

 while (<INFILE>) {
 ($prg,$date,$time1,$time2,$cpu,$codeline,$check) = split;
 next if ($check ne '');
# next if ($codeline == 0);
 $prg =~ s/$plext//;
 $nb = split(/:/,$cpu);
 $hour = 0;
 ($hour,$min,$sec) = split(/:/,$cpu) if ($nb == 3);
 ($min,$sec) = split(/:/,$cpu) if ($nb == 2);
 next if ($min < 0 || $sec < 0);

 if ($count_day == 0) {
     $firstjour = $date;

     $date1 = $date;
     $date1 =~ s/\// /g;
     $jour_of_year_tmp = &nbday($date1);
 }

 $count_day++ if ($date ne $dateold);
 $dateold = $date;
 $sec = 1 if ($hour == 0 && $min == 0 && $sec == 0);
 $cpu{$prg} += $sec+($min*60)+($hour*60*60);

 if ($codeline ne '') {
 $codeline{$prg} += $codeline;
 $nbcode{$prg}++;
 }
 if ($codeline eq '') {
     $codeline = "-";
#     $nbcode{$prg} = 0;
} 
 push(@line,"$prg\t$date\t$time1\t$hour\t$min\t$sec\t$codeline\t") ;
# print "A - $prg\t$date\t$time1\t$hour\t$min\t$sec\t$codeline\n";
 $nbprg{$prg}++;
 $scriptdate{$prg} = $date;

 $unique++ if ($nbprg{$prg} == 1); # unless ($seen{"$prg"}++);
}
 close(INFILE);

$lastdate = $date;

####

$date1 = $date;
$date1 =~ s/\// /g;
$jour_of_year_tmp2 = &nbday($date1);

$count_day = $jour_of_year_tmp2 - $jour_of_year_tmp;
#$count_day += 365 if ($count_day < 0);

####

$occurcpu[0] = 0;

foreach $value (keys(%cpu)) { 
if ($cpu{$value} > $occurcpu[0]) {
    $occurcpu[0] = $cpu{$value};
    $bestcpu[0] = $value;
}
}

for ($i=1;$i <=$unique;$i++) {
    $occurcpu[$i] = 0;
    foreach $value (keys(%cpu)) {
        $out = 0;
        if ($cpu{$value} >= $occurcpu[$i] && ($cpu{$value} <= $occurcpu[$i-1])) {
               for ($j=0;$j<= $i;$j++) {
                  $out = 1 if ($bestcpu[$j] eq $value);
                }
                if ($out == 0) {
                      $occurcpu[$i] = $cpu{$value};
                      $bestcpu[$i] = $value;
                }
        }
     }
}

####

foreach $value (keys(%cpu)) { 
#$moy{$value} = int($cpu{$value}/$nbprg{$value});
    $moy{$value} = $cpu{$value}/$nbprg{$value};
    $moycodeline{$value} = int($codeline{$value}/$nbcode{$value}) if ($nbcode{$value} != 0);

#print "A - $value - $cpu{$value} / $nbprg{$value} = $moy{$value} : $codeline{$value} / $nbcode{$value} = $moycodeline{$value}\n";
    $tot += $cpu{$value};
    $nbtotprg += $nbprg{$value};

    #next if ($value =~ /week/ || $value =~ /day/ || $value =~ /url/);

#    $secmax = 0;
    #$linemax = 0;

    undef @graphcpu;
    $count = 0;
    for ($i=0;$i<=$#line;$i++) {
	($prg,$date,$time1,$hour,$min,$sec,$line) = split(/\t/,$line[$i]);
	if ($prg eq $value) {
	    $sec = $sec + (60*$min)+($hour*60*60);
	    $graphcpu[$sec] = $line if ($line ne '-');
	    $graphcpu[$sec]++ if ($line eq '-');
	    $count++;
#	    print "$i $sec - $graphcpu[$sec] - $value - $line\n";
#	    $secmax = $sec if ($sec > $secmax);
#			$linemax = $line if ($line > $linemax); 
	}
    }


    for ($nblang=0;$nblang<=$#lang;$nblang++) {
	$file_to_open = $path.$lang[$nblang].$dirsep.$dirlist.$dirsep.$value.$htmlext;
#	print "OPEN $file_to_open\n";
	open(TABOUT, ">$file_to_open") || die "Error, unable to open $file_to_open\n";
	&TableScript(*TABOUT,eval($Lang{$lang[$nblang]}),$value);
	close(TABOUT);
    }
}


####

for ($nblang=0;$nblang<=$#lang;$nblang++) {

    $file_to_open = $path.$lang[$nblang].$dirsep.$dirlist.$dirsep.$filecpu.$htmlext;

    open(TABOUT, ">$file_to_open") || die "Error, unable to open $file_to_open\n";
    &TableCpu(*TABOUT, eval($Lang{$lang[$nblang]}));
    close(TABOUT);
}

###

sub TableScript { 
    local(*FOUT,*L,$value) = @_;
    local($date);

    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Stats_about_CPU'} - $value</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";	 
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
    print FOUT "$curvy_bottom_jss\n";
    
    &add_jqplot_js(*FOUT,2);
    &add_css_style(*FOUT,2);

    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
    print FOUT "<H2>$L{'CPU'} - $value</H2><P>\n";
    print FOUT "<P><HR>\n";
    print FOUT "<CENTER><B>$firstjour - $scriptdate{$value}</B></CENTER>\n";
    print FOUT "<HR><P><CENTER>\n";

#    if ($value !~ /week/ && $value !~ /day/ && $value !~ /url/) {

	if ($fly_set == 0) {

	    $xlegend = "$L{'CPU'} ($L{'seconds'})";

	    if ($nbcode{$value} != 0) {
		$ylegend = $L{'Lines_processed'};
	    } else { 
		$ylegend = $L{'Occurence'};
	    }

	    &MakeGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$lang,\@graphcpu,1,$chart_id,1,$xlegend,$ylegend,$xmax_jqplot,$ymax_jqplot);
	}

	if ($fly_set == 1) {
	    $linkfile = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$value.$gifext;
	    $linkfilex = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$value."x".$gifext;
	    $linkfiley = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl.$value."y".$gifext;  
	
	    print FOUT "<TABLE>\n";
	    print FOUT "<TR>\n";
	    print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkfiley\" ALT=\"y\"></TD>\n";
	    print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkfile\" ALT=\"$value\" BORDER=0></TD>\n";
	    print FOUT "</TR><TR><TD></TD>\n";
	    print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkfilex\" ALT=\"x\"></TD>\n";
	    print FOUT "</TR>\n";
	    print FOUT "</TABLE><P>\n";
	}

	print FOUT "<P><I>$L{'Blue_line_is_average'}</I>\n<P>\n";
#    }
    print FOUT "<TABLE><TR>\n";
    print FOUT "<TH COLSPAN=4>$value</TH></TR><TR><TD>\n";
    print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
    print FOUT "<thead>\n";
#    print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"cpu_script\">\n";
    print FOUT "<TR>\n";
    print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Date'}&nbsp;</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric_datetime\">&nbsp;$L{'Hour'}&nbsp;</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric_datetime\">&nbsp;$L{'CPU'}&nbsp;</TH>\n";
#    if ($value !~ /week/ && $value !~ /day/ && $value !~ /url/) {
    print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Lines_processed'}&nbsp;</TH>\n" if ($nbcode{$value} != 0);
#    }
    print FOUT "</TR>\n";
    print FOUT "</thead>\n";
    print FOUT "<tbody>\n";

    $val = 0;

    for ($i=$#line;$i>=0;$i--) {
	($prg,$date,$time1,$hour,$min,$sec,$line) = split(/\t/,$line[$i]);

	if ($prg eq $value && $val < $topten) {
	    
	    $val++;
	    if ($min > 60) {
		$hour = int($min/60);
		$min = int($min-($hour*60));
	    }

	    $min = "0".$min if (length($min) == 1);
	    $sec = "0".$sec if (length($sec) == 1);
	    $hour = "0".$hour if (length($hour) == 1);
	    
	    print FOUT "<TR><TD>$date</TD><TD>$time1</TD><TD>$hour:$min:$sec</TD>";
#	    if ($value !~ /week/ && $value !~ /day/ && $value !~ /url/) {
	    if ($nbcode{$value} != 0) {
		print FOUT "<TD CLASS=\"right\">$line</TD></TR>\n" if ($line ne "-");
		print FOUT "<TD>$line</TD></TR>\n" if ($line eq "-");
	    }
	}
    }
    print FOUT "</tbody>\n";
    print FOUT "</TABLE>\n";
    print FOUT "</TD></TR></TABLE>\n";
    print FOUT "</CENTER><P><HR><P>\n";    
    print FOUT "</BODY></HTML>\n";
}


sub TableCpu { 
    local(*FOUT,*L) = @_;

    print FOUT "$doctype\n";
    print FOUT "<HTML><HEAD>\n";
    print FOUT "$charset\n";
    print FOUT "<TITLE>$L{'Stats_about_CPU'} - $L{'Tab_about_lastdays1'} $count_day $L{'Tab_about_lastdays2'}</TITLE>\n";
    print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";	 
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
    print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";

    print FOUT "$curvy_bottom_jss\n";

    &add_css_style(*FOUT,2);

    print FOUT "</HEAD>\n";
    print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
    &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
    print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
    print FOUT "<TR>\n";
    print FOUT "<TD ALIGN=LEFT VALIGN=MIDDLE WIDTH=\"20%\">";

    print FOUT "</TD>\n";
    print FOUT "<TD ALIGN=CENTER WIDTH=\"60%\">\n";

    print FOUT "<TABLE>\n<TR>\n<TD ALIGN=CENTER>\n";
    print FOUT "<DIV CLASS=\"curly_title\">\n";
    print FOUT "<H1>".uc(&noaccentinhtml($L{'Stats_about_CPU'}))."</H1>\n";
    print FOUT "</DIV>\n";
    print FOUT "</TD>\n</TR>\n</TABLE>\n";

    print FOUT "</TD>\n";
    print FOUT "<TD ALIGN=RIGHT VALIGN=MIDDLE WIDTH=\"20%\">\n";

    print FOUT "</TD>\n";
    print FOUT "</TR>\n";
    print FOUT "</TABLE>\n";

    print FOUT "<P><HR>\n";
    print FOUT "<CENTER><B>$firstjour - $lastdate</B></CENTER>\n";
    print FOUT "<HR><P>\n";
    print FOUT "$L{'Tab_about_lastdays1'} $count_day $L{'Tab_about_lastdays2'}<BR><BR>\n";
#    print FOUT "<TABLE CLASS=\"sortable\" ID=\"cpu\">\n";
    print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
    print FOUT "<thead>\n";
    print FOUT "<TR>\n";    
    print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Scripts'}&nbsp;</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric_datetime\">&nbsp;Total CPU <BR>($L{'seconds'})&nbsp;</TH>\n";
    print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric_datetime\">&nbsp;$L{'Average_CPU'} <BR>($L{'seconds'})&nbsp;</TH>\n";
    print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Speed'} <BR>($L{'Lines_processed'}/$L{'seconds'})&nbsp;</TH>\n";
    print FOUT "</TR>\n";
    print FOUT "</thead>\n";
    print FOUT "<tbody>\n";

    for ($i=0;$i<$unique;$i++) {
	$value = $bestcpu[$i];
	$tmp = $value.$htmlext;
	print FOUT "<TR><TD ALIGN=CENTER><A HREF=\"$tmp\">$value</A></TD>\n";

	$hour = int($cpu{$value}/3600);
	$min = int(($cpu{$value}-($hour*3600))/60);
	$sec = $cpu{$value}-($hour*3600)-($min*60);

	$min = "0".$min if (length($min) == 1);
	$sec = "0".$sec if (length($sec) == 1);

	print FOUT "<TD CLASS=\"right\">$hour:$min:$sec</TD>\n";
	print FOUT "<TD CLASS=\"right\">$nbprg{$value}</TD>\n";

	$min = int($moy{$value}/60);
	$min = "0".$min if (length($min) == 1);
	$sec = int($moy{$value} - ($min*60));
	$sec = "0".$sec if (length($sec) == 1);

	print FOUT "<TD CLASS=\"right\">$min:$sec</TD>\n";
	print FOUT "<TD CLASS=\"right\">";
	if (($value =~ /week/ || $value =~ /day/ || $value =~ /url/) || (int($nbcode{$value}) == 0)) {
	    print FOUT "-";
	} else {
	    $tmp = $moycodeline{$value}/$moy{$value} if ($moy{$value} != 0);
	    printf FOUT "%.1f",$tmp if (int($tmp) == 0);
	    print FOUT int($tmp) if (int($tmp) != 0);
	}
	print FOUT "</TD>\n";
	print FOUT "</TR>\n";
    }

    $hour = int($tot/3600);
    $min = int(($tot-($hour*3600))/60);
    $sec = $tot-($hour*3600)-($min*60);
    
    $hour = "0".$hour if (length($hour) == 1);
    $min = "0".$min if (length($min) == 1);
    $sec = "0".$sec if (length($sec) == 1);

    print FOUT "</tbody><tbody class=\"table-nosort\">\n";
    print FOUT "<TR><TD>&nbsp;</TD>\n<TD CLASS=\"right\"><B>$hour:$min:$sec</B></TD>\n";
    print FOUT "<TD CLASS=\"right\">$nbtotprg</TD>";

    $totmoy = int($tot/$nbtotprg) if ($nbtotprg != 0);
    
    $min = int($totmoy/60);
    $min = "0".$min if (length($min) == 1);
    $sec = $totmoy - ($min*60);
    $sec = "0".$sec if (length($sec) == 1);
    
    print FOUT "<TD CLASS=\"right\"><I>$min:$sec</I></TD>\n";
    print FOUT "<TD CLASS=\"right\">&nbsp;</TD></TR>\n";
    print FOUT "</tbody>\n";
    print FOUT "</TABLE>\n";
    print FOUT "<P>\n";    
    print FOUT "</BODY></HTML>\n";

}

#################################################################

if ($fly_set == 1) {

foreach $value (keys(%cpu)) { 

next if ($value =~ /week/ || $value =~ /day/ || $value =~ /url/);

$secmax = 0;
$linemax = 0;

for ($i=0;$i<=$#line;$i++) {
($prg,$date,$time1,$hour,$min,$sec,$line) = split(/\t/,$line[$i]);
if ($prg eq $value) {
 $sec = $sec + (60*$min)+($hour*60*60);
 $graphcpu[$sec] = $line;
 $secmax = $sec if ($sec > $secmax);
 $linemax = $line if ($line > $linemax); 
 }

}


$grad = 7;

$it = length($secmax)-1;
$div = 10**$it;
$factx = ($div*(int($secmax/$div)+1))/$grad;

$repmax = 0;

$it = length($linemax)-1;
$div = 10**$it;
$facty = ($div*(int($linemax/$div)+1))/$grad;

$fymax = $ymax-2;
$xstep = int($xmax/$grad);

 open(FLY,">$tmpfly$vtmp");
 print FLY "new\n";
 print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,$xmax,$ymax,200,200,200\n";
 $oldj = 0;

 for ($j=1;$j<=$secmax;$j++) {
 next if ($graphcpu[$j] == 0);

 $x1 = ($j-1)*$xstep/$factx;
 $x2 = $j*$xstep/$factx;

 $y2 = $ymax - ($ystep/$facty * $graphcpu[$j]);
 $graphcpu[$j] = 0;

 if ($bargraph == 1) {
    print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
    print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
   if ($tridim == 1 && $y2 != $ymax) {

        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
        $y1plus = $ymax - $perspec;

        print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";

        print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
   }
 }

 if ($linegraph == 1) {
    $y1 = $ymax - ($ystep/$facty * $oldj);
    print FLY "line $oldx,$y1,$x2,$y2,$red[0],$green[0],$blue[0]\n" if ($oldj != 0);


    if ($fillgraph == 1) {
	$fx1 = ($x1+$x2)/2;
	$fx1 = $x2 if ($fx1 < ($x1+1.5));
	if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
	    print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
	    print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";

	    print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
	    print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
       }
    }
 }
 $oldj = $graphcpu[$j];
 $oldx = $x1;
 $graphcpu[$j] = 0;

 }

 $x1 = ($moy{$value}-1)*$xstep/$factx;

print FLY "line $x1,$ymax,$x1,0,$red[2],$green[2],$blue[2]\n";
$x1++;
print FLY "line $x1,$ymax,$x1,0,$red[2],$green[2],$blue[2]\n";

  $y2 = $ymax - ($ystep/$facty * $moycodeline{$value});

print FLY "line 0,$y2,$xmax,$y2,$red[2],$green[2],$blue[2]\n";
$y2++;
print FLY "line 0,$y2,$xmax,$y2,$red[2],$green[2],$blue[2]\n";


print FLY "transparent 200,200,200\n";
close (FLY);

&BuildFly("$tmpfly$vtmp","$path$dirgraph$dirsep$value$gifext");

### image pour les abscisses

$valuex = $value."x".$gifext;

$xlegend = "CPU (seconds)";

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,$xmax,$ydecal,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";

 for ($j=$xstep;$j<$xmax;$j+=$xstep) {
 $valstep = int($j * ($factx/$xstep));

 $hour = int($valstep/3600);
 $min = int(($valstep-($hour*3600))/60);
 $sec = $valstep-($hour*3600)-($min*60);

 $hour = "0".$hour if (length($hour) == 1);
 $min = "0".$min if (length($min) == 1);
 $sec = "0".$sec if (length($sec) == 1);
$valstep = "$hour:$min:$sec";

 $pos = ($ydecal - length($valstep)*9);
# $posy = $j-5;
 $posx = $j - length($valstep)*3;
# print FLY "line $xdecalm,$j,$xdecal,$j,0,0,0\n";
# print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 print FLY "line $j,0,$j,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$valstep\n";
 }
 
print FLY "transparent 200,200,200\n";
close (FLY);

&BuildFly("$tmpfly$vtmp","$path$dirgraph$dirsep$valuex");

### image pour les ordonnees

$valuey = $value."y".$gifext;

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,$xdecal,$ymax,200,200,200\n";
 $posy = $ymax - (($ymax/2)-(length("Lines")));
 print FLY "stringup 0,0,0,5,$posy,medium,Lines\n";

 for ($j=$ystep;$j<$ymax;$j+=$ystep) {
 $valstep = int(($ymax - $j) * ($facty/$ystep));
 $pos = ($xdecal - length($valstep)*9);
 $posy = $j-5;
 print FLY "line $xdecalm,$j,$xdecal,$j,0,0,0\n";
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }

print FLY "transparent 200,200,200\n";
close (FLY);

&BuildFly("$tmpfly$vtmp","$path$dirgraph$dirsep$valuey");

}

unlink("$tmpfly$vtmp");
}


&update_homepage;

# calculer le temps mis pour le calcul

$datesyst = &ctime(time);
$datesyst = POSIX::ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

$endrun = "$hour:$minute:$second";

($hour,$min,$sec) = &timetaken($startrun,$endrun);

$endtime = time();

$msg = "Computing took";
$msg .= " $hour h" if ($hour > 0);
$msg .= " $min min $sec sec\n\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET"); 
&output_log($msg);

if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y ne '') {
    print "</DIV>";;
    print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
    print "ToggleMenu('TOGGLE_$scriptname');\n";
    print "</script>\n";
}

&UpdateCSSMenu('Resources','CPU',"-","$dirlist$dirsepurl$filecpu$htmlext",1,0) if ($precision > 1);

&admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y eq '');

&StatusCompleted($scriptname,$status_script);

