#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                     MASTER SCRIPT                              #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 29/05/2014     #####
####                                                                #####
#########################################################################

# option available in crontab 
# 01 * * * * /home/domisse/public_html/w3perl/cron-w3perl.pl -c /home/domisse/public_html/w3perl/config-hplyot.pl
 
# customise your own value in the 'user launching configuration' part.

## TODO
# if exist -e

$verdate = "29/05/14";

$cwd = $0;
$cwd =~ s/(([^\\\/]+)$)//;
require "$cwd"."libw3perl.pl";

#$w3perlpath = "/home/httpd/cgi-bin/w3perl"; # do not remove
#$w3perlpath .= $dirsep;

#$dirw3perl = "w3perl";
#$cgipath_install = "c:/inetpub/wwwroot/cgi-bin/";
# The W3Perl CGI Path
#$w3perlpath = "$cgipath$dirw3perl$dirsep" if ($cgipath ne $pathinit && $cgipath ne '');
$w3perlpath = "$cgipath_install" if ($cgipath_install ne $pathinit && $cgipath_install ne '');
$w3perlpath = "$pathinit" if ($cgipath_install eq $pathinit || $cgipath_install eq '');

# Fix problem with Windows shortcut
$w3perlpath = &Windows_ShortPath($w3perlpath,0);

if ($opt_c ne '') {
    $configfile = &Windows_ShortPath($opt_c,0);
    $configfile = $w3perlpath.$configfile if ($configfile !~ /^\// && $conf_file !~ /^\w:/);
    $option = "-c ".$configfile;
}


#use Cwd;
#use POSIX qw( :sys_wait_h );

# init
$nb_proc = 1;
#$scriptname = "cron-w3perl.pl";
$process_to_launch = 0;

$startrun = "$hour:$minute:$second";
$daystart = $day;
$minutestart = $minute;
$hourstart = $hour;

$yesterday = &yesterday_date($day,$countmonth,$year);

$wday = (localtime)[6];

unlink("$path$output_log") if (-f "$path$output_log");


#print "$yesterday - $day,$countmonth,$year\n";

### choose which scripts you want to run (0 = off ; 1 = on)
# compatibilite avec les anciens fichiers de config

if ($actif_hour eq '') {
    $actif_real = 1;
    $actif_hour = 1;
    $actif_day = 1;
    $actif_week = 1;
    $actif_month = 1;
    $actif_year = 0;
    $actif_agent = 1;
    $actif_refer = 1;
    $actif_session = 1;
    $actif_error = 1;
    $actif_history = 1;
    $actif_url = 1;
}

# disable scripts if not web
if ($ftp_format == 1 || $mail_format == 1) {
    $actif_agent = 0;
    $actif_refer = 0;
    $actif_error = 0;
    $actif_history = 0;
    $actif_url = 0;
}

if ($squid_format == 1) {
    $actif_url = 0;
    $actif_error = 0;
}

if ($mail_format == 1) {
    $actif_session = 0;
}

#################################################################
###                      Test Windows                         ###
#################################################################

$car = substr($w3perlpath,1,1);
$nt = 1 if ($car eq ':');

#################################################################
###                      get local time                       ###
#################################################################

($a,$min,$hour,$d,$month,$year,$weekofday,$yearday) = localtime(time);

$month++;
$weekofyear = int($yearday/7)+1;

#################################################################
###            user launching configuration                   ###
#################################################################

### run cron-xxx.pl -h to see specific script options 
# compatibilite avec les anciens fichiers de config

if ($hour_launch eq '') {

### hour

$hour_launch = 1; # every hour

### day

$day_launch = 1; # every day
$day_launch_time = 0; # launch at midnight

### week

$week_launch = 1; # every day
$week_launch_time = 1; # launch at 1 am o'clock
$week_launch_day = 1; # launch on monday (0 = sunday, 6 = saturday)

### month

$month_launch = 1; # every day
$month_launch_time = 1; # launch at 1 am o'clock
$month_launch_day = 1; # launch on the first day of each month

### year

$year_launch = 1; # every day
$year_launch_time = 1; # launch at 1 am o'clock

### inc

$inc_launch = 1; # everyday
$inc_launch_time = 0; # launch at midnight

## refer

$refer_launch = 1; # everyday
$refer_launch_time = 0; # launch at 0 o'clock

## agent

$agent_launch = 1; # everyday
$agent_launch_time = 0; # launch at 0 am o'clock

## error

$error_launch = 1; # everyday
$error_launch_time = 1; # launch at 1 am o'clock

## session

$session_launch = 1; # every 5 days
$session_launch_time = 0; # launch at 0 o'clock

## url

#$option_url = "";
#$url_launch = 5; # every 5 days
#$url_launch_time = 1; # launch at 1 o'clock

## history

$history_launch = 1; # everyday
$history_launch_time = 2; # launch at 2 am o'clock
}

#################################################################
###            checking everything could be launch            ###
#################################################################

if ($hour_launch != 1) {
&warning("cron-day",$day_launch_time);
&warning("cron-week",$week_launch_time);
&warning("cron-month",$month_launch_time);
&warning("cron-year",$year_launch_time);
&warning("cron-inc",$inc_launch_time);
&warning("cron-refer",$refer_launch_time);
&warning("cron-agent",$agent_launch_time);
&warning("cron-error",$error_launch_time);
&warning("cron-session",$session_launch_time);
#&warning("cron-url",$url_launch_time);
&warning("cron-history",$history_launch_time);
}

#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h == 1) {
      print STDOUT "Usage : \n";
      print STDOUT "        -a          : reset all your stats\n";
      print STDOUT "        -b          : show crontab\n";
      print STDOUT "        -c <file>   : load configuration file\n";
      print STDOUT "        -d <nbdays> : number of days to scan\n";      
      print STDOUT "        -e          : incremental run for all scripts\n";
#      print STDOUT "        -u        : reset all your stats (manual use)\n";
      print STDOUT "        -s <date>   : starting date (dd/Mmm/yyyy)\n";
      print STDOUT "        -p <number> : precision (1=low; 2=medium (no time resolution); 3=default; 4=high)\n";
      print STDOUT "        -r <date>   : ending date (dd/Mmm/yyyy)\n";
      print STDOUT "        -v          : version\n";
      print STDOUT "        -x          : show default value for flag options\n";
      print STDOUT "\n";
      exit;
}

if ($opt_x == 1) {
      print STDOUT "Default : \n";
      print STDOUT "          -c : $configfile\n";
      print STDOUT "          -a : ";
      &id($opt_a);
      print STDOUT "          -d <nbdays>   : all\n";
      print STDOUT "          -e : ";
      &id($opt_e);      
      print STDOUT "          -p : 3";
#      &id($opt_p);      
      print STDOUT "          -s <date>     : $firstjour\n";
      print STDOUT "          -r <date>     : $yesterday\n";
#      print STDOUT "          -u : ";
#      &id($opt_u);
      print STDOUT "          -v : $version\n";
      exit;
}

if ($opt_v == 1) {
      print "cron-w3perl.pl version $version $verdate\n";
      exit;
}

if ($opt_d ne '') {
    $option .= " -d $opt_d";
    $opt_a = 1;
}

if ($opt_p ne '') {
    $option .= " -p $opt_p";
}

if ($opt_s ne '') {
    if ($opt_s !~ /(\d{2})\/(\w{3})\/(\d{4})/) {
	$msg = "Not a valid starting date format (valid format is for example 02/May/1995)\n";
	&error_exit($msg);
    } else {
	if ($1 < 1 || $1 > 31) {
	    $msg = "Day should be between 1 and 31 !\n";
	    &error_exit($msg);
	}

	$lettermonth = $2;
	$month = $month_equiv{$lettermonth};
	if ($month < 1 || $month > 12) {
	    $msg = "Month should be between Jan and Dec !\n";
	    &error_exit($msg);
	}

	if ($fullyear < $3) {
	    $msg = "Year should be less than the current date \n";
	    &error_exit($msg);
	}

	$nbstartday = &nbday($opt_s);

	$option .= " -s $opt_s";
	$opt_a = 1;
    }
}

if ($opt_r ne '') {
    if ($opt_r !~ /(\d{2})\/(\w{3})\/(\d{4})/) {
	$msg = "Not a valid ending date format (valid format is for example 02/May/1995)\n";
	&error_exit($msg);
    } else {
	if ($1 < 1 || $1 > 31) {
	    $msg = "Day should be between 1 and 31 !\n";
	    &error_exit($msg);
	}

	$tmp = $month_equiv{$2};
	if ($tmp < 1 || $tmp > 12) {
	    $msg = "Month should be between Jan and Dec !\n";
	    &error_exit($msg);
	}

	if ($fullyear < $3) {
	    $msg = "Year should be less than the current date !\n";
	    &error_exit($msg);
	}

	$nbstopday = &nbday($opt_r);
	# bypass cron-hour.pl and cron-hour.pl -n si $opt_r != today
	$option .= " -r $opt_r";
	$bypass_hour = 1;
	$opt_a = 1;
    }   
}

#bypass cron-week, month si intervalle <

if ($opt_s && $opt_r) {
    if ($nbstopday < $nbstartday) {
	$msg = "Ending date should be later than the starting date !\n";
	&error_exit($msg);
    }
    if ($opt_d ne '') {
	$msg = "You cannot use both two different date selection\n";
	&error_exit($msg);
    }
}
 

if ($opt_a == 1 && $opt_e == 1) {
    &error_exit("> Cannot run initialisation and update together ! Choose one mode : a for init, e for update");
    exit;
}

if ($opt_b == 1) {
    print STDOUT "Crontab :\n";

    # hour

    print STDOUT "0 ";

    if ($actif_hour == 1) {
	if ($hour_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=24;$k++) {
		$cday .= "$k," if (($k/$hour_launch) == int($k/$hour_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * * ".$w3perlpath."cron-hour$plext";
	print STDOUT " $option_hour" if ($option_hour ne '');
	print STDOUT " $option" if ($option ne '');
	print STDOUT "\n";
    }

    # day

    if ($actif_day == 1) {
	print STDOUT "0 $day_launch_time ";
	if ($day_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=31;$k++) {
		$cday .= "$k," if (($k/$day_launch) == int($k/$day_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * ".$w3perlpath."cron-day$plext";
	print STDOUT " $option_day" if ($option_day ne '');
	print STDOUT " $option" if ($option ne '');
	print STDOUT "\n";
    }

    # week
    
    if ($actif_week == 1) {
	print STDOUT "0 $week_launch_time ";
	if ($week_launch == 1) {
	    print STDOUT "*";
	} else {
	    $begin = $day+($week_launch_day-$wday);
	    $begin = $begin - (7*int($begin/7));
	    $cday = "(";
	    for ($k=$begin;$k<=31;$k+=7*$week_launch) {
		$cday .= "$k,";
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * $week_launch_day ".$w3perlpath."cron-week$plext";
	print STDOUT " $option_week" if ($option_week ne '');
	print STDOUT " $option" if ($option ne '');
	print STDOUT "\n";
    }

    # month

    if ($actif_month == 1) {    
	print STDOUT "0 $month_launch_time $month_launch_day * * ".$w3perlpath."cron-month$plext";
	print STDOUT " $option_month" if ($option_month ne '');
	print STDOUT " $option" if ($option ne '');
	print STDOUT "\n";
    }

    # year

    if ($actif_year == 1) {    
	print STDOUT "0 $year_launch_time $year_launch * * ".$w3perlpath."cron-year$plext";
	print STDOUT " $option_year" if ($option_year ne '');
	print STDOUT " $option" if ($option ne '');
	print STDOUT "\n";
    }

    # inc
    
    print STDOUT "0 $inc_launch_time ";
    if ($inc_launch == 1) {
    print STDOUT "*";
    } else {
    $cday = "(";
    for ($k=2;$k<=31;$k++) {
    $cday .= "$k," if (($k/$inc_launch) == int($k/$inc_launch));
    }
    chop($cday);
    $cday .= ")";
    print STDOUT "$cday";
    }
    print STDOUT " * * ".$w3perlpath."cron-inc$plext";
    print STDOUT " $option_inc" if ($option_inc ne '');
    print STDOUT " $option" if ($option ne '');
    print STDOUT "\n";

    # refer

    if ($actif_refer == 1) {
	print STDOUT "0 $refer_launch_time ";
	if ($refer_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=31;$k++) {
		$cday .= "$k," if (($k/$refer_launch) == int($k/$refer_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * ".$w3perlpath."cron-refer$plext";
	print STDOUT " $option_refer" if ($option_refer ne '');
	print STDOUT " $option" if ($option ne '');
	print STDOUT "\n";
    }
 
    # agent

    if ($actif_agent == 1) {
	print STDOUT "0 $agent_launch_time ";
	if ($agent_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=31;$k++) {
		$cday .= "$k," if (($k/$agent_launch) == int($k/$agent_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * ".$w3perlpath."cron-agent$plext";
	print STDOUT " $option_agent" if ($option_agent ne '');
	print STDOUT " $option" if ($option ne '');
	print STDOUT "\n";
    }

    # error

    if ($actif_error == 1) {
	print STDOUT "0 $error_launch_time ";
	if ($error_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=31;$k++) {
		$cday .= "$k," if (($k/$error_launch) == int($k/$error_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * ".$w3perlpath."cron-error$plext";
	print STDOUT " $option_error" if ($option_error ne '');
	print STDOUT " $option" if ($option ne '');
	print STDOUT "\n";
    }

    # session

    if ($actif_session == 1) {
	print STDOUT "0 $session_launch_time ";
	if ($session_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=31;$k++) {
		$cday .= "$k," if (($k/$session_launch) == int($k/$session_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * ".$w3perlpath."cron-session$plext";
	print STDOUT " $option_session" if ($option_session ne '');
	print STDOUT " $option" if ($option ne '');
	print STDOUT "\n";
    }

    # url

    if ($actif_url == 1) {
	print STDOUT "0 $url_launch_time ";
	if ($url_launch == 1) {
	    print STDOUT "*";
	} else {
	    $cday = "(";
	    for ($k=2;$k<=31;$k++) {
		$cday .= "$k," if (($k/$url_launch) == int($k/$url_launch));
	    }
	    chop($cday);
	    $cday .= ")";
	    print STDOUT "$cday";
	}
	print STDOUT " * * ".$w3perlpath."cron-url$plext";
	print STDOUT " $option_url" if ($option_url ne '');
	print STDOUT " $option" if ($option ne '');
	print STDOUT "\n";
    }
            
    exit;
}


if ($opt_p ne '') {
    if ($opt_p == 1) {
	$actif_real = 0;
	$actif_hour = 0;
	$actif_day = 0;
	$actif_week = 0;
	$actif_month = 0;
	$actif_year = 0;
	$actif_refer = 0;
	$actif_agent = 0;
	$actif_session = 0;
	$actif_history = 0;
	$actif_heatmap = 0;
    }

}


#open(OUTPUT_LOG,">$path$output_log") || die "Unable to open the output log $path$output_log";

#if ($ENV{'REQUEST_METHOD'} ne "GET") {
#print STDOUT "\nAdd the following line in your crontab :\n";
#print STDOUT "0 ";

#if ($hour_launch == 1) {
#print STDOUT "*";
#} else {
#   $cday = "(";
#   for ($k=2;$k<=24;$k++) {
#      $cday .= "$k," if (($k/$hour_launch) == int($k/$hour_launch));
#   }
#   chop($cday);
#   $cday .= ")";
#   print STDOUT "$cday";
#   }

#print STDOUT " * * * ".$w3perlpath."cron-w3perl$plext $option\n";
#print STDOUT "where 0 is the minute of the hour, change it to whatever you want. (0-59)";
#print STDOUT "\n(if you are using w3perl for several web, better to use different minute launch time to avoid CPU increase)\n\n";
#}

# check output dir exist, if not => set flag -a on

if ($opt_a == 0) {
    open(FILE,$conf_file) || die "Unable to open the configuration file $conf_file";
    while (<FILE>) {
	($tmp,$pathoutput) = split(/\s=\s/) if (/^\$path\s=\s/); 
#	($tmp,$defaulthomepage) = split(/\s=\s/) if (/^\$defaulthomepage\s=\s/); 
    }
    close(FILE);
    ($tmp,$pathoutput) = split(/\"/,$pathoutput);
#    ($tmp,$defaulthomepage) = split(/\"/,$defaulthomepage);
#    &error_exit("> No default homepage defined") if ($defaulthomepage eq '');
    if (!(-f "$pathoutput$menu")) {
	print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg = "No report found. Switching to initialization.\n";
	&output_log($msg);
	print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
#    &MakeDirectories;
	$opt_a = 1;
    }
}

#################################################################
###       reset for first use (don't use in crontab !)        ###
#################################################################

if ($opt_a != 0) {

    unlink("$path$dirinc$dirsep$menuheader") if (-f "$path$dirinc$dirsep$menuheader");

    if ($actif_url == 1) {
	$string = $w3perlpath."cron-url".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_url if ($option_url ne '');
	push(@list,$string);
	push(@script_name,"Document");
    }

    $string = $w3perlpath."cron-pages".$plext;

    if (!(-f $string)) {
	print "Script $string not found\n";
	exit;
    }

#    $string .= "\"" if ($space_found == 1);
    $string .= " ".$option_pages if ($option_pages ne '');
    push(@list,$string);
    push(@script_name,"Main");

    if ($actif_agent == 1) {
	$option_agent .= " -b";
	$string = $w3perlpath."cron-agent".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_agent if ($option_agent ne '');
	push(@list,$string);
	push(@script_name,"Agent");
    }

    if ($actif_refer == 1) {
	$option_refer .= " -b";
	$string = $w3perlpath."cron-refer".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_refer if ($option_refer ne '');
	push(@list,$string);
	push(@script_name,"Referer");
    }


    if ($actif_hour == 1) {
	$option_day_hour = "-b";
	$string = $w3perlpath."cron-hour".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_hour if ($option_hour ne '');
	$string .= " ".$option_day_hour;
	push(@list,$string);
	push(@script_name,"Hourly (for each day)");
#	$process_to_launch++;
    }

    if ($bypass_hour == 0) {
    if ($actif_hour == 1) {
	$option_hour .= "";
	$string = $w3perlpath."cron-hour".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_hour if ($option_hour ne '');
	push(@list,$string);
	push(@script_name,"Hourly");
    }


    if ($actif_real == 1) {
	$option_real .= " -n";
	$string = $w3perlpath."cron-hour".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_real if ($option_real ne '');
	push(@list,$string);
	push(@script_name,"Real time");
    }
    }

    if ($actif_week == 1) {
	$option_week .= " -b";
	$string = $w3perlpath."cron-week".$plext;      
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_week if ($option_week ne '');
	push(@list,$string);
	push(@script_name,"Weekly");
    }


    if ($actif_month == 1) {
	$option_month = "-b";
	$string = $w3perlpath."cron-month".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_month if ($option_month ne '');
	push(@list,$string);
	push(@script_name,"Monthly");
    }


    if ($actif_year == 1) {
	$string = $w3perlpath."cron-year".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_year if ($option_year ne '');
	push(@list,$string);
	push(@script_name,"Yearly");
    }

    if ($actif_session == 1) {
	$option_session .= ""; 
#	$option_session = " -u" if ($exclude_robot == 1);
	$string = $w3perlpath."cron-session".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_session if ($option_session ne '');
	push(@list,$string);
	push(@script_name,"Session");
    }

    if ($actif_day == 1) {
	$string = $w3perlpath."cron-day".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_day if ($option_day ne '');
	push(@list,$string);
	push(@script_name,"Daily");
    }

    if ($actif_error == 1) {
	$option_error .= " -b";
	$string = $w3perlpath."cron-error".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_error if ($option_error ne '');
	push(@list,$string);
	push(@script_name,"Error");
    }

    if ($actif_history == 1) {
#	$option_history .= " -b";
	$string = $w3perlpath."cron-history".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_history if ($option_history ne '');
	push(@list,$string);
	push(@script_name,"CPU");
    }

    $string = $w3perlpath."cron-pages".$plext;
#    $string .= "\"" if ($space_found == 1);
    $string .= " -u";
    push(@list,$string);
    push(@script_name,"Updating homepage");

    print "<P><I>Move your mouse over script's line to view more details</I><BR><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    print "<B>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "<STRONG CLASS=\"launch_main\">\n " if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg = " *** Initializing stats using W3Perl $version ($today) *** \n";
    &output_log($msg);
    print "</STRONG></B><BR><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
# Retrieve external log
    &retrieve_external_logfile($fileroot,$remote_host_log) if ($retrieve_external_log == 1);

    $contentype = "-y -w";

  BOUCLE:
    for ($i=0;$i<=$#list;$i++) {
	for ($k=0;$k<$nb_proc;$k++) {
	    
	    $l= $i+$k;

	    print "<STRONG CLASS=\"launch_title\">\n " if ($ENV{'REQUEST_METHOD'} eq "GET");
	    $timesec = time;
#	&get_time($timesec);
	    ($date,$datehour,$datemisc) = &get_time($timesec);
	    $today = $date." ".$datehour;

	    ($string_script) = split(/\s/,$list[$l]) if ($list[$l] !~ /^\"/);
	    ($tmp,$string_script) = split(/\"/,$list[$l]) if ($list[$l] =~ /^\"/);
	    $string_script =~ s/\"//g;
#	$string_script =~ s/$w3perlpath//;
	    $string_script = substr($string_script,rindex($string_script,'/')+1,length($string_script));
	    if ($string_script eq "cron-hour.pl") {
		$string_script .= "1" if ($list[$l] =~ /\s\-n/);
		$string_script .= "2" if ($list[$l] =~ /\s\-b/);
	    }
	    if ($string_script eq "cron-pages.pl") {
		$string_script .= "1" if ($list[$l] =~ /\s\-u/);
	    }
	    $tmp_status = "statut".$string_script;
	    
	    print "<A HREF=\"javascript:ToggleMenu('TOGGLE_$string_script')\" OnMouseOver=\"javascript:ToggleMenu('TOGGLE_$string_script')\" TITLE=\"Show more details\">>&nbsp;" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    $msg = "=== $script_name[$l] stats ===\n";
	    &output_log($msg);
	    print "</A>&nbsp;:&nbsp;</STRONG>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    
	    print "<STRONG ID=\"$tmp_status\"></STRONG>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    print "<DIV CLASS=\"launch_script\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    $msg = "Launching $list[$l] $option ($today)\n";
	    &output_log($msg);
	    print "</DIV>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
	    
	    $cmd = "$list[$l] $contentype $option";

	    if (!defined($pid = fork())) {
		# fork returned undef, so failed
		die "Cannot fork: $!";
	    } elsif ($pid == 0) {
		# fork returned 0, so this branch is child
		exec "$list[$i] $contentype $option";
		# if exec fails, fall through to the next statement
		die $msg = ">> can't exec : Make sure cmd.exe can be run by IIS User (Internet Guest Account)" if ($nt == 1);
	    } else {
		# fork returned 0 nor undef
		# so this branch is parent
		waitpid($pid, 0);
		&check_cmd_status($?);
	    }
	    
	}
    }

#    $datesyst = &ctime(time);
    $datesyst = POSIX::ctime(time);
    ($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
    ($hour,$minute,$second) = split(/:/,$hourdate);

    $dayend = $day;

    $endrun = "$hour:$minute:$second";

    if ($daystart != $dayend) {

	$tmpstart = 1440-(($hourstart*60)+$minutestart);
	$tmpend = ($hour*60)+$minute;
	$hour = ($dayend-$daystart-1)*24;

	$tmpmin = $tmpstart+$tmpend;
	$hour = int($tmpmin/60);
    
	$min = $tmpmin-($hour*60);
    } else {
	($hour,$min,$sec) = &timetaken($startrun,$endrun);
    }

    if ($fatal == 0) {
	print "<BR><B>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg = "Stats computed in";

	$msg .= " $hour h" if ($hour > 0);
	$msg .= " $min min";
	$msg .= " $sec sec" if ($daystart == $dayend);
	$msg .= "</B>\n<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg .= "\n\n";

	$msg .= "Initialization completed.\n";
	$msg .= "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg .= "In order to update your stats, wait tomorrow and use this script with the -e flag.\n";
	$msg .= "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg .= "Updating main reports need to be done only once a day\n\n";
	&output_log($msg);

	&admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET");
#	print "<P><I>You can now check the output stats, please <A HREF=\"javascript:history.back()\">go back</A> to the admin homepage</I>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
    } else {

    }
    exit(0);
}

sub run_and_check_exit_daemon {
#  local $SIG{'CHLD'}; # desactivate CHLD catching to access $?: problems with SIGQUIT
#  my ($curr_filename,@tmp) = @_;
  my ($command) = @_;
#  my $command = join(' ',@tmp);
#  print "$curr_filename - $command\n";
#  print "Running $command\n";
  system($command);
#  print "Code : $? - WIFEXITED($?) - WEXITSTATUS($?) - WIFSIGNALED($?)\n<P>";
  if (WIFEXITED($?)) { # child process exited normally
#      print "AA\n<P>";
      # exit status of the child not = 0
    if (WEXITSTATUS($?) != 0) {
#      print "AA1\n<P>";
#        my $new_filename = $curr_filename;
#        $new_filename =~ s/$curr_ext$/$err_ext/;
#        print "rename $curr_filename, $new_filename\n" if $verbose;
#        rename $curr_filename, $new_filename;
#       print "ERROR: the following command returned the non zero value ".WEXITSTATUS($?).":\n$command\n";
       die ("ERROR: the following command returned the non zero value ".WEXITSTATUS($?).":\n$command\n");
    }
  } else {
#      print "BB\n<P>";
    #  child process terminated because of a signal
    if (WIFSIGNALED($?)) {
#      print "BB1\n<P>";
#        my $new_filename = $curr_filename;
#        $new_filename =~ s/$curr_ext$/$err_ext/;
#        print "rename $curr_filename, $new_filename\n" if $verbose;
#        rename $curr_filename, $new_filename;
        die ("ERROR: the following command exited because of signal ".WTERMSIG($?).":\n$command\n");
    }
#    my $new_filename = $curr_filename;
#   $new_filename =~ s/$curr_ext$/$err_ext/;
#    print "rename $curr_filename, $new_filename\n" if $verbose;
#    rename $curr_filename, $new_filename;
#      print "BB2\n<P>";
#    print "ERROR: the following command failed to exit normally:\n$command\n";
    die ("ERROR: the following command failed to exit normally:\n$command\n");
  }
}

#################################################################
###                    force incremental fork                 ###
#################################################################

if ($opt_e != 0) {

    # Check first
    $lockfile = $path.$dirtmp.$dirsep."lock-ini";
    if (-f $lockfile) {
	$lockfile_date = -M $lockfile;
	if ($lockfile_date < 1) {
	    $tmp = int($lockfile_date*24*60);
	    open(LOCKFILE,"$lockfile");
	    $tmp2 = <LOCKFILE>;
	    close(LOCKFILE);
	    chomp($tmp2);
	    if ($tmp2 eq $today) {
		$msg = "\nLockfile found : $lockfile\n";
		$msg .= "You need to wait tomorrow in order to run incremental stats\n";
		if ($tmp >= 60) {
		    $tmp2 = int($tmp/60);
		    $tmp = $tmp-($tmp2*60);
		    $msg .= "Last use : $tmp2 h ";
		    $msg .= "$tmp min " if ($tmp != 0);
		    $msg.= "ago\n";
		} else {
		    $msg .= "Last use : $tmp minutes ago\n";
		}
		&error_exit($msg);
	    }
	} else {
	    unlink ("$lockfile");
	}
    }

    $lockfile = $path.$dirtmp.$dirsep."lock-inc";
    # test if lockfile there and old
    if (-f $lockfile) {
	$lockfile_date = -M $lockfile;
	if ($lockfile_date < 1) {
	    $tmp = int($lockfile_date*24*60);
	    open(LOCKFILE,"$lockfile");
	    $tmp2 = <LOCKFILE>;
	    close(LOCKFILE);
	    chomp($tmp2);
	    if ($tmp2 eq $today) {
		$msg = "\nLockfile found : $lockfile\n";
		$msg .= "This script is designed to be run once a day\n";
		if ($tmp >= 60) {
		    $tmp2 = int($tmp/60);
		    $tmp = $tmp-($tmp2*60);
		    $msg .= "Last use : $tmp2 h ";
		    $msg .= "$tmp min " if ($tmp != 0);
		    $msg.= "ago\n";
		} else {
		    $msg .= "Last use : $tmp minutes ago\n";
		}
#		&error_exit($msg,1);
		&error_exit($msg);
	    }
	}
    }


    ###	Find number of days to scan for hourly -j

    open(GENERAL,"$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile");
	while (<GENERAL>) {
	    ($tmp1,$tmp2,$tmp3) = split('\s+');
	}	
    close GENERAL;
    $day_to_scan = "$tmp1/$tmp2/$tmp3";
    $yday = &nbday($day_to_scan);

    $count = $ydaytoday-$yday-1;

    ###

    if ($actif_url == 1) {
	&daily("cron-url",$option_url,$url_launch,$url_launch_time,"Document");
    }

    if ($actif_refer == 1) {
	$string = $w3perlpath."cron-refer".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_refer if ($option_refer ne '');
	push(@list,$string);
	$process_to_launch++;
	push(@script_name,"Referer");
    }

    if ($actif_agent == 1) {
	$string = $w3perlpath."cron-agent".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_agent if ($option_agent ne '');
	push(@list,$string);
	$process_to_launch++;
	push(@script_name,"Agent");
    }

    $string = $w3perlpath."cron-inc".$plext;
#    $string .= "\"" if ($space_found == 1);

    if (!(-f $string)) {
	print "Script $string not found\n";
	exit;
    }

    $string .= " ".$option_inc if ($option_inc ne '');
    push(@list,$string);
    push(@script_name,"Main");
    $process_to_launch++;


    if ($actif_hour == 1) {

	for ($i=$count;$i>0;$i--) {
	    $day_to_scan = &date_intervalle($today,-$i);
#	    print "LAUNCH hourly $day_to_scan\n";
	    $day_to_scan =~ s/\s/\//g;
	    $option_day_hour = "-j $day_to_scan";
	    $string = $w3perlpath."cron-hour".$plext;
	    $string .= " ".$option_hour if ($option_hour ne '');
	    $string .= " ".$option_day_hour;
	    push(@list,$string);
	    $process_to_launch++;
	    push(@script_name,"Hourly ($day_to_scan)");
	}

#	$option_day_hour = "-j $yesterday";
#	$string = $w3perlpath."cron-hour".$plext;
#	$string .= " ".$option_hour if ($option_hour ne '');
#	$string .= " ".$option_day_hour;
#	push(@list,$string);
#	$process_to_launch++;
#	push(@script_name,"Hourly ($yesterday)");
    }

    if ($actif_hour == 1) {
	$string = $w3perlpath."cron-hour".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_hour if ($option_hour ne '');
	push(@list,$string);
	$process_to_launch++;
	push(@script_name,"Hourly");
    }

    if ($actif_real == 1) {
	$option_real .= " -n";
	$string = $w3perlpath."cron-hour".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_real if ($option_real ne '');
	push(@list,$string);
	$process_to_launch++;
	push(@script_name,"Real time");
    }

    if ($actif_week == 1) {
	$string = $w3perlpath."cron-week".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_week if ($option_week ne '');
	push(@list,$string);
	$process_to_launch++;
	push(@script_name,"Weekly");
    }

    if ($actif_month == 1) {
	$string = $w3perlpath."cron-month".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_month if ($option_month ne '');
	if ((($month/$month_launch) == int($month/$month_launch)) && ($day == $month_launch_day)) {
	    push(@list,$string);
	    $process_to_launch++;
	    push(@script_name,"Monthly");
	}
    }

    if ($actif_year == 1) {
	$string = $w3perlpath."cron-year".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_year if ($option_year ne '');
	push(@list,$string);
	$process_to_launch++;
	push(@script_name,"Yearly");
    }

    if ($actif_session == 1) {
#	$option_session = " -u";
	$string = $w3perlpath."cron-session".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_session if ($option_session ne '');
	push(@list,$string);
	$process_to_launch++;
	$option_session = "";
	push(@script_name,"Session");
    }

    if ($actif_day == 1) {
	$string = $w3perlpath."cron-day".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_day if ($option_day ne '');
	push(@list,$string);
	$process_to_launch++;
	push(@script_name,"Daily");
    }

    if ($actif_error == 1) {
	$string = $w3perlpath."cron-error".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_error if ($option_error ne '');
	push(@list,$string);
	$process_to_launch++;
	push(@script_name,"Error");
    }

    if ($actif_history == 1) {
	$string = $w3perlpath."cron-history".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_history if ($option_history ne '');
	push(@list,$string);
	$process_to_launch++;
	push(@script_name,"CPU");
    }

    $string = $w3perlpath."cron-pages".$plext;
#    $string .= "\"" if ($space_found == 1);
    $string .= " -u";
    push(@list,$string);
    $process_to_launch++;
    push(@script_name,"Updating homepage");

}

#################################################################
###         adding the script in the fork list                ###
#################################################################

if ($opt_e != 1) {

    &daily("cron-url",$option_url,$url_launch,$url_launch_time,"Document") if ($actif_url == 1);
    &daily("cron-refer",$option_refer,$refer_launch,$refer_launch_time,"Referer") if ($actif_refer == 1);
    &daily("cron-agent",$option_agent,$agent_launch,$agent_launch_time,"Agent") if ($actif_agent == 1);
    &daily("cron-session",$option_session,$session_launch,$session_launch_time,"Session") if ($actif_session == 1);

### inc

    $string = "cron-inc";
    &daily($string,$option_inc,$inc_launch,$inc_launch_time,"Main");

### real stats

    if ($actif_real == 1) {
	$option_real .= " -n";
#	$string = $w3perlpath."cron-hour".$plext." ".$option_real;        
	$string = $w3perlpath."cron-hour".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_real if ($option_real ne '');
	if (($hour/$hour_launch) == int($hour/$hour_launch)) {
	    push(@list,$string) ;
	    $process_to_launch++;
	}
    }

### hour 

    if ($actif_hour == 1) {
	$string = $w3perlpath."cron-hour".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_hour if ($option_hour ne '');
	if (($hour/$hour_launch) == int($hour/$hour_launch)) {
	    push(@list,$string) ;
	    $process_to_launch++;
	}
    }

### week

    if ($actif_week == 1) {
	$string = $w3perlpath."cron-week".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_week if ($option_week ne '');
	if ((($weekofyear/$week_launch) == int($weekofyear/$week_launch)) && ($weekofday == $week_launch_day) && ($hour == $week_launch_time)) {
	    push(@list,$string);
	    $process_to_launch++;
	}
    }

### month

    if ($actif_month == 1) {
	$string = $w3perlpath."cron-month".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_month if ($option_month ne '');
	if ((($month/$month_launch) == int($month/$month_launch)) && ($day == $month_launch_day) && ($hour == $month_launch_time)) {
	    push(@list,$string);
	    $process_to_launch++;
	}
    }

### year

    if ($actif_year == 1) {
	$string = $w3perlpath."cron-year".$plext;
#	$string .= "\"" if ($space_found == 1);
	$string .= " ".$option_year if ($option_year ne '');
	if ((($weekofyear/$year_launch) == int($weekofyear/$year_launch)) && ($hour == $year_launch_time)) {
	    push(@list,$string);
	    $process_to_launch++;
	}
    }

### make a comment in front of the line you don't want to run

    &daily("cron-error",$option_error,$error_launch,$error_launch_time,"Error") if ($actif_error == 1);
    &daily("cron-history",$option_history,$history_launch,$history_launch_time,"CPU") if ($actif_history == 1);

### day 

    if ($actif_day == 1) {
	$string = "cron-day";
	&daily($string,$option_day,$day_launch,$day_launch_time,"Daily");
    }
}


#################################################################
###              main loop to fork processes                  ###
#################################################################

#$timesec = time;
#&get_time($timesec);
#$today = $date." ".$datehour;

print "<P><I>Move your mouse over script's line to view more details</I><BR><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");


print "<B>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "<STRONG CLASS=\"launch_main\">\n " if ($ENV{'REQUEST_METHOD'} eq "GET");
$msg = " *** Updating stats using W3Perl $version ($today) *** \n";
&output_log($msg);
print "</STRONG></B><BR><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

# Retrieve external log
&retrieve_external_logfile($fileroot,$remote_host_log) if ($retrieve_external_log == 1);

$contentype = "-y -w";

for ($i=0;$i<$process_to_launch;$i+=$nb_proc) {
    for ($k=0;$k<$nb_proc;$k++) {
	    
	$l= $i+$k;

#	print "<P>\n " if ($l == 0 && $ENV{'REQUEST_METHOD'} eq "GET");
	print "<STRONG CLASS=\"launch_title\">\n " if ($ENV{'REQUEST_METHOD'} eq "GET");
	$timesec = time;
#	&get_time($timesec);
	($date,$datehour,$datemisc) = &get_time($timesec);
	$today = $date." ".$datehour;
	($string_script) = split(/\s/,$list[$l]) if ($list[$l] !~ /^\"/);
	($tmp,$string_script) = split(/\"/,$list[$l]) if ($list[$l] =~ /^\"/);
	$string_script =~ s/\"//g;
#	$string_script =~ s/$w3perlpath//;
	$string_script = substr($string_script,rindex($string_script,'/')+1,length($string_script));
	if ($string_script eq "cron-hour.pl") {
	    $string_script .= "1" if ($list[$l] =~ /\s\-n/);
	    $string_script .= "2" if ($list[$l] =~ /\s\-b/);
	}
	if ($string_script eq "cron-pages.pl") {
	    $string_script .= "1" if ($list[$l] =~ /\s\-u/);
	}
	$tmp_status = "statut".$string_script;
#	print "<A HREF=\"javascript:ToggleMenu('TOGGLE_$string_script')\" TITLE=\"Show more details\">></A> " if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "<A HREF=\"javascript:ToggleMenu('TOGGLE_$string_script')\" OnMouseOver=\"javascript:ToggleMenu('TOGGLE_$string_script')\" TITLE=\"Show more details\">>&nbsp;" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg = "=== $script_name[$l] stats ===\n";
	&output_log($msg);
	print "</A>&nbsp;:&nbsp;</STRONG>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "<STRONG ID=\"$tmp_status\"></STRONG>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "<DIV CLASS=\"launch_script\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg = "Launching $list[$l] $option ($today)\n";
	&output_log($msg);
	print "</DIV>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");

	$cmd = "$list[$l] $contentype $option";

	if (!defined($pid = fork())) {
	    # fork returned undef, so failed
	    die "Cannot fork: $!";
	} elsif ($pid == 0) {
	    # fork returned 0, so this branch is child
	    exec "$list[$i] $contentype $option";
	    # if exec fails, fall through to the next statement
	    die "can't exec $cmd: $!";
	} else {
	    # fork returned 0 nor undef
	    # so this branch is parent
	    waitpid($pid, 0);
	    &check_cmd_status($?);
	}

#	$commit = system($cmd);
#	if ($commit != 0) {
#	    print "<P>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
#	    &error_exit("> Fatal error, stats aborted : Error $? : $!");
#	    print "</TD>\n</TR>\n</TABLE>\n</BODY>\n</HTML>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
#	    $fatal = 1;
#	    last BOUCLE;
#	} else {
#	    if ($ENV{'REQUEST_METHOD'} eq "GET") {
		# Opening status.txt
#		$tmp = $path."status.txt";
#		$msg = '';
#		open(FILE,"$tmp");
#		$line = (<FILE>);
#		chop($line);
#		($a,$b,$c) = split(/\t/,$line);
#		close(FILE);
#		$msg = "<STRONG CLASS=\'status_ok\'>OK</STRONG>" if ($c == 0);
#		$msg = "<STRONG CLASS=\'warning_msg\'>Warning</STRONG>" if ($c == 1);
#		$msg = "<STRONG CLASS=\'error_exit\'>Error</STRONG>" if ($c == 2);
#		print "<script language=\"javascript\">\n";
#		print "document.getElementById('$tmp_status').innerHTML = \"$msg\";\n";
#		print "</script>\n";
#	    }
#	}
    }
}

#$datesyst = &ctime(time);
$datesyst = POSIX::ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

$dayend = $day;

$endrun = "$hour:$minute:$second";

if ($daystart != $dayend) {
    
    $tmpstart = 1440-(($hourstart*60)+$minutestart);
    $tmpend = ($hour*60)+$minute;
    $hour = ($dayend-$daystart-1)*24;

    $tmpmin = $tmpstart+$tmpend;
    $hour = int($tmpmin/60);
    
    $min = $tmpmin-($hour*60);
} else {
    ($hour,$min,$sec) = &timetaken($startrun,$endrun);
}

if ($fatal == 0) {
    print "<BR><B>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg = "Stats computed in";
	    
    $msg .= " $hour h" if ($hour > 0);
    $msg .= " $min min";
    $msg .= " $sec sec" if ($daystart == $dayend);

    &output_log($msg);
    print "</B>\n<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "\n\n";
    
    &admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET");
} else {
    
}
#exit(0);

#close(OUTPUT_LOG);

exit;

#----------------------------------------------------
# create_fork
#sub create_fork {
#    local($string) = @_;
#    $cron = fork;
#    unless ($cron) {
#	exec "$string";
#	exit 0;	
#    } elsif ($cron != 0) {
#	$pid = wait;
#    }
#}

#----------------------------------------------------
# daily
sub daily {
    local($string,$option,$launch,$launch_time,$script_name) = @_;

#    $string = $w3perlpath.$string.$plext." ".$option;        
    $string = $w3perlpath.$string.$plext;        
#    $string_name .= "\"" if ($space_found == 1);
    $string_name .= " ".$option if ($option ne '');

    if (($day/$launch) == int($day/$launch) && $hour == $launch_time) {
	push(@list,$string);
	$process_to_launch++;
	push(@script_name,$script_name);
    }
}

#----------------------------------------------------
# warning
sub warning {
    local($string,$launch_time) = @_;

    $string = $string.$plext;        

    if ($hour_launch != 0) {
	if (($launch_time/$hour_launch) != int($launch_time/$hour_launch)) {
	    print STDERR "$string will never be launch...\n";
    	}
    }
}

#----------------------------------------------------
# Check child fork status
sub check_cmd_status() {
    local($commit) = @_;

    if ($commit != 0) {
#		print "<TABLE>\n<TR>\n<TD WIDTH=110></TD><TD>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg = '';
	print "<P>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
#	$code = $commit >> 8;
#	$msg = "> Fatal error, stats aborted";
#	$msg .= ": Error $code : $!" if ($! ne '');
	if (-f "$path$incstatus$txtext") {
	    open(FILESTATUS,"$path$incstatus$txtext");
	    $scalar = (<FILESTATUS>);
	    (@line) = split(/\t/,$scalar);
	    close(FILESTATUS);
	}
	print "<TABLE CELLSPACING=0 CELLPADDING=0 WIDTH=\"100%\" STYLE=\"border: 2px solid #FF0000\"><TR><TD WIDTH=130 VALIGN=TOP ALIGN=CENTER><BR>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$msg = "> Fatal error, stats aborted";
	if ($line[0] ne '') {
#	    $line[3] =~ s/<BR>/<<BR>/;
	    $msg .= " with $line[0]";
	    $msg .= " : $line[3]";
	}
	&error_exit($msg);
	print "</TD>\n</TR>\n</TABLE>\n</BODY>\n</HTML>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
	$fatal = 1;
	last BOUCLE;
    } else {
	if ($ENV{'REQUEST_METHOD'} eq "GET") {
	    # Opening status.txt
	    $tmp = $path."status.txt";
	    $msg = '';
	    open(FILE,"$tmp");
	    $line = (<FILE>);
	    chop($line);
	    ($a,$b,$c) = split(/\t/,$line);
	    close(FILE);
	    $msg = "<STRONG CLASS=\'status_ok\'>OK</STRONG>" if ($c == 0);
	    $msg = "<STRONG CLASS=\'warning_msg\'>Warning</STRONG>" if ($c == 1);
	    $msg = "<STRONG CLASS=\'error_exit\'>Error</STRONG>" if ($c == 2);
	    print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
	    print "document.getElementById('$tmp_status').innerHTML = \"$msg\";\n";
	    print "</script>\n";
	}
    }
}


