#!/usr/bin/perl

#http://fr.wikipedia.org/wiki/ISO_3166-1

# Russia
#python converter_old.py ne_10m_admin_1_states_provinces.shp ru.js --width 900 --projection mill --language en --name ru --where "iso_a2='RU'" --viewport "20 75 180 40" --simplify_tolerance 1000 --country_name_index 8 --country_code_index 1

### Asia 
# python converter_old.py ne_10m_admin_0_countries.shp Asia.js --width 900 --projection mill --language en --name Asia --where "continent='Asia' or iso_A2='RU' or iso_A2='KZ'" --country_name_index 12 --country_code_index 18 --viewport "25 75 180 -12" --simplify_tolerance 1000
# laos, north and south korea


# Kosov : 'KOS','ks', no TLD available
# Afrique : The Gambia => Gambia + guinea-bissau + somaliland
#python converter_old.py ne_10m_admin_0_countries.shp Africa.js --width 900 --projection mill --language en --name Africa --where "region_un='Africa'" --country_name_index 12 --country_code_index 18 --viewport "-25 40 60 -40" --simplify_tolerance 1000

# Oceania
#python converter_old.py ne_10m_admin_0_countries.shp Oceania.js --width 900 --projection mill --language en --name Oceania --where "continent='Oceania'" --country_name_index 12 --country_code_index 18 --simplify_tolerance 1000 --viewport "100 -10 180 -50"

#python converter_old.py ne_10m_admin_0_countries.shp North-America.js --width 900 --projection mill --language en --name North-America --where "continent='North America'" --country_name_index 12 --country_code_index 18 --simplify_tolerance 1000 --viewport "-165 72 -50 15"

#python converter_old.py ne_10m_admin_0_countries.shp Central-America.js --width 900 --projection mill --language en --name Central-America --where "subregion='Central America' or subregion='Caribbean'" --country_name_index 12 --country_code_index 18 --simplify_tolerance 1000

#python converter_old.py ne_10m_admin_0_countries.shp South-America.js --width 900 --projection mill --language en --name South-America --where "subregion='South America' or wb_a2='FR'" --country_name_index 12 --country_code_index 18 --simplify_tolerance 1000 --viewport "-95 12 -35 -60"

$dir = "/nethome/domisse/jvectormap-maps-builder-master/bin/source";
$dir_out = "/nethome/domisse/jvectormap-maps-builder-master/bin/output";

$file_conv = "/var/www/w3perl/resources/pays-conv";
$jsext = ".js";
$origext = ".orig";
$mode = 0;
$scan_dir = 1;


if ($mode == 1) {
    open(FILE,$file_conv);
    while (<FILE>) {
	$nb = ($newpays,$pays,$zone)=split(/\s+/); 
	if ($nb == 2) {
	    $zone[$pays] = $newpays;
	    $nbzone++;
	} else {
	    $pays =~ s/\(\.(.*)\)/$1/;
	    $pays =~ tr/[a-z]/[A-Z]/;
	    $newpays =~ s/\-/ /g;

	    $conv{$newpays} = $pays;
	    print "$newpays - $pays\n";
	}
    }
    close(FILE);

}


%country_code = ('AFG','af',
		 'AGO','ao',
		 'AFR','afr',
		 'ASIA','asia',
		 'ALB','al',
		 'ARE','ae',
		 'ARG','ar',
		 'ARM','am',
		 'AUS','au',
		 'AUT','at',
		 'AZE','az',
		 'BDI','bi',
		 'BEL','be',
		 'BEN','bj',
		 'BFA','bf',
		 'BGD','bd',
		 'BGR','bg',
		 'BIH','ba',
		 'BLR','by',
		 'BLZ','bz',
		 'BOL','bo',
		 'BRA','br',
		 'BRN','bn',
		 'BTN','bt',
		 'BWA','bw',
		 'CAF','cf',
		 'CAN','ca',
		 'CHE','ch',
		 'CHL','cl',
		 'CHN','cn',
		 'CIV','ci',
		 'CMR','cm',
		 'COD','cd',
		 'COG','cg',
		 'COL','co',
		 'CRI','cr',
		 'CUB','cu',
		 'CYP','cy',
		 'CZE','cz',
#		 'DEU','de',
		 'DJI','dj',
		 'DNK','dk',
		 'DOM','do',
		 'DZA','dz',
		 'ECU','ec',
		 'EGY','eg',
		 'ERI','er',
		 'ESP','es',
		 'EST','ee',
		 'ETH','et',
		 'FIN','fi',
		 'FJI','fj',
#		 'FRA','fr',
		 'GAB','ga',
		 'GBR','gb',
		 'GEO','ge',
		 'GHA','gh',
		 'GIN','gn',
		 'GMB','gm',
		 'GNB','gw',
		 'GNQ','gq',
		 'GRC','gr',
		 'GRL','gl',
		 'GTM','gt',
		 'GUY','gy',
		 'HND','hn',
		 'HRV','hr',
		 'HTI','ht',
		 'HUN','hu',
		 'IDN','id',
		 'IRL','ie',
		 'IRN','ir',
		 'IRQ','iq',
		 'ISL','is',
#		 'ITA','it',
		 'JAM','jm',
		 'JOR','jo',
		 'JPN','jp',
		 'KAZ','kz',
		 'KEN','ke',
		 'KGZ','kg',
		 'KHM','kh',
		 'KOR','kr',
		 'KOS','ks',
		 'KWT','kw',
		 'LAO','la',
		 'LBN','lb',
		 'LBR','lr',
		 'LBY','ly',
		 'LKA','lk',
		 'LSO','ls',
		 'LTU','lt',
		 'LUX','lu',
		 'LVA','lv',
		 'MAR','ma',
		 'MDA','md',
		 'MDG','mg',
		 'MEX','mx',
		 'MKD','mk',
		 'MLI','ml',
		 'MMR','mm',
		 'MNE','me',
		 'MNG','mn',
		 'MOZ','mz',
		 'MRT','mr',
		 'MWI','mw',
		 'MYS','my',
		 'NAM','na',
		 'NCL','nc',
		 'NER','ne',
		 'NGA','ng',
		 'NIC','ni',
		 'NLD','nl',
		 'NOR','no',
		 'NPL','np',
		 'NZL','nz',
		 'OMN','om',
		 'PAK','pk',
		 'PER','pe',
		 'PHL','ph',
		 'PNG','pg',
		 'POL','pl',
		 'PRK','kp',
		 'PRT','pt',
		 'PRY','py',
		 'QAT','qa',
		 'ROU','ro',
		 'RUS','ru',
		 'RWA','rw',
		 'SAU','sa',
		 'SDN','sd',
		 'SDS','ss',
		 'SEN','sn',
		 'SLB','sb',
		 'SLE','sl',
		 'SLV','sv',
		 'SOM','so',
		 'SRB','rs',
		 'SUR','sr',
		 'SVK','sk',
		 'SVN','si',
		 'SWE','se',
		 'SWZ','sz',
		 'SYR','sy',
		 'TCD','td',
		 'TGO','tg',
		 'THA','th',
		 'TJK','tj',
		 'TKM','tm',
		 'TLS','tl',
		 'TTO','tt',
		 'TUN','tn',
		 'TUR','tr',
		 'TWN','tw',
		 'TZA','tz',
		 'UGA','ug',
		 'UKR','ua',
		 'URY','uy',
		 'USA','us',
		 'UZB','uz',
		 'VEN','ve',
		 'VNM','vn',
		 'VUT','vu',
		 'YEM','ye',
		 'ZAF','za',
		 'ZMB','zm',
		 'ZWE','zw'
    );

if ($scan_dir == 1) {
    opendir(SOURCEDIR,$dir);
    @filenames = readdir(SOURCEDIR);
    closedir(SOURCEDIR);
}

binmode(STDOUT, ':utf8');

$list = 0;

for (@filenames) {
    next if $_ eq '.';
    next if $_ eq '..';
    next if ($_ =~ /^#/);
    $filename = "$dir/$_";
    print "Opening $filename\n";
    open(FILE_IN,"$filename");
    $line = <FILE_IN>;
    close(FILE_IN);

    $tmp = $_;
    $tmp =~ s/$jsext//;
    @line_split = split(/_/,$tmp);

#    print $line_split[$#line_split];
    $pays = $country_code{$line_split[$#line_split]};

    $file_out = $dir_out."/$pays$jsext";

    $line =~ s/\'world/\'$pays/;
    $line =~ s/\\u([0-9a-fA-F]{4})/chr(hex($1))/eg;
    $line = &noaccent($line);

    @val = split(/\}/,$line);

    print "MAP : $pays\n";

    $idx = 0;
    for ($i=0;$i<=$#val;$i++) {

#	print "Line : $val[$i]\n";

	if ($val[$i] !~ /path/) {
	    $val[$i] = $val[$i];
	} else {
	    if ($val[$i] =~ /\"([^\"]*)\":\s\{\"path\"/) {
#	    if ($val[$i] =~ /\"([,\)\(\.0-9A-Za-z\_\-\'\s]+)\":\s\{\"path\"/) {
		$number = $1;
		$idx++;
	    }
	    if ($val[$i] =~ /\"name\":\s\"([^\"]*)\"/) {
#	    if ($val[$i] =~ /\"name\":\s\"([,\(\)\.0-9A-Za-z\_\-\'\s]+)\"/) {
		$value = $1;
#		$value =~ s/\\u([0-9a-fA-F]{4})/chr(hex($1))/eg;
	    }

	    print "FOUND $idx - $number - $value\n";
	    
	    if ($list == 0) {
		$empty = 0;
		if ($value =~ /\u/ || $value eq '') {
		    print "VALUE empty $val[$i]\n";
		    $val[$i] =~ s/\"$number\": \{\"path\"/\"Unknown\": \{\"path\"/;
#		exit;
		    $empty = 1;
		}


		if ($mode == 0) {
		    $val[$i] =~ s/\"$number\": \{\"path\"/\"$value\": \{\"path\"/;
		    $seen{$value}++;
		}
		if ($mode == 1) {
		    $val[$i] =~ s/\"name\": \"$value\"/\"name\": \"$number\"/;
		    $val[$i] =~ s/\"$number\": \{\"path\"/\"$conv{$number}\": \{\"path\"/ if ($empty == 0);
		}
	    }

	    print "*** ERROR for $number - $value seen twice\n" if ($seen{$value} > 1);
	    

	}  
    }

    binmode(FILE_OUT, ':utf8');
    print "Write $file_out\n";
    open(FILE_OUT,">$file_out");
    for ($i=0;$i<=$#val;$i++) {
    #   print FILE_OUT "$i - $val[$i]\n";
	print FILE_OUT "$val[$i]";
	print FILE_OUT "}" if ($i != $#val);
    }
#print FILE_OUT $line;
    close(FILE_OUT);
}


sub noaccent {
    local($words) = @_;

    $words =~ s/\xc3\xa9/e/g;
    $words =~ s/\xc3\xa8/e/g;
    $words =~ s/\xc3\xaA/e/g;
    $words =~ s/\xc3\xab/e/g;

    $words =~ s/\xc3\x89/E/g;
    $words =~ s/\xc3\x88/E/g;
    $words =~ s/\xc3\x8a/E/g;
    $words =~ s/\xc3\x8b/E/g;

    $words =~ s/\xc3\xa0/a/g;
    $words =~ s/\xc3\xa1/a/g;
    $words =~ s/\xc3\xa2/a/g;
    $words =~ s/\xc3\xa3/a/g;
    $words =~ s/\xc3\xa4/a/g;
    $words =~ s/\xc3\xa5/a/g;

    $words =~ s/\xc3\x80/A/g;
    $words =~ s/\xc3\x81/A/g;
    $words =~ s/\xc3\x82/A/g;
    $words =~ s/\xc3\x83/A/g;
    $words =~ s/\xc3\x84/A/g;
    $words =~ s/\xc3\x85/A/g;
    $words =~ s/\xc3\x86/A/g;

    $words =~ s/\xc3\xac/i/g;
    $words =~ s/\xc3\xad/i/g;
    $words =~ s/\xc3\xae/i/g;
    $words =~ s/\xc3\xaf/i/g;

    $words =~ s/\xc3\x8c/I/g;
    $words =~ s/\xc3\x8d/I/g;
    $words =~ s/\xc3\x8e/I/g;
    $words =~ s/\xc3\x8f/I/g;

    $words =~ s/\xc3\xb2/o/g;
    $words =~ s/\xc3\xb3/o/g;
    $words =~ s/\xc3\xb4/o/g;
    $words =~ s/\xc3\xb5/o/g;
    $words =~ s/\xc3\xb6/o/g;

    $words =~ s/\xc3\x92/O/g;
    $words =~ s/\xc3\x93/O/g;
    $words =~ s/\xc3\x94/O/g;
    $words =~ s/\xc3\x95/O/g;
    $words =~ s/\xc3\x96/O/g;

    $words =~ s/\xc3\xb9/u/g;
    $words =~ s/\xc3\xba/u/g;
    $words =~ s/\xc3\xbb/u/g;
    $words =~ s/\xc3\xbc/u/g;

    $words =~ s/\xc3\x99/U/g;
    $words =~ s/\xc3\x9a/U/g;
    $words =~ s/\xc3\x9b/U/g;
    $words =~ s/\xc3\x9c/U/g;

    $words =~ s/\xc3\xbd/y/g;
    $words =~ s/\xc3\xbf/y/g;

    $words =~ s/\xc3\x9d/Y/g;

    $words =~ s/\xc3\xa7/c/g;
    $words =~ s/\xc3\x87/C/g;

    $words =~ s/\xc3\xb1/n/g;
    $words =~ s/\xc3\x91/N/g;

###

    $words =~ s/\351/e/g;
    $words =~ s/\350/e/g;
    $words =~ s/\352/e/g;
    $words =~ s/\353/e/g;
    $words =~ s/\337/ss/g;

    $words =~ s/\311/E/g;
    $words =~ s/\310/E/g;
    $words =~ s/\312/E/g;
    $words =~ s/\313/E/g;

    $words =~ s/\341/a/g;
    $words =~ s/\340/a/g;
    $words =~ s/\342/a/g;
    $words =~ s/\344/a/g;
    $words =~ s/\343/a/g;
    $words =~ s/\345/a/g;
    $words =~ s/\346/ae/g;

    $words =~ s/\301/A/g;
    $words =~ s/\300/A/g;
    $words =~ s/\302/A/g;
    $words =~ s/\303/A/g;
    $words =~ s/\304/A/g;
    $words =~ s/\305/A/g;

    $words =~ s/\355/i/g;
    $words =~ s/\354/i/g;
    $words =~ s/\356/i/g;
    $words =~ s/\353/i/g;

    $words =~ s/\315/I/g;
    $words =~ s/\314/I/g;
    $words =~ s/\316/I/g;
    $words =~ s/\317/I/g;

    $words =~ s/\363/o/g;
    $words =~ s/\362/o/g;
    $words =~ s/\364/o/g;
    $words =~ s/\366/o/g;
    $words =~ s/\370/o/g;

    $words =~ s/\323/O/g;
    $words =~ s/\322/O/g;
    $words =~ s/\324/O/g;
    $words =~ s/\326/O/g;
    $words =~ s/\330/O/g;

    $words =~ s/\372/u/g;
    $words =~ s/\371/u/g;
    $words =~ s/\373/u/g;
    $words =~ s/\374/u/g;

    $words =~ s/\332/U/g;
    $words =~ s/\331/U/g;
    $words =~ s/\333/U/g;
    $words =~ s/\334/U/g;

    $words =~ s/\375/y/g;
    $words =~ s/\377/y/g;

    $words =~ s/\335/Y/g;
    $words =~ s/\276/Y/g;

    $words =~ s/\347/c/g;
    $words =~ s/\307/C/g;

    $words =~ s/\361/n/g;
    $words =~ s/\321/N/g;

    return $words;
    
}
