%define name w3perl
%define version 3.17
%define release %mkrel 1
%define basedir /var/www/html/w3perl
%define docs %{basedir}/docs
%define cfg1 %{basedir}/config
%define cfg2 %{basedir}/resources/admin
%define cgi /var/www/cgi-bin/w3perl
%define perl_path %(which perl)

Summary: Web/ftp/mail/squid/cups/dhcp server logfile analyser
Name: %{name}
Version: %{version}
Release: %{release}
Source0: http://www.w3perl.com/download/%{name}-%{version}.tar.bz2
License: GPL
Group: Networking/WWW
URL: http://www.w3perl.com/
BuildRequires: perl >= 5.0
Requires: webserver
BuildRoot: %{_tmppath}/%{name}-buildroot
BuildArch: noarch

%description
W3Perl is a free web logfile analyzer which is also able to parse FTP,
Mail, CUPS, DHCP and Squid logfiles.

It is one of the most powerful package as it includes advanced stats
like real-time, sessions, URL mapping along with classical
stats like hosts, pages, traffic, countries, agents, referers, errors,
filetypes, robots, search engines and much more.

It supports most logfile formats, including Apache (CLF, ECLF, NECLF)
or IIS (W3C, Microsoft or any variation). Logs can be daily or monthly
split and/or compressed.

A web administration tool allows you to manage your configuration
files to customize your stats output. A demo is available at
http://www.w3perl.com/demo/ 

%prep
%setup -q

%install
rm -rf $RPM_BUILD_ROOT
perl install.pl -r $RPM_BUILD_ROOT -i $RPM_BUILD_ROOT%{basedir} -d $RPM_BUILD_ROOT%{cgi} -p %{perl_path}

# No need to ship the license if it's standard
rm -f %{buildroot}%{basedir}/LICENCE

%clean
rm -rf $RPM_BUILD_ROOT

%files
%doc %{basedir}/README 
%doc %{basedir}/INSTALL 
%doc %{basedir}/VERSION 
%doc %{docs}
#%attr(0755, root, root) %config %{cfg1}
#%{basedir}/admin
#%{basedir}/*.pl
#%{basedir}/index.html
#%{basedir}/tools
#%{basedir}/cgi-bin
#%{basedir}/upgrade.txt
#%{basedir}/resources/os
#%{basedir}/resources/admin
#%attr(755, root, root) %{basedir}/resources/lang/*.pl
#%attr(755, root, root) %{basedir}/resources/admin/*.pl
#%{basedir}/upgrade.txt
%{basedir}/index.html
%{basedir}/admin
#%{basedir}/resources
%{basedir}/resources/*.jpg
%{basedir}/resources/*.gif
%{basedir}/resources/*.png
%{basedir}/resources/*.ico
%{basedir}/resources/*.nsi
%{basedir}/resources/*.spec
%{basedir}/resources/fileext
%{basedir}/resources/pays-conv
%{basedir}/resources/pays-coord
%{basedir}/resources/upgrade
%{basedir}/resources/virus
%{basedir}/resources/robot.txt
%{basedir}/resources/gpl.txt
%{basedir}/resources/referrer-standard.txt
%{basedir}/resources/resolv_users.csv.example
%{basedir}/resources/spip
%{basedir}/resources/css
%{basedir}/resources/pays
%{basedir}/resources/js
%{basedir}/resources/flags
%{basedir}/resources/help
%{basedir}/resources/os
%{basedir}/resources/homepage
%{basedir}/resources/lang
%{basedir}/resources/counter
%{basedir}/logs
%{basedir}/tools
#%{basedir}/tools/Readme
#%{basedir}/resources/lang/Readme
%{basedir}/resources/rpmfile
%{basedir}/resources/new_package
%{basedir}/resources/Readme-tag.txt
%{basedir}/resources/tag_log.php
%{basedir}/resources/heatmap.php
#%{basedir}/logs/htaccess.dist
#%{cfg1}/Readme
##%attr(755, apache, apache) %{cfg2}/locconf
##%{cfg2}/var-forms
#%attr(755, apache, apache) %{cfg2}/config*
#%{basedir}/tools/Transfert_log_NT2Unix/readme.txt
#%{basedir}/tools/Transfert_log_NT2Unix/ftp_cmd.txt
#%{basedir}/tools/Transfert_log_NT2Unix/ftp_crontab.bat
#%{basedir}/tools/Transfert_log_NT2Unix
#%{basedir}/tools/Transfert_log_Unix2Unix
##%{cfg2}/global.pl

#%{cgi}
%defattr(0755,apache,apache,-) 
%{cfg1}
%{cfg2}

%defattr(0755,root,root,-) 
#%attr(755, apache, apache) %{cfg1}/*.pl
##%{cfg1}/restore.sh
##%{cfg2}/restore.sh
%{cgi}
%{basedir}/install.pl
#%{basedir}/upgrade.pl
#%{basedir}/*pl
#%{basedir}/cgi-bin/w3perl/*pl
#%{basedir}/resources/lang/*pl
#%{basedir}/resources/lang/help/*pl
#%{basedir}/resources/lang/country/*pl
#%{basedir}/tools/*.pl
#%{basedir}/tools/*.sh
#%{basedir}/tools/windows
#%{basedir}/tools/Transfert_log_NT2Unix/cron-stats.sh
#%{basedir}/tools/Transfert_log_Unix2Unix/cron-stats.sh
