%define name w3perl
%define version 3.172
%define release %mkrel 1
%define basedir /var/www/w3perl
%define docs %{basedir}/docs
%define cfg1 %{basedir}/config
%define cfg2 %{basedir}/resources/admin
%define cgi /var/www/cgi-bin/w3perl
%define perl_path %(which perl)
%define mod_conf w3perl.conf

Summary: Web/ftp/mail/squid/cups/dhcp server logfile analyser
Name: %{name}
Version: %{version}
Release: %{release}
Source0: http://www.w3perl.com/download/%{name}-%{version}.tar.bz2
License: GPL
Group: Networking/WWW
URL: http://www.w3perl.com/
BuildRequires: perl >= 5.0
Requires: perl >= 5.0
Requires: webserver
BuildRoot: %{_tmppath}/%{name}-buildroot
#Prefix: %{basedir}
BuildArch: noarch

%description
W3Perl is a free web logfile analyzer which is also able to parse FTP,
Mail, CUPS, DHCP and Squid logfiles.

It is one of the most powerful package as it includes advanced stats
like real-time, sessions, URL mapping along with classical
stats like hosts, pages, traffic, countries, agents, referers, errors,
filetypes, robots, search engines and much more.

It supports most logfile formats, including Apache (CLF, ECLF, NECLF)
or IIS (W3C, Microsoft or any variation). Logs can be daily or monthly
split and/or compressed.

A web administration tool allows you to manage your configuration
files to customize your stats output. A demo is available at
http://www.w3perl.com/demo/ 

%prep
%setup -q

%install
rm -rf $RPM_BUILD_ROOT
%{perl_path} install.pl -r $RPM_BUILD_ROOT -i $RPM_BUILD_ROOT%{basedir} -d $RPM_BUILD_ROOT%{cgi} -p %{perl_path}
ln -sf install.pl %{buildroot}%{basedir}/upgrade.pl


# Web app config file
cat <<EOF > %{mod_conf}

Alias /%{name} %{basedir}

<Directory %{basedir}>

    Allow from all

</Directory>

EOF

mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d
install -m0644 %{mod_conf} %{buildroot}%{_sysconfdir}/httpd/conf/webapps.d/%{mod_conf}

cat > README.urpmi <<EOF
W3Perl has been successfully installed.

The resource files are located in %{basedir}
The cgi scripts are located in %{cgi}

If you want to run your stats :
   1 - First, password protect the %{basedir}/admin directory
   2 - Open a browser to http://127.0.0.1/w3perl/admin
   3 - Select "immediate launch" using your configuration file
   4 - Click on the "Init all stats" icon to compute all stats
   5 - When completed, go back to admin and view the output
EOF

# No need to ship the license if it's standard
rm -f %{buildroot}%{basedir}/LICENCE

%post
if [ "$1" = "2" ]; then
%{perl_path} %{basedir}/upgrade.pl
fi
if [ -f /var/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi

%postun
if [ "$1" = "0" ]; then
    if [ -f /var/lock/subsys/httpd ]; then
	%{_initrddir}/httpd restart 1>&2
    fi
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%doc README.urpmi 
%doc %{basedir}/README 
%doc %{basedir}/INSTALL 
%doc %{basedir}/VERSION 
%doc %{docs}

%{basedir}/index.html
%attr(0755,-,-) %{basedir}/install.pl
%{basedir}/upgrade.pl
%{basedir}/upgrade.txt

%{basedir}/admin
%{basedir}/logs
%{basedir}/tools
%dir %{basedir}/resources
%dir %{basedir}

%{basedir}/resources/*.jpg
%{basedir}/resources/*.gif
%{basedir}/resources/*.png
%{basedir}/resources/*.ico
%{basedir}/resources/*.nsi
%{basedir}/resources/*.spec
%{basedir}/resources/fileext
%{basedir}/resources/pays-conv
%{basedir}/resources/pays-coord
%{basedir}/resources/upgrade
%{basedir}/resources/virus
%{basedir}/resources/robot.txt
%{basedir}/resources/gpl.txt
%{basedir}/resources/referrer-standard.txt
%{basedir}/resources/referrer-keyword.txt
%{basedir}/resources/resolv_users.csv.example
%{basedir}/resources/spip
%{basedir}/resources/css
%{basedir}/resources/pays
%{basedir}/resources/js
%{basedir}/resources/flags
%{basedir}/resources/help
%{basedir}/resources/os
%{basedir}/resources/homepage
%{basedir}/resources/lang
%{basedir}/resources/counter
%{basedir}/resources/new_package
%{basedir}/resources/Readme-tag.txt
%{basedir}/resources/tag_log.php
%{basedir}/resources/heatmap.php

%defattr(0755,apache,apache,-)
%dir %{cfg1}
%dir %{cfg2}

%attr(0644,apache,apache) %{cfg1}/*
%attr(0644,apache,apache) %{cfg2}/*

%defattr(0755,root,root,-)
%{cgi}
%{_sysconfdir}/httpd/conf/webapps.d/%{mod_conf}

