; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "W3Perl"
!define PRODUCT_VERSION "3.20"
!define PRODUCT_PUBLISHER "Laurent Domisse"
!define PRODUCT_WEB_SITE "http://www.w3perl.com"
!define PRODUCT_WEB_SITE_HOME "http://www.w3perl.com/"
!define PRODUCT_WEB_SITE_NEW "http://www.w3perl.com/demo/docs/uk/new.html"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\w3perl.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define VDIRNAME "cgi-bin"
!define PERLEXT ".pl";
!define ConfigWin "config-win"
!define OutputStats "file:///C:/W3Perl/w3stats/index.html"
!define PRODUCT_WEB_ADMIN "file:///$PROGRAMFILES/W3Perl/docs/uk/windows_noserver.html"
!define InstallDirShort "$PROGRAMFILES\W3Perl"
 
SetCompressor lzma
  
Var PerlPath
Var upgrade
OutFile "w3perl-dev.exe"

RequestExecutionLevel admin

; MUI 1.67 compatible ------
!include "MUI.nsh"

;-----------------------------------------------------------------------------------------

Function .onInit
  
 Banner::show /NOUNLOAD "Checking for Perl ..."

 ReadRegStr $5 HKLM Software\Perl BinDir
 StrCmp $5 "" 0 +2
 StrCpy $5 perl.exe
 nsExec::Exec '"$5" -v'
 Pop $0
 StrCmp $0 0 check_upgrade
   MessageBox MB_YESNOCANCEL|MB_ICONEXCLAMATION "The installer  can not find Perl \
    on this computer!$\r$\nPlease install Perl and run this \
    installer again.$\r$\nPress cancel if you are sure you have Perl \
    installed.$\r$\n$\r$\nWould you like the installer to open Perl's download page \
    for you?" IDNO abort IDCANCEL splash
     ExecShell open http://www.strawberryperl.com/
     Goto abort
   
   check_upgrade:
 ClearErrors
 StrCpy $upgrade 0
 ReadRegStr $6 "${PRODUCT_UNINST_ROOT_KEY}" "${PRODUCT_UNINST_KEY}" "DisplayVersion"
 StrCmp $6 "" 0 +3
 StrCpy $R0 "$PROGRAMFILES\W3Perl"
 goto +7
 StrCmp $6 "${PRODUCT_VERSION}" 0 +3
 MessageBox MB_OK "W3Perl $6 already installed."
 goto abort
 MessageBox MB_OK "W3Perl $6 have been found. Will upgrade to ${PRODUCT_VERSION}"
 ReadRegStr $R0 "${PRODUCT_UNINST_ROOT_KEY}" "${PRODUCT_DIR_REGKEY}" ""
 StrCpy $upgrade 1
 StrCpy $INSTDIR $R0
 
 StrCmp $upgrade 1 0 +2
 StrCpy $INSTDIR "$R0\"
 
 ;MessageBox MB_OK "Install in $INSTDIR"
 goto splash
 
 splash:
   Banner::destroy
   ;File /oname=$PLUGINSDIR\splash.bmp splash.bmp

   advsplash::show 1800 350 187 -1 $PLUGINSDIR\splash

   Pop $0 ; $0 has '1' if the user closed the splash screen early,
       ; '0' if everything closed normal, and '-1' if some error occurred.
   Return

 abort:
   Banner::destroy
   Abort
;  !insertmacro MUI_LANGDLL_DISPLAY

FunctionEnd
 
; MUI Settings
!define MUI_ABORTWARNING

!define MUI_WELCOMEPAGE_TEXT "This wizard will guide you through the installation of W3Perl ${PRODUCT_VERSION}, a free logfile analyzer.\r\n\rW3Perl is able to parse Web / FTP / Squid / CUPS / SSH / DHCP and mail logfiles."

!define MUI_ICON "E:\nsis\logo_32x32.ico"
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "E:\nsis\header.bmp"
!define MUI_HEADERIMAGE_RIGHT
!define MUI_WELCOMEFINISHPAGE_BITMAP "E:\nsis\headerimage.bmp"

; Welcome page
!define MUI_PAGE_CUSTOMFUNCTION_PRE skip_install
!insertmacro MUI_PAGE_WELCOME

; License page
!define MUI_PAGE_CUSTOMFUNCTION_PRE skip_install
!insertmacro MUI_PAGE_LICENSE "${NSISDIR}\w3perl\resources\gpl.txt"

!define MUI_PAGE_CUSTOMFUNCTION_PRE skip_install
!insertmacro MUI_PAGE_DIRECTORY

; Instfiles page

!insertmacro MUI_PAGE_INSTFILES
; Finish page
!define MUI_FINISHPAGE_RUN
!define MUI_FINISHPAGE_RUN_TEXT "Configure W3Perl"
!define MUI_FINISHPAGE_RUN_FUNCTION "LaunchLink"
!define MUI_FINISHPAGE_TEXT "You should now create a configuration file. The web wizard is not available without a web server running."
!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"
;!insertmacro MUI_LANGUAGE "French"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"

;InstallDir "$PROGRAMFILES\W3Perl"
ShowInstDetails show
ShowUnInstDetails show

;-----------------------------------------------------------------------------------------

Section "SectionPrincipale" SEC01

  StrCpy $PerlPath "$5"
  StrCpy $PerlPath "$PerlPath" -9
 
  SetOutPath "$INSTDIR"
  SetOverwrite ifnewer
  
  WriteINIStr "$INSTDIR\Config.txt" "Data" "PerlPath" "$PerlPath"
  WriteINIStr "$INSTDIR\Config.txt" "Data" "InstallPath" "${InstallDirShort}"
  WriteINIStr "$INSTDIR\Config.txt" "Data" "CGIPath" ""
  WriteINIStr "$INSTDIR\Config.txt" "Data" "CGIServer" ""
  WriteINIStr "$INSTDIR\Config.txt" "Data" "LogFileServer" ""
  WriteINIStr "$INSTDIR\Config.txt" "Data" "ConfigFile" "${ConfigWin}"
  
  ;StrCpy $0 ${InstallDirShort}
  ;GetFullPathName /short $1 $0
  
  FileOpen $0 $INSTDIR\InitStats.bat w
  ;FileWrite $0 "$\"$1\cron-w3perl.pl$\" -a -c ${ConfigWin}${PERLEXT}"
  FileWrite $0 "$\"$INSTDIR\cron-w3perl.pl$\" -a -c $\"$INSTDIR\${ConfigWin}${PERLEXT}$\""
  FileClose $0

  FileOpen $0 $INSTDIR\UpdateStats.bat w
  ;FileWrite $0 "$\"$1\cron-w3perl.pl$\" -e -c ${ConfigWin}${PERLEXT}"
  FileWrite $0 "$\"$INSTDIR\cron-w3perl.pl$\" -e -c $\"$INSTDIR\${ConfigWin}${PERLEXT}$\""
  FileClose $0
  
  SetOverwrite On
  File /r "${NSISDIR}\w3perl\*"

  StrCmp $5 perl.exe 0 +2
  SearchPath $5 perl.exe
  StrCmp $5 "" 0 +2
  StrCpy $5 perl.exe
   
  
  ;nsExec::Exec '$5 "$INSTDIR\install.pl" -g "$INSTDIR\Config.txt"'
  ;ReadRegStr $6 "${PRODUCT_UNINST_ROOT_KEY}" "${PRODUCT_UNINST_KEY}" "DisplayVersion"
  ;StrCmp $6 "" 0 +3
  ;nsExec::Exec '$5 "$INSTDIR\install.pl" -g "$INSTDIR\Config.txt"'
  ;goto +2
  ;nsExec::Exec '$5 "$INSTDIR\upgrade.pl"'
  
  
  IntCmp $upgrade 0 0 0 +3
  nsExec::Exec '$5 "$INSTDIR\install.pl" -g "$INSTDIR\Config.txt"'
  goto +2
  nsExec::Exec '$5 "$INSTDIR\upgrade.pl" -g "$INSTDIR\Config.txt"'
  
SectionEnd

;-----------------------------------------------------------------------------------------

Function LaunchLink
  ExecShell open ${PRODUCT_WEB_ADMIN}
FunctionEnd

;-----------------------------------------------------------------------------------------

Section -AdditionalIcons
  
  ;WriteIniStr "$INSTDIR\Admin.url" "InternetShortcut" "URL" "${PRODUCT_WEB_ADMIN}"
  ;WriteIniStr "$INSTDIR\Admin.url" "InternetShortcut" "IconFile" "$INSTDIR\resources\favicon.ico"
  ;WriteIniStr "$INSTDIR\Admin.url" "InternetShortcut" "IconIndex" "0"
  
  WriteIniStr "$INSTDIR\Whats new.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE_NEW}?${PRODUCT_VERSION}"
  WriteIniStr "$INSTDIR\Whats new.url" "InternetShortcut" "IconFile" "$INSTDIR\resources\favicon.ico"
  WriteIniStr "$INSTDIR\Whats new.url" "InternetShortcut" "IconIndex" "0"
  
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE_HOME}"
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "IconFile" "$INSTDIR\resources\favicon.ico"
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "IconIndex" "0"
  
  WriteIniStr "$INSTDIR\ViewStats.url" "InternetShortcut" "URL" "${OutputStats}"
  WriteIniStr "$INSTDIR\ViewStats.url" "InternetShortcut" "IconFile" "$INSTDIR\resources\favicon.ico"
  WriteIniStr "$INSTDIR\ViewStats.url" "InternetShortcut" "IconIndex" "0"

  SetShellVarContext all
  CreateDirectory "$SMPROGRAMS\W3Perl"
  ;CreateShortCut "$SMPROGRAMS\W3Perl\Admin.lnk" "$INSTDIR\Admin.url" "" "$INSTDIR\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\Whats new.lnk" "$INSTDIR\Whats new.url" "" "$INSTDIR\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\${PRODUCT_NAME}.lnk" "$INSTDIR\${PRODUCT_NAME}.url" "" "$INSTDIR\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\Init Stats.lnk" "$INSTDIR\InitStats.bat" "" "$INSTDIR\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\Update Stats.lnk" "$INSTDIR\UpdateStats.bat" "" "$INSTDIR\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\View Stats.lnk" "$INSTDIR\ViewStats.url" "" "$INSTDIR\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\Uninstall.lnk" "$INSTDIR\uninst.exe"
SectionEnd

;-----------------------------------------------------------------------------------------

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$\"H:\nsis\logo_32x32.ico$\""
SectionEnd

;-----------------------------------------------------------------------------------------

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) has been successfully removed from your computer"
FunctionEnd

;-----------------------------------------------------------------------------------------

Function un.onInit
;!insertmacro MUI_UNGETLANGUAGE
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to remove $(^Name)?" IDYES +2
  Abort
FunctionEnd

;-----------------------------------------------------------------------------------------

Function skip_install
  StrCmp $upgrade 1 0 +2
  Abort
FunctionEnd

;-----------------------------------------------------------------------------------------

Section Uninstall

  ReadRegStr $0 ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_DIR_REGKEY}" ""
  StrCpy $INSTDIR "$0"
  
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  ;Delete "$INSTDIR\Admin.url"
  Delete "$INSTDIR\Whats new.url"
  Delete "$INSTDIR\uninst.exe"
  
  Delete "$INSTDIR\tools\Transfert_log_Unix2Unix\*"
  Delete "$INSTDIR\tools\Transfert_log_NT2Unix\*"
  Delete "$INSTDIR\tools\windows\*"
  Delete "$INSTDIR\tools\*"
  Delete "$INSTDIR\resources\counter\*"
  Delete "$INSTDIR\resources\spip\*"
  Delete "$INSTDIR\resources\os\*"
  Delete "$INSTDIR\resources\css\*"
  Delete "$INSTDIR\resources\js\jqplot\plugins\*"
  Delete "$INSTDIR\resources\js\jqplot\*"
  Delete "$INSTDIR\resources\js\jvectormap\*"
  Delete "$INSTDIR\resources\js\*"
  Delete "$INSTDIR\resources\lang\country\*"
  Delete "$INSTDIR\resources\lang\help\*"
  Delete "$INSTDIR\resources\lang\*"
  Delete "$INSTDIR\resources\homepage\*"
  Delete "$INSTDIR\resources\help\uk\*"
  Delete "$INSTDIR\resources\help\admin\*"
  Delete "$INSTDIR\resources\help\*"
  Delete "$INSTDIR\resources\flags\*"
  Delete "$INSTDIR\resources\pays\*"
  Delete "$INSTDIR\resources\admin\*"
  Delete "$INSTDIR\resources\*"
  Delete "$INSTDIR\docs\img\*"
  Delete "$INSTDIR\docs\uk\*"
  Delete "$INSTDIR\docs\fr\*"
  Delete "$INSTDIR\docs\*"
  Delete "$INSTDIR\logs\*"
  Delete "$INSTDIR\config\*"
  ;Delete "$INSTDIR\cgi-bin\w3perl\*"
  ;Delete "$INSTDIR\cgi-bin\*"
  ;Delete "$INSTDIR\admin\help\*"
  Delete "$INSTDIR\admin\config\*"
  Delete "$INSTDIR\admin\scripts\*"
  Delete "$INSTDIR\admin\js\*"
  Delete "$INSTDIR\admin\*"
  Delete "$INSTDIR\*"
  
  RMDir "$INSTDIR\tools\Transfert_log_Unix2Unix"
  RMDir "$INSTDIR\tools\Transfert_log_NT2Unix"
  RMDir "$INSTDIR\tools\windows"
  RMDir "$INSTDIR\tools"
  RMDir "$INSTDIR\resources\counter"
  RMDir "$INSTDIR\resources\spip"
  RMDir "$INSTDIR\resources\os"
  RMDir "$INSTDIR\resources\css"
  RMDir "$INSTDIR\resources\js\jqplot\plugins"
  RMDir "$INSTDIR\resources\js\jqplot"
  RMDir "$INSTDIR\resources\js\jvectormap"
  RMDir "$INSTDIR\resources\js"
  RMDir "$INSTDIR\resources\lang\country"
  RMDir "$INSTDIR\resources\lang\help"
  RMDir "$INSTDIR\resources\lang"
  RMDir "$INSTDIR\resources\homepage"
  RMDir "$INSTDIR\resources\help\uk"
  RMDir "$INSTDIR\resources\help\admin"
  RMDir "$INSTDIR\resources\help"
  RMDir "$INSTDIR\resources\flags"
  RMDir "$INSTDIR\resources\pays"
  RMDir "$INSTDIR\resources\admin"
  RMDir "$INSTDIR\resources"
  RMDir "$INSTDIR\docs\img"
  RMDir "$INSTDIR\docs\uk"
  RMDir "$INSTDIR\docs\fr"
  RMDir "$INSTDIR\docs"
  RMDir "$INSTDIR\logs"
  RMDir "$INSTDIR\config"
  RMDir "$INSTDIR\cgi-bin\w3perl"
  RMDir "$INSTDIR\cgi-bin"
  ;RMDir "$INSTDIR\admin\help"
  RMDir "$INSTDIR\admin\config"
  RMDir "$INSTDIR\admin\scripts"
  RMDir "$INSTDIR\admin\js"
  RMDir "$INSTDIR\admin"
  RMDir "$INSTDIR"

  SetShellVarContext all
  Delete "$SMPROGRAMS\W3Perl\Uninstall.lnk"
  ;Delete "$SMPROGRAMS\W3Perl\Admin.lnk"
  Delete "$SMPROGRAMS\W3Perl\Whats new.lnk"
  Delete "$SMPROGRAMS\W3Perl\Init Stats.lnk"
  Delete "$SMPROGRAMS\W3Perl\Update Stats.lnk"
  Delete "$SMPROGRAMS\W3Perl\View Stats.lnk"
  Delete "$SMPROGRAMS\W3Perl\${PRODUCT_NAME}.lnk"
  RMDir "$SMPROGRAMS\W3Perl"

  
   ;Delete "$INSTDIR\fly.exe"
   ;Delete "$INSTDIR\wget.exe"
   Delete "$INSTDIR\tools\*"
   RMDir "$INSTDIR\tools"
   ;Delete "$INSTDIR\w3perl\*"
  
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_DIR_REGKEY}"
  
  SetAutoClose true

  IfFileExists "$INSTDIR" 0 NoErrorMsg
    MessageBox MB_OK "Note: $INSTDIR could not be removed!" IDOK 0 ; skipped if file doesn't exist
  NoErrorMsg:
  
SectionEnd
