; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "W3Perl"
!define PRODUCT_VERSION "3.20"
!define PRODUCT_PUBLISHER "Laurent Domisse"
!define PRODUCT_WEB_SITE "http://www.w3perl.com"
!define PRODUCT_WEB_SITE_HOME "http://www.w3perl.com/"
!define PRODUCT_WEB_SITE_NEW "http://www.w3perl.com/demo/docs/uk/new.html"
!define PRODUCT_WEB_ADMIN "http://127.0.0.1/w3perl/admin/index.html"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\w3perl-apache.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define XAMPP "Software\Microsoft\Windows\CurrentVersion\Uninstall\xampp"
!define VDIRNAME "cgi-bin"
!define PERLEXT ".pl";
!define ConfigWin "config-win-apache"
!define PRODUCT_OUTPUT_STATS "http://127.0.0.1/w3stats/index.html"

SetCompressor lzma
Var PerlPath
Var upgrade
Var xampp_cfg
Var apache_version

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "w3perl-apache-dev.exe"

RequestExecutionLevel admin

; MUI 1.67 compatible ------
!include "MUI.nsh"

; MUI Settings
!define MUI_ABORTWARNING

!define MUI_WELCOMEPAGE_TEXT "This wizard will guide you through the installation of W3Perl ${PRODUCT_VERSION}, a free logfile analyzer.\r\n\rW3Perl is able to parse Web / FTP / Squid / CUPS / SSH / DHCP and mail logfiles."

!define MUI_ICON "E:\nsis\logo_32x32.ico"
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "E:\nsis\header.bmp"
!define MUI_HEADERIMAGE_RIGHT
!define MUI_WELCOMEFINISHPAGE_BITMAP "E:\nsis\headerimage.bmp"

; Welcome page
!define MUI_PAGE_CUSTOMFUNCTION_PRE skip_install
!insertmacro MUI_PAGE_WELCOME

; License page
!define MUI_PAGE_CUSTOMFUNCTION_PRE skip_install
!insertmacro MUI_PAGE_LICENSE "${NSISDIR}\w3perl\resources\gpl.txt"

!define MUI_PAGE_CUSTOMFUNCTION_PRE skip_install
!insertmacro MUI_PAGE_DIRECTORY

; Instfiles page
!insertmacro MUI_PAGE_INSTFILES

; Finish page
!define MUI_FINISHPAGE_RUN
!define MUI_FINISHPAGE_RUN_TEXT "Configure W3Perl"
!define MUI_FINISHPAGE_RUN_FUNCTION "LaunchLink"
!define MUI_FINISHPAGE_TEXT "You should now create a configuration file using the web wizard.\r\n\rSome templates are available. Default configuration file for your server is config-win-apache"

!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"
;!insertmacro MUI_LANGUAGE "French"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

;Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"

ShowInstDetails show
ShowUnInstDetails show

;-----------------------------------------------------------------------------------------

Function .onInit
 ;InitPluginsDir
 ;File /oname=$PLUGINSDIR\splash.bmp "splash.bmp"
 ;splash::show 3000 $PLUGINSDIR\splash.bmp
 ;Pop $R0
 ;Delete $PLUGINSDIR\splash
 Banner::show /NOUNLOAD "Checking for Perl and Webserver..."

 #ReadRegStr $5 HKLM Software\Perl BinDir
 #StrCmp $5 "" 0 +2
 StrCpy $5 perl.exe
 nsExec::Exec '"$5" -v'
 Pop $0
 StrCmp $0 0 CheckApache
   MessageBox MB_YESNOCANCEL|MB_ICONEXCLAMATION "The installer can not find Perl \
    on this computer!$\r$\nPlease install Perl and run this \
    installer again.$\r$\nPress cancel if you are sure you have Perl \
    installed.$\r$\n$\r$\nWould you like the installer to open Perl's download page \
    for you?" IDNO abort IDCANCEL splash
     ExecShell open http://www.activestate.com/Products/ActivePerl/
     Goto abort

CheckApache:
   ClearErrors
   ; READ HKLM\SYSTEM\ControlSet001\Services\Apache2.2 Description = Apache/2.2.11 (Win32)
   StrCpy $apache_version "2.4.19"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.19" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.18"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.18" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.17"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.17" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.16"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.16" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.15"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.15" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.14"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.14" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.13"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.13" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.12"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.12" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.11"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.11" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.10"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.10" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.9"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.9" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.8"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.8" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.7"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.7" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.6"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.6" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.5"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.5" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.4"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.4" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.3"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.3" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.2"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.2" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.4.1"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.4.1" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.29"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.29" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.28"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.28" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.27"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.27" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.26"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.26" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.25"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.25" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.24"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.24" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.23"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.23" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.22"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.22" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.21"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.21" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.20"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.20" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.19"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.19" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.18"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.18" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.17"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.17" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.16"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.16" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.15"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.15" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.14"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.14" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.13"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.13" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.11"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.11" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   StrCpy $apache_version "2.2.10"
   ReadRegStr $7 HKLM "SOFTWARE\Apache Software Foundation\Apache\2.2.10" "ServerRoot"
   StrCmp $7 "" 0 check_upgrade
   ReadRegStr $7 HKLM "${XAMPP}" "InstallLocation"
   StrCmp $7 "" 0 xampp_found
   StrCpy $7 "$7\"
   MessageBox MB_YESNO "Apache server not found. Do you want to continue ?" IDYES true IDNO false
   true:
   goto check_upgrade
   false:
   goto abort
   next:
   ;goto splash
   
   ;ReadRegStr $R0 HKLM "SOFTWARE\Apache Software Foundation\Apache\$apache_version" "ServerRoot"

  xampp_found:
  StrCpy $xampp_cfg 1
  goto check_upgrade
  
 check_upgrade:
 StrCpy $upgrade 0
 ClearErrors
 ReadRegStr $6 "${PRODUCT_UNINST_ROOT_KEY}" "${PRODUCT_UNINST_KEY}" "DisplayVersion"
 StrCmp $6 "" 0 +3
 StrCpy $R0 $7
 goto +7
 StrCmp $6 "${PRODUCT_VERSION}" 0 +3
 MessageBox MB_OK "W3Perl $6 already installed."
 goto abort
 StrCpy $upgrade 1
 MessageBox MB_OK "W3Perl $6 have been found. Will upgrade to ${PRODUCT_VERSION}"
 ReadRegStr $R0 "${PRODUCT_UNINST_ROOT_KEY}" "${PRODUCT_DIR_REGKEY}" ""
 StrCpy $INSTDIR $R0
 ;MessageBox MB_OK "Install in $INSTDIR"

 StrCmp $upgrade 1 0 +2
 StrCpy $INSTDIR "$R0\"
 
 goto splash

 splash:
   Banner::destroy
   ;File /oname=$PLUGINSDIR\splash.bmp splash.bmp

   advsplash::show 1800 350 187 -1 $PLUGINSDIR\splash

   Pop $0 ; $0 has '1' if the user closed the splash screen early,
       ; '0' if everything closed normal, and '-1' if some error occurred.
   Return

 abort:
   Banner::destroy
   Abort
;  !insertmacro MUI_LANGDLL_DISPLAY

FunctionEnd

;-----------------------------------------------------------------------------------------

Section "SectionPrincipale" SEC01

  StrCpy $PerlPath "$5"
  StrCpy $PerlPath "$PerlPath" -9
 
  SetOutPath "$INSTDIR\htdocs\w3perl"
  SetOverwrite ifnewer
  
  WriteINIStr "$INSTDIR\htdocs\w3perl\Config.txt" "Data" "PerlPath" "$PerlPath"
  WriteINIStr "$INSTDIR\htdocs\w3perl\Config.txt" "Data" "InstallPath" "$INSTDIR\htdocs\w3perl"
  WriteINIStr "$INSTDIR\htdocs\w3perl\Config.txt" "Data" "WebRoot" "$INSTDIR\htdocs"
  WriteINIStr "$INSTDIR\htdocs\w3perl\Config.txt" "Data" "CGIPath" "$INSTDIR\cgi-bin\w3perl"
  WriteINIStr "$INSTDIR\htdocs\w3perl\Config.txt" "Data" "CGIServer" "$INSTDIR\cgi-bin"
  IntCmp $xampp_cfg 0 0 0 +3
  WriteINIStr "$INSTDIR\htdocs\w3perl\Config.txt" "Data" "LogFileServer" "$INSTDIR\logs"
  goto +2
  WriteINIStr "$INSTDIR\htdocs\w3perl\Config.txt" "Data" "LogFileServer" "$INSTDIR\apache\logs"
  WriteINIStr "$INSTDIR\htdocs\w3perl\Config.txt" "Data" "ConfigFile" "${ConfigWin}"

  FileOpen $0 $INSTDIR\htdocs\w3perl\InitStats.bat w
  FileWrite $0 "$\"$INSTDIR\cgi-bin\w3perl\cron-w3perl.pl$\" -c $\"$INSTDIR\cgi-bin\w3perl\${ConfigWin}${PERLEXT}$\" -a"
  FileClose $0

  FileOpen $0 $INSTDIR\htdocs\w3perl\UpdateStats.bat w
  FileWrite $0 "$\"$INSTDIR\cgi-bin\w3perl\cron-w3perl.pl$\" -c $\"$INSTDIR\cgi-bin\w3perl\${ConfigWin}${PERLEXT}$\" -e"
  FileClose $0
  
  SetOverwrite On
  File /r "${NSISDIR}\w3perl\*"
  
  StrCmp $5 perl.exe 0 +2
  SearchPath $5 perl.exe
  StrCmp $5 "" 0 +2
  StrCpy $5 perl.exe
  
  ;ReadRegStr $6 "${PRODUCT_UNINST_ROOT_KEY}" "${PRODUCT_UNINST_KEY}" "DisplayVersion"
  ;StrCmp $6 "" 0 +3
  ;nsExec::Exec '$5 "$INSTDIR\htdocs\w3perl\install.pl" -g "$INSTDIR\htdocs\w3perl\Config.txt"'
  ;goto +2
  ;nsExec::Exec '$5 "$INSTDIR\htdocs\w3perl\upgrade.pl"'

  IntCmp $upgrade 0 0 0 +3
  nsExec::Exec '$5 "$INSTDIR\htdocs\w3perl\install.pl" -g "$INSTDIR\htdocs\w3perl\Config.txt"'
  goto +2
  nsExec::Exec '$5 "$INSTDIR\htdocs\w3perl\upgrade.pl" -g "$INSTDIR\htdocs\w3perl\Config.txt"'
  
SectionEnd

;-----------------------------------------------------------------------------------------

Function LaunchLink
  ExecShell open ${PRODUCT_WEB_ADMIN}
FunctionEnd

;-----------------------------------------------------------------------------------------

Section -AdditionalIcons
  
  WriteIniStr "$INSTDIR\htdocs\w3perl\Admin.url" "InternetShortcut" "URL" "${PRODUCT_WEB_ADMIN}"
  WriteIniStr "$INSTDIR\htdocs\w3perl\Admin.url" "InternetShortcut" "IconFile" "$INSTDIR\w3perl\resources\favicon.ico"
  WriteIniStr "$INSTDIR\htdocs\w3perl\Admin.url" "InternetShortcut" "IconIndex" "0"
  
  WriteIniStr "$INSTDIR\htdocs\w3perl\Whats new.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE_NEW}?${PRODUCT_VERSION}"
  WriteIniStr "$INSTDIR\htdocs\w3perl\Whats new.url" "InternetShortcut" "IconFile" "$INSTDIR\w3perl\resources\favicon.ico"
  WriteIniStr "$INSTDIR\htdocs\w3perl\Whats new.url" "InternetShortcut" "IconIndex" "0"
  
  WriteIniStr "$INSTDIR\htdocs\w3perl\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE_HOME}"
  WriteIniStr "$INSTDIR\htdocs\w3perl\${PRODUCT_NAME}.url" "InternetShortcut" "IconFile" "$INSTDIR\w3perl\resources\favicon.ico"
  WriteIniStr "$INSTDIR\htdocs\w3perl\${PRODUCT_NAME}.url" "InternetShortcut" "IconIndex" "0"
  
  WriteIniStr "$INSTDIR\htdocs\w3perl\ViewStats.url" "InternetShortcut" "URL" "${PRODUCT_OUTPUT_STATS}"
  WriteIniStr "$INSTDIR\htdocs\w3perl\ViewStats.url" "InternetShortcut" "IconFile" "$INSTDIR\w3perl\resources\favicon.ico"
  WriteIniStr "$INSTDIR\htdocs\w3perl\ViewStats.url" "InternetShortcut" "IconIndex" "0"
  
  SetShellVarContext all
  CreateDirectory "$SMPROGRAMS\W3Perl"
  CreateShortCut "$SMPROGRAMS\W3Perl\Admin.lnk" "$INSTDIR\htdocs\w3perl\Admin.url" "" "$INSTDIR\htdocs\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\Whats new.lnk" "$INSTDIR\htdocs\w3perl\Whats new.url" "" "$INSTDIR\htdocs\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\${PRODUCT_NAME}.lnk" "$INSTDIR\htdocs\w3perl\${PRODUCT_NAME}.url" "" "$INSTDIR\htdocs\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\Init Stats.lnk" "$INSTDIR\htdocs\w3perl\InitStats.bat" "" "$INSTDIR\htdocs\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\Update Stats.lnk" "$INSTDIR\htdocs\w3perl\UpdateStats.bat" "" "$INSTDIR\htdocs\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\View Stats.lnk" "$INSTDIR\htdocs\w3perl\ViewStats.url" "" "$INSTDIR\htdocs\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\Uninstall.lnk" "$INSTDIR\htdocs\w3perl\uninst.exe"
SectionEnd

;-----------------------------------------------------------------------------------------

Section -Post
  WriteUninstaller "$INSTDIR\htdocs\w3perl\uninst.exe"
  ;WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\htdocs\w3perl\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$\"H:\nsis\logo_32x32.ico$\""
SectionEnd

;-----------------------------------------------------------------------------------------

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) has been successfully removed from your computer"
FunctionEnd

;-----------------------------------------------------------------------------------------

Function un.onInit
;!insertmacro MUI_UNGETLANGUAGE
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to remove $(^Name)?" IDYES +2
  Abort
FunctionEnd

;-----------------------------------------------------------------------------------------

Function skip_install
  StrCmp $upgrade 1 0 +2
  Abort
FunctionEnd

;-----------------------------------------------------------------------------------------

Section Uninstall

  ReadRegStr $0 ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_DIR_REGKEY}" ""
  StrCpy $INSTDIR "$0"
  
;MessageBox MB_OK "Are you sure $INSTDIR you want to remove $(^Name)?"

  Delete "$INSTDIR\htdocs\w3perl\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\htdocs\w3perl\Admin.url"
  Delete "$INSTDIR\htdocs\w3perl\Whats new.url"
  Delete "$INSTDIR\htdocs\w3perl\uninst.exe"
  
  Delete "$INSTDIR\htdocs\w3perl\tools\Transfert_log_Unix2Unix\*"
  Delete "$INSTDIR\htdocs\w3perl\tools\Transfert_log_NT2Unix\*"
  Delete "$INSTDIR\htdocs\w3perl\tools\windows\*"
  Delete "$INSTDIR\htdocs\w3perl\tools\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\counter\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\spip\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\os\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\css\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\js\jqplot\plugins\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\js\jqplot\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\js\jvectormap\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\js\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\lang\country\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\lang\help\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\lang\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\homepage\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\help\uk\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\help\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\help\admin\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\flags\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\pays\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\admin\*"
  Delete "$INSTDIR\htdocs\w3perl\resources\*"
  Delete "$INSTDIR\htdocs\w3perl\docs\img\*"
  Delete "$INSTDIR\htdocs\w3perl\docs\uk\*"
  Delete "$INSTDIR\htdocs\w3perl\docs\fr\*"
  Delete "$INSTDIR\htdocs\w3perl\docs\*"
  Delete "$INSTDIR\htdocs\w3perl\logs\*"
  Delete "$INSTDIR\htdocs\w3perl\config\*"
  ;Delete "$INSTDIR\htdocs\w3perl\cgi-bin\w3perl\*"
  ;Delete "$INSTDIR\htdocs\w3perl\cgi-bin\*"
  ;Delete "$INSTDIR\htdocs\w3perl\admin\help\*"
  Delete "$INSTDIR\htdocs\w3perl\admin\config\*"
  Delete "$INSTDIR\htdocs\w3perl\admin\scripts\*"
  Delete "$INSTDIR\htdocs\w3perl\admin\js\*"
  Delete "$INSTDIR\htdocs\w3perl\admin\*"
  Delete "$INSTDIR\htdocs\w3perl\*"
  
  RMDir "$INSTDIR\htdocs\w3perl\tools\Transfert_log_Unix2Unix"
  RMDir "$INSTDIR\htdocs\w3perl\tools\Transfert_log_NT2Unix"
  RMDir "$INSTDIR\htdocs\w3perl\tools\windows"
  RMDir "$INSTDIR\htdocs\w3perl\tools"
  RMDir "$INSTDIR\htdocs\w3perl\resources\counter"
  RMDir "$INSTDIR\htdocs\w3perl\resources\spip"
  RMDir "$INSTDIR\htdocs\w3perl\resources\os"
  RMDir "$INSTDIR\htdocs\w3perl\resources\css"
  RMDir "$INSTDIR\htdocs\w3perl\resources\js\jqplot\plugins"
  RMDir "$INSTDIR\htdocs\w3perl\resources\js\jqplot"
  RMDir "$INSTDIR\htdocs\w3perl\resources\js\jvectormap"
  RMDir "$INSTDIR\htdocs\w3perl\resources\js"
  RMDir "$INSTDIR\htdocs\w3perl\resources\lang\country"
  RMDir "$INSTDIR\htdocs\w3perl\resources\lang\help"
  RMDir "$INSTDIR\htdocs\w3perl\resources\lang"
  RMDir "$INSTDIR\htdocs\w3perl\resources\homepage"
  RMDir "$INSTDIR\htdocs\w3perl\resources\help\uk"
  RMDir "$INSTDIR\htdocs\w3perl\resources\help\admin"
  RMDir "$INSTDIR\htdocs\w3perl\resources\help"
  RMDir "$INSTDIR\htdocs\w3perl\resources\flags"
  RMDir "$INSTDIR\htdocs\w3perl\resources\pays"
  RMDir "$INSTDIR\htdocs\w3perl\resources\admin"
  RMDir "$INSTDIR\htdocs\w3perl\resources"
  RMDir "$INSTDIR\htdocs\w3perl\docs\img"
  RMDir "$INSTDIR\htdocs\w3perl\docs\uk"
  RMDir "$INSTDIR\htdocs\w3perl\docs\fr"
  RMDir "$INSTDIR\htdocs\w3perl\docs"
  RMDir "$INSTDIR\htdocs\w3perl\logs"
  RMDir "$INSTDIR\htdocs\w3perl\config"
  RMDir "$INSTDIR\htdocs\w3perl\cgi-bin\w3perl"
  RMDir "$INSTDIR\htdocs\w3perl\cgi-bin"
  ;RMDir "$INSTDIR\htdocs\w3perl\admin\help"
  RMDir "$INSTDIR\htdocs\w3perl\admin\config"
  RMDir "$INSTDIR\htdocs\w3perl\admin\scripts"
  RMDir "$INSTDIR\htdocs\w3perl\admin\js"
  RMDir "$INSTDIR\htdocs\w3perl\admin"
  RMDir "$INSTDIR\htdocs\w3perl"

  SetShellVarContext all
  Delete "$SMPROGRAMS\W3Perl\Uninstall.lnk"
  Delete "$SMPROGRAMS\W3Perl\Admin.lnk"
  Delete "$SMPROGRAMS\W3Perl\Whats new.lnk"
  Delete "$SMPROGRAMS\W3Perl\Init Stats.lnk"
  Delete "$SMPROGRAMS\W3Perl\Update Stats.lnk"
  Delete "$SMPROGRAMS\W3Perl\View Stats.lnk"
  Delete "$SMPROGRAMS\W3Perl\${PRODUCT_NAME}.lnk"
  RMDir "$SMPROGRAMS\W3Perl"
  
   ;Delete "$INSTDIR\cgi-bin\fly.exe"
   ;Delete "$INSTDIR\cgi-bin\wget.exe"
   ;Delete "$INSTDIR\cgi-bin\gzip.exe"
   ;Delete "$INSTDIR\cgi-bin\bzip2.exe"
   ;Delete "$INSTDIR\cgi-bin\bzip2.dll"
   ;Delete "$INSTDIR\cgi-bin\libeay32.dll"
   ;Delete "$INSTDIR\cgi-bin\libiconv2.dll"
   ;Delete "$INSTDIR\cgi-bin\libintl3.dll"
   ;Delete "$INSTDIR\cgi-bin\libssl32.dll"
   Delete "$INSTDIR\cgi-bin\w3perl\tools\*"
   Delete "$INSTDIR\cgi-bin\w3perl\*"
   RMDir "$INSTDIR\cgi-bin\w3perl\tools"
   RMDir "$INSTDIR\cgi-bin\w3perl"

  
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_DIR_REGKEY}"
  
  SetAutoClose true

  IfFileExists "$INSTDIR\htdocs\w3perl" 0 NoErrorMsg
    MessageBox MB_OK "Note: $INSTDIR\htdocs\w3perl could not be removed!" IDOK 0 ; skipped if file doesn't exist
  NoErrorMsg:
  
SectionEnd
