; Script generated by the HM NIS Edit Script Wizard.

; HM NIS Edit Wizard helper defines
!define PRODUCT_NAME "W3Perl"
!define PRODUCT_VERSION "3.20"
!define PRODUCT_PUBLISHER "Laurent Domisse"
!define PRODUCT_WEB_SITE "http://www.w3perl.com"
!define PRODUCT_WEB_SITE_HOME "http://www.w3perl.com/"
!define PRODUCT_WEB_SITE_NEW "http://www.w3perl.com/demo/docs/uk/new.html"
!define PRODUCT_WEB_ADMIN_URL "w3perl/admin/index.html"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\w3perl-iis.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define VDIRNAME "cgi-bin"
!define VDIROUTPUT "w3stats"
!define DIRCFG "config"
!define DIRRESADM "resources/admin"
!define PERLEXT ".pl";
!define ConfigWin "config-iis"
!define PRODUCT_OUTPUT_STATS_URL "w3stats/index.html"

; todo
; check IIS running
; add index.html
; get logformat
; rmdir -r installdir if DIR_USER set

SetCompressor lzma

Var LogFileDir
Var WebName
Var WebRoot
Var IP
Var Port
Var PerlPath
var PerlPathBin
Var IIS_State
Var Timeout
Var LogType
Var LogPeriod
Var LogTypeFormat
Var DIR_USER
Var DIR_USER_URL
;Var tmp
Var check_value
Var WMI
Var upgrade
Var Metabase

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "w3perl-iis-dev.exe"

RequestExecutionLevel admin

; MUI 1.67 compatible ------
!include "MUI.nsh"
;!include LogicLib.nsh

; MUI Settings
!define MUI_ABORTWARNING

;!define MUI_PAGE_HEADER_TEXT Foo
;!define MUI_PAGE_HEADER_SUBTEXT Toto
!define MUI_WELCOMEPAGE_TEXT "This wizard will guide you through the installation of W3Perl ${PRODUCT_VERSION}, a free logfile analyzer.\r\n\rW3Perl is able to parse Web / FTP / Squid / CUPS / SSH / DHCP and mail logfiles."

!define MUI_ICON "E:\nsis\logo_32x32.ico"
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "E:\nsis\header.bmp"
!define MUI_HEADERIMAGE_RIGHT
!define MUI_WELCOMEFINISHPAGE_BITMAP "E:\nsis\headerimage.bmp"

; Welcome page
!define MUI_PAGE_CUSTOMFUNCTION_PRE skip_install
!insertmacro MUI_PAGE_WELCOME

; License page
!define MUI_PAGE_CUSTOMFUNCTION_PRE skip_install
!insertmacro MUI_PAGE_LICENSE "${NSISDIR}\w3perl\resources\gpl.txt"

;!insertmacro MUI_PAGE_DIRECTORY
Page custom PickWebsite ValidateCustom

; Instfiles page
!insertmacro MUI_PAGE_INSTFILES

; Finish page
!define MUI_FINISHPAGE_RUN
!define MUI_FINISHPAGE_RUN_TEXT "Configure W3Perl"
!define MUI_FINISHPAGE_RUN_FUNCTION "LaunchLink"
!define MUI_FINISHPAGE_TEXT "You should now create a configuration file using the web wizard.\r\n\rSome templates are available. Default configuration file for your server is config-iis"

!insertmacro MUI_PAGE_FINISH

; Uninstaller pages
!insertmacro MUI_UNPAGE_INSTFILES

; Language files
!insertmacro MUI_LANGUAGE "English"
;!insertmacro MUI_LANGUAGE "French"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

; MUI end ------

;Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
;OutFile "w3perl-iis-dev.exe"
ShowInstDetails show
ShowUnInstDetails show

;-----------------------------------------------------------------------------------------

Function .onInit
 Banner::show /NOUNLOAD "Checking for Perl and Webserver..."

 ReadRegStr $PerlPath HKLM "Software\Perl" "BinDir"
 StrCmp $PerlPath "" 0 +6
 SetRegView 64
 ReadRegStr $PerlPath HKLM "Software\Perl" "BinDir"
 SetRegView 32
 StrCmp $PerlPath "" 0 +2
 StrCpy $PerlPath perl.exe
 nsExec::Exec '"$PerlPath" -v'
 Pop $0
 StrCmp $0 0 checkIIS
   MessageBox MB_YESNOCANCEL|MB_ICONEXCLAMATION "The installer can not find Perl \
    on this computer!$\r$\nPlease install Perl and run this \
    installer again.$\r$\nPress cancel if you are sure you have Perl \
    installed.$\r$\n$\r$\nWould you like the installer to open Perl's download page \
    for you?" IDNO abort IDCANCEL splash
     ExecShell open http://www.activestate.com/activeperl/downloads
     Goto abort
   
 CheckIIS:
   ClearErrors
   ReadRegDWORD $0 HKLM "SOFTWARE\Microsoft\InetStp" "MajorVersion"
   ReadRegDWORD $1 HKLM "SOFTWARE\Microsoft\InetStp" "MinorVersion"
   IfErrors 0 CheckVersion
   MessageBox MB_OK|MB_ICONSTOP "Setup could not detect Microsoft Internet Information Server; \
   this is required for installation. Setup will abort." IDOK IISWeb
   
   IISWeb:
   ExecShell open http://www.iis.net/
   goto abort
   
   CheckVersion:
   IntCmp $0 5 check_iis7 IISMajVerLT5 check_iis7

    IISMajVerLT5:
	 MessageBox MB_OK|MB_ICONEXCLAMATION "Setup could not detect Microsoft Internet Information Server v5 or later; \
          . Setup will abort."
         ExecShell open http://www.microsoft.com/iis
         Goto abort

check_iis7:
 ClearErrors
 IntCmp $0 7 check_iis7_metabase check_upgrade check_iis7_metabase
 StrCpy $WMI 0

check_iis7_metabase:
StrCpy $metabase 0
ReadRegStr $6 "HKLM" "SOFTWARE\Microsoft\InetStp\Components" "ADSICompatibility"
StrCmp $6 1 +2 0
StrCpy $metabase 1
ReadRegStr $6 "HKLM" "SOFTWARE\Microsoft\InetStp\Components" "CGI"
StrCmp $6 1 +2 0
StrCmp $metabase 1 IIS7MetabaseCGI IIS7CGI
StrCmp $metabase 1 IIS7Metabase check_upgrade

IIS7Metabase:
	 MessageBox MB_OK|MB_ICONEXCLAMATION "Setup could not detect IIS 6 metabase compatibility. Setup will abort."
         ExecShell open http://www.w3perl.com/demo/docs/uk/windows_iis.html
         Goto abort

IIS7MetabaseCGI:
	 MessageBox MB_OK|MB_ICONEXCLAMATION "Setup could not detect IIS 6 metabase compatibility and CGI components. Setup will abort."
         ExecShell open http://www.w3perl.com/demo/docs/uk/windows_iis.html
         Goto abort
         
;check_cgi:
;ReadRegStr $6 "HKLM" "SOFTWARE\Microsoft\InetStp\Components" "CGI"
;StrCmp $6 "" +2 0
;goto check_upgrade
;goto IIS7CGI

IIS7CGI:
	 MessageBox MB_OK|MB_ICONEXCLAMATION "Setup could not detect IIS CGI components. Setup will abort."
         ExecShell open http://www.w3perl.com/demo/docs/uk/windows_iis.html
         Goto abort
         
check_upgrade:
 StrCpy $upgrade 0
 ReadRegStr $6 "${PRODUCT_UNINST_ROOT_KEY}" "${PRODUCT_UNINST_KEY}" "DisplayVersion"
 StrCmp $6 "" 0 +3
 ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\InetStp" "PathWWWRoot"
 goto +7
 StrCmp $6 "${PRODUCT_VERSION}" 0 +3
 MessageBox MB_OK "W3Perl $6 already installed."
 goto abort
 MessageBox MB_OK "W3Perl $6 have been found. Will upgrade to ${PRODUCT_VERSION}"
 ReadRegStr $R0 "${PRODUCT_UNINST_ROOT_KEY}" "${PRODUCT_DIR_REGKEY}" ""
 StrCpy $upgrade 1
 StrCpy $INSTDIR $R0
 
 StrCmp $upgrade 1 0 +2
 StrCpy $INSTDIR "$R0\"
 
 ;MessageBox MB_OK "Install in $INSTDIR"
 InitPluginsDir
 ;File /oname=$PLUGINSDIR\pick_website.ini pick_website.ini
 goto splash
 
 splash:
   Banner::destroy
   ;File /oname=$PLUGINSDIR\splash.bmp splash.bmp

   ;File /oname=$PLUGINSDIR\splash.bmp splash.bmp

   advsplash::show 1800 350 187 -1 $PLUGINSDIR\splash

   Pop $0 ; $0 has '1' if the user closed the splash screen early,
       ; '0' if everything closed normal, and '-1' if some error occurred.
       ;call WriteIni
   Return

 abort:
   Banner::destroy
   Abort
;  !insertmacro MUI_LANGDLL_DISPLAY

FunctionEnd

;-----------------------------------------------------------------------------------------

Function GetWebsitesWMI
 ; Output the VBScript
 FileOpen $4 "$PLUGINSDIR\GetWebsites.vbs" w
 FileWrite $4 'Set objFSO = CreateObject("Scripting.FileSystemObject")$\r$\n'
 FileWrite $4 'Set objTextFile = objFSO.OpenTextFile("$PLUGINSDIR\websites.ini", 8, True)$\r$\n'
 FileWrite $4 'AllSites = ""$\r$\n'
 FileWrite $4 'Set objWMIService = GetObject ("winmgmts:{authenticationLevel=pktPrivacy}\\localhost\root\microsoftiisv2")$\r$\n'
 FileWrite $4 'Set colItems = objWMIService.ExecQuery("Select * from IIsWebServerSetting")$\r$\n'
 FileWrite $4 'For Each objItem in colItems$\r$\n'
 FileWrite $4 'AllSites = AllSites & "|" & objItem.Description$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("[" & objItem.Description & "]")$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("Name=" & objItem.Name)$\r$\n' 
 FileWrite $4 'objTextFile.WriteLine("LogDir=" & objItem.LogFileDirectory & "\w3svc" & objItem.Name)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("LogTypeFormat=" & IISWebSite.LogExtFileFLags)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("LogType=" & ReturnLogFileformat(objItem.LogPluginClsid))$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("LogPeriod=" & objItem.LogFilePeriod)$\r$\n'
 FileWrite $4 'Set servObj= objWMIService.get("IIsWebServer=$\'W3SVC/" & objItem.Name & "$\'")$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("Status=" & servObj.ServerState)$\r$\n'
 FileWrite $4 'Set vdirObj= objWMIService.get("IIsWebVirtualDirSetting=$\'W3SVC/" & objItem.Name & "/ROOT$\'")$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("WebRoot=" & vdirObj.Path)$\r$\n'	
 FileWrite $4 'objTextFile.WriteLine("IP=" & objItem.ServerBindings(0).IP)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("Timeout=" & objItem.CGITimeout)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("Port=" & objItem.ServerBindings(0).Port)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("WebName=" & objItem.ServerBindings(0).Hostname)$\r$\n'
 FileWrite $4 'next$\r$\n'

 FileWrite $4 'objTextFile.WriteLine("[Websites]")$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("AllSites=" & Right(AllSites, Len(AllSites)-1))$\r$\n'
 FileWrite $4 'objTextFile.Close$\r$\n'

 FileWrite $4 'Set objFSO = Nothing$\r$\n'
 FileWrite $4 'Set objTextFile = Nothing$\r$\n'

 FileWrite $4 'Function ReturnLogfileFormat(CLSID)$\r$\n'
 FileWrite $4 'Set logItems = objWMIService.ExecQuery ("Select * from IIsLogModuleSetting")$\r$\n'
 FileWrite $4 'For Each logItem in logItems$\r$\n'
 FileWrite $4 '    if (logItem.LogModuleId = CLSID) Then$\r$\n'
 FileWrite $4 '    ReturnLogfileFormat = logItem.Name$\r$\n'
 FileWrite $4 '    exit Function$\r$\n'
 FileWrite $4 'end if$\r$\n'
 FileWrite $4 'Next$\r$\n'
 FileWrite $4 'ReturnLogfileFormat = "Unknown Format"$\r$\n'
 FileWrite $4 'exit Function$\r$\n'
 FileWrite $4 'end if$\r$\n'
 FileWrite $4 'ReturnLogfileFormat = "No Log File Format Configured"$\r$\n'
 FileWrite $4 'end function$\r$\n'

 FileClose $4

 ; Execute the script
 nsExec::Exec /TIMEOUT=20000 '"$SYSDIR\cscript.exe" "$PLUGINSDIR\GetWebsites.vbs"'

FunctionEnd

;-----------------------------------------------------------------------------------------

Function GetWebsitesADSI
 ; Output the VBScript
 FileOpen $4 "$PLUGINSDIR\GetWebsites.vbs" w
 
 FileWrite $4 'IISObjectPath = "IIS://localhost/w3svc"$\r$\n'
 ;FileWrite $4 'Set IISOBJ = getObject("IIS://localhost/" & "w3svc")$\r$\n'
 FileWrite $4 'Set IISOBJ = getObject(IISObjectPath)$\r$\n'
 FileWrite $4 'Set objFSO = CreateObject("Scripting.FileSystemObject")$\r$\n'
 FileWrite $4 'Set objTextFile = objFSO.OpenTextFile("$PLUGINSDIR\websites.ini", 8, True)$\r$\n'
 FileWrite $4 'AllSites = ""$\r$\n'
 FileWrite $4 'for each Web in IISOBJ$\r$\n'
 FileWrite $4 'if (Web.Class = "IIsWebServer") then$\r$\n'
 FileWrite $4 'BindingPath = IISObjectPath & "/" & Web.Name$\r$\n'
 FileWrite $4 'Set IISWebSite = getObject("IIS://localhost/" & "w3svc" & "/" & Web.Name)$\r$\n'
 FileWrite $4 'Set IISWebSiteRoot = getObject("IIS://localhost/" & "w3svc" & "/" & Web.Name & "/root")$\r$\n'
 FileWrite $4 'AllSites = AllSites & "|" & IISWebSite.ServerComment$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("[" & IISWebSite.ServerComment & "]")$\r$\n'
; FileWrite $4 'objTextFile.WriteLine("Path=" & IISWebSiteRoot.Path)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("Name=" & Web.Name)$\r$\n'
 
 FileWrite $4 'objTextFile.WriteLine("LogDir=" & IISWebSite.LogFileDirectory & "\w3svc" & Web.Name)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("LogTypeFormat=" & IISWebSite.LogExtFileFLags)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("LogType=" & ReturnLogFileformat(IISWebSite.LogPluginClsId))$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("LogPeriod=" & IISWebSite.LogFilePeriod)$\r$\n'
 
 FileWrite $4 'objTextFile.WriteLine("Status=" & Web.ServerState)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("WebRoot=" & IISWebSiteRoot.Path)$\r$\n'
 FileWrite $4 'Set IISObjectIP = GetObject(BindingPath)$\r$\n'
 FileWrite $4 'ValueList = IISObjectIP.Get("ServerBindings")$\r$\n'
 FileWrite $4 'ValueString = ""$\r$\n'
 FileWrite $4 'For ValueIndex = 0 To UBound(ValueList)$\r$\n'
 FileWrite $4 'value = ValueList(ValueIndex)$\r$\n'
 FileWrite $4 'values = split(value,":")$\r$\n'
 FileWrite $4 'IP = values(0)$\r$\n'
 FileWrite $4 'if (IP = "") then$\r$\n'
 FileWrite $4 'IP = values(2)$\r$\n'
 FileWrite $4 'end if$\r$\n'
 FileWrite $4 'if (values(2) = "") then$\r$\n'
 FileWrite $4 'IP = "127.0.0.1"$\r$\n'
 FileWrite $4 'end if$\r$\n'
 FileWrite $4 'TCP = values(1)$\r$\n'
 FileWrite $4 'if (TCP = "") then$\r$\n'
 FileWrite $4 'TCP = "80"$\r$\n'
 FileWrite $4 'end if$\r$\n'
 FileWrite $4 'HostHeader = values(2)$\r$\n'
 FileWrite $4 'next$\r$\n'
; FileWrite $4 'IISObjectIP = Nothing$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("IP=" & IP)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("Timeout=" & IISWebSite.CGITimeout)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("Port=" & TCP)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("WebName=" & HostHeader)$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("")$\r$\n'
 FileWrite $4 'Set IISWebSiteRoot = nothing$\r$\n'
 FileWrite $4 'Set IISWebsiteLogDir = nothing$\r$\n'
 FileWrite $4 'Set IISWebSite = Nothing$\r$\n'
 FileWrite $4 'end if$\r$\n'
 FileWrite $4 'next$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("[Websites]")$\r$\n'
 FileWrite $4 'objTextFile.WriteLine("AllSites=" & Right(AllSites, Len(AllSites)-1))$\r$\n'
 FileWrite $4 'objTextFile.Close$\r$\n'
 ;
 ;FileWrite $4 'IISWebSite.Stop$\r$\n'
 ;FileWrite $4 'IISWebSite.CGITimeout = 1000$\r$\n'
 ;FileWrite $4 'IISWebSite.SetInfo$\r$\n'
 ;FileWrite $4 'IISWebSite.Start$\r$\n'
 FileWrite $4 'Set objFSO = Nothing$\r$\n'
 FileWrite $4 'Set objTextFile = Nothing$\r$\n'
 FileWrite $4 'Set IISOBj = Nothing$\r$\n'


 FileWrite $4 'Function ReturnLogfileFormat(CLSID)$\r$\n'
 FileWrite $4 'Set LoggingModules = GetObject("IIS://localhost/logging")$\r$\n'
 FileWrite $4 'If CLSID <> "" Then$\r$\n'
 FileWrite $4 ' for Each LogModule in LoggingModules$\r$\n'
 FileWrite $4 ' if (LogModule.Class = "IIsLogModule") then$\r$\n'
 FileWrite $4 ' if LogModule.LogModuleID = CLSID Then$\r$\n'
 FileWrite $4 ' ReturnLogfileFormat = LogModule.Name$\r$\n'
 FileWrite $4 'exit Function$\r$\n'
 FileWrite $4 'end if$\r$\n'
 FileWrite $4 'end if$\r$\n'
 FileWrite $4 'Next$\r$\n'
 FileWrite $4 'ReturnLogfileFormat = "Unknown Format"$\r$\n'
 FileWrite $4 'exit Function$\r$\n'
 FileWrite $4 'end if$\r$\n'
 FileWrite $4 'ReturnLogfileFormat = "No Log File Format Configured"$\r$\n'
 FileWrite $4 'end function$\r$\n'
 
 FileClose $4
 
 ; Execute the script
 nsExec::Exec /TIMEOUT=20000 '"$SYSDIR\cscript.exe" "$PLUGINSDIR\GetWebsites.vbs"'

 ; Read the value and put it in the page's INI
 ;ReadINIStr $R0 "$PLUGINSDIR\websites.ini" "Websites" "AllSites"
 ;WriteINIStr "$PLUGINSDIR\pick_website.ini" "Field 2" "ListItems" $0
FunctionEnd

;-----------------------------------------------------------------------------------------

function WriteIni

WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Settings' 'NumFields' '4'

WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 1' 'Type' 'Label'
WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 1' 'Text' 'Please Select which Web Site to set the application to use:'
WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 1' 'Left' '0'
WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 1' 'Right' '-1'
WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 1' 'Top' '0'
WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 1' 'Bottom' '10'

WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 2' 'Type' 'Droplist'
WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 2' 'Text' 'droplist'
WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 2' 'ListItems' ''
WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 2' 'Left' '25'
WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 2' 'Right' '150'
WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 2' 'Top' '10'
WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 2' 'Bottom' '1000'

;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 3' 'Type' 'label'
;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 3' 'Text' 'Directory for the application (leave blank for default) :'
;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 3' 'Left' '0'
;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 3' 'Right' '-1'
;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 3' 'Top' '30'
;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 3' 'Bottom' '40'

;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 4' 'Type' 'text'
;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 4' 'Text' 'webPath'
;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 4' 'State' ''
;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 4' 'Left' '25'
;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 4' 'Right' '150'
;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 4' 'Top' '40'
;WriteIniStr '$PLUGINSDIR\pick_website.ini' 'Field 4' 'Bottom' '52'

FunctionEnd

;-----------------------------------------------------------------------------------------

Function ValidateCustom
 ;SetShellVarContext All
 StrCmp $upgrade 1 0 +2
 Abort
 !insertmacro MUI_INSTALLOPTIONS_READ $check_value "pick_website.ini" "Field 2" "State"
 StrCmp $check_value "" 0 +3
 MessageBox MB_ICONEXCLAMATION|MB_OK "Please select a web server"
 Abort
 ReadINIStr $IIS_State "$PLUGINSDIR\websites.ini" "$check_value" "Status"
 StrCmp $IIS_State 2 +3 0
 MessageBox MB_ICONEXCLAMATION|MB_OK "This website is not running"
 Abort
FunctionEnd

;-----------------------------------------------------------------------------------------

Function PickWebsite
 ;ReserveFile "pick_website.ini"
 
 StrCmp $upgrade 1 0 +2
 Abort
  
 IntCmp $WMI 1 0 +3 0
 Call GetWebsitesWMI
 goto +2
 Call GetWebsitesADSI
 Call WriteIni
 ReadINIStr $0 "$PLUGINSDIR\websites.ini" "Websites" "AllSites"
 WriteINIStr "$PLUGINSDIR\pick_website.ini" "Field 2" "ListItems" $0
 ;!insertmacro MUI_INSTALLOPTIONS_EXTRACT "pick_website.ini"
 !insertmacro MUI_HEADER_TEXT "Webserver Configuration" "Choose the website and path that your installation will reside at."
 !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "pick_website.ini"
 !insertmacro MUI_INSTALLOPTIONS_SHOW
 ;!insertmacro MUI_HEADER_TEXT "Webserver Configuration" "Choose the website and path that your installation will reside at."
 ;!insertmacro MUI_INSTALLOPTIONS_EXTRACT "pick_website.ini"
 ;!insertmacro MUI_INSTALLOPTIONS_DISPLAY "pick_website.ini"
FunctionEnd

;-----------------------------------------------------------------------------------------

Function StrSlash
Exch $R3
Exch
Exch $R1
Push $R2
Push $R4
Push $R6
Push $R7
StrCpy $R2 ""
StrLen $R6 $R1
StrCpy $R4 "\"
StrCmp $R3 "/" loop
StrCpy $R4 "/"
loop:
StrCpy $R7 $R1 1
StrCpy $R1 $R1 $R6 1
StrCmp $R7 $R3 found
StrCpy $R2 "$R2$R7"
StrCmp $R1 "" done loop
found:
StrCpy $R2 "$R2$R4"
StrCmp $R1 "" done loop
done:
StrCpy $R3 $R2
Pop $R7
Pop $R6
Pop $R4
Pop $R2
Pop $R1
Exch $R3
FunctionEnd

;-----------------------------------------------------------------------------------------

Function CreateVDirWMI

;http://forums.iis.net/t/1150945.aspx
;http://www.vbrad.com/article.aspx?id=15
;http://msdn.microsoft.com/en-us/library/ms689436.aspx

DetailPrint "Creating $TEMP\createVDir.vbs";
FileOpen $0 "$TEMP\createVDir.vbs" w
FileWrite $0 'Set objWMIService = GetObject ("winmgmts:{authenticationLevel=pktPrivacy}\\localhost\root\microsoftiisv2")$\r$\n'
;FileWrite $0 'objWMIService.Get("VirtualDirectory").Create strVDirPath, strAppPath, ${VDIRNAME}, $INSTDIR\${VDIRNAME}$\n'

FileWrite $0 'Set vdirClassObj = objWMIService.Get("IIsWebVirtualDirSetting")$\r$\n'
FileWrite $0 'Set vdirObj = vdirClassObj.SpawnInstance_()$\r$\n'
FileWrite $0 'vdirObj.Name = "W3SVC/" & $WebName & "/Root/" & ${VDIRNAME} & "$\r$\n'
FileWrite $0 "vdirObj.Path = $\"$INSTDIR\${VDIRNAME}$\"$\n"
FileWrite $0 'vdirObj.AccessFlags = 517$\r$\n'
FileWrite $0 'vdirObj.AppFriendlyName = "${VDIRNAME}"$\r$\n' 
FileWrite $0 "vdirObj.EnableDirBrowsing = False$\n"
FileWrite $0 "vdirObj.ContentIndexed = False$\n"
FileWrite $0 "vdirObj.DontLog = True$\n"
FileWrite $0 "vdirObj.EnableDefaultDoc = True$\n"
;FileWrite $0 "Dir.DefaultDoc = $\"index.html$\"$\n"
FileWrite $0 "vdir.CGITimeout = 36000$\n"
FileWrite $0 'vdirObj.Put_()$\r$\n'

;http://www.developmentnow.com/g/59_2006_7_0_0_797098/Add-new-MimeType.htm
;http://www.xt1.org/blog/2006/03/adsi-and-wmi
;http://www.winserverkb.com/Uwe/Forum.aspx/iis/4938/IIS-6-Metabase-editing-with-WMI-MULTISZ-values-problem

;FileWrite $0 "$\n"
;FileWrite $0 'Set server = objWMIService.Get("IIsWebVirtualDirSetting=$\'W3SVC/' & WebName & '/ROOT$\'")$\r$\n'
;FileWrite $0 'Set mimemap = objWMIService.Get("MimeMap").SpawnInstance_();$\r$\n'
;FileWrite $0 'mimemaps.Extension = ".foo"$\r$\n'
;FileWrite $0 'mimemaps.MimeType = "application/foo"$\r$\n'
;FileWrite $0 'server.MimeMap = mimemaps$\r$\n'
;FileWrite $0 'server.Put_()$\r$\n'

;FileWrite $0 'Set mimemap = vdirClassObj.SpawnInstance_()$\r$\n'
;FileWrite $0 'vdirObj.Name = "W3SVC/" & $WebName & "/Root/" & ${VDIRNAME} & "$\r$\n'

FileClose $0

DetailPrint "Executing $TEMP\createVDir.vbs"
nsExec::Exec /TIMEOUT=20000 '"$SYSDIR\cscript.exe" "$TEMP\createVDir.vbs"'
Pop $1
StrCmp $1 "0" CreateVDirOK
DetailPrint "Error $1 in CreateVDir.vbs"
Abort "Failed to create IIS Virtual Directory"

CreateVDirOK:
;MessageBox MB_YESNO|MB_ICONEXCLAMATION "Successfully created IIS virtual directory"
DetailPrint "Successfully created IIS virtual directory"
Delete "$TEMP\createVDir.vbs"
FunctionEnd

;-----------------------------------------------------------------------------------------

Function CreateVDirADSI
;Var /Global tVAR
;Open a VBScript File in the temp dir for writing
DetailPrint "Creating $TEMP\createVDir.vbs";
FileOpen $0 "$TEMP\createVDir.vbs" w

;Write the script:
;Create a virtual dir named ${VDIRNAME} pointing to $INSTDIR\w3perl\web with proper attributes
;FileWrite $0 "Option Explicit$\n"
;FileWrite $0 "Dim IISPath$\n"
FileWrite $0 "Set Root = GetObject($\"IIS://LocalHost/W3SVC/$WebName/ROOT$\")$\n"
FileWrite $0 "Set Dir = Root.Create($\"IIsWebVirtualDir$\", $\"${VDIRNAME}$\")$\n"
FileWrite $0 "Dir.Path = $\"$INSTDIR\${VDIRNAME}$\"$\n"
FileWrite $0 "Dir.AccessRead = True$\n"
FileWrite $0 "Dir.AccessWrite = False$\n"
FileWrite $0 "Dir.AccessScript = True$\n"
FileWrite $0 "Dir.AccessExecute = True$\n"
FileWrite $0 "Dir.AppFriendlyName = $\"${VDIRNAME}$\"$\n"
FileWrite $0 "Dir.EnableDirBrowsing = False$\n"
FileWrite $0 "Dir.ContentIndexed = False$\n"
FileWrite $0 "Dir.DontLog = True$\n"
FileWrite $0 "Dir.EnableDefaultDoc = True$\n"
;FileWrite $0 "Dir.DefaultDoc = $\"index.html$\"$\n"
FileWrite $0 "Dir.AspBufferingOn = True$\n"
FileWrite $0 "Dir.AspAllowSessionState = True$\n"
FileWrite $0 "Dir.AspSessionTimeout = 30$\n"
FileWrite $0 "Dir.AspScriptTimeout = 900$\n"
;FileWrite $0 "Dir.CGITimeout = 36000$\n"
FileWrite $0 "Dir.SetInfo$\n"

FileWrite $0 "$\n"
FileWrite $0 "Dim Pos, NewScriptMaps, ArgNewMap $\n"
FileWrite $0 "ArgNewMap = $\"${PERLEXT},$PerlPath $\"$\"%s$\"$\" %s,1,GET,POST$\"$\n"
FileWrite $0 "if (DoesScriptMapExist(Ext) = false) then$\n"
FileWrite $0 "NewScriptMaps = Dir.ScriptMaps$\n"
FileWrite $0 "Redim preserve NewScriptMaps(Ubound(NewScriptMaps)+1)$\n"
FileWrite $0 "NewScriptMaps(ubound(NewScriptMaps)) = ArgNewMap$\n"
FileWrite $0 "Dir.ScriptMaps = NewScriptMaps$\n"
FileWrite $0 "else$\n"
FileWrite $0 "  WScript.Quit(2)$\n"
FileWrite $0 "end if$\n"
FileWrite $0 "Dir.SetInfo$\n"

FileWrite $0 "$\n"
FileWrite $0 "Function DoesScriptMapExist(Extension)$\n"
FileWrite $0 "    Dim Pos, Items, Ext, ScriptMaps$\n"
FileWrite $0 "DoesScriptMapExist = false$\n"
FileWrite $0 "Ext = ucase(Extension)$\n"
FileWrite $0 "ScriptMaps = Dir.Scriptmaps$\n"
FileWrite $0 "for pos = lbound(ScriptMaps) to UBOund(ScriptMaps)$\n"
FileWrite $0 "  Items = Split(Scriptmaps(Pos), $\",$\")$\n"
FileWrite $0 "        if (ucase(items(0)) = Ext) then$\n"
FileWrite $0 "   DoesScriptMapExist = true$\n"
FileWrite $0 "   exit Function$\n"
FileWrite $0 "  end if$\n"
FileWrite $0 "next$\n"
FileWrite $0 "end function$\n"

FileClose $0

DetailPrint "Executing $TEMP\createVDir.vbs"
nsExec::Exec /TIMEOUT=20000 '"$SYSDIR\cscript.exe" "$TEMP\createVDir.vbs"'
Pop $1
StrCmp $1 "0" CreateVDirOK
DetailPrint "Error $1 in CreateVDir.vbs"
Abort "Failed to create IIS Virtual Directory"

CreateVDirOK:
;MessageBox MB_YESNO|MB_ICONEXCLAMATION "Successfully created IIS virtual directory"
DetailPrint "Successfully created IIS virtual directory"
Delete "$TEMP\createVDir.vbs"
FunctionEnd

;-----------------------------------------------------------------------------------------

; DeleteVDirWMI Function
Function un.DeleteVDirWMI

;  http://209.85.229.132/search?q=cache:GGkfFT6GORUJ:ephemeralvalue.com/%3Fcat%3D3+WMI+VirtualDirectory+delete+method&hl=fr&ct=clnk&cd=6&gl=fr&client=firefox-a

DetailPrint "Creating $TEMP\deleteVDir.vbs";
FileOpen $0 "$TEMP\deleteVDir.vbs" w
FileWrite $0 'Set objWMIService = GetObject ("winmgmts:{authenticationLevel=pktPrivacy}\\localhost\root\microsoftiisv2")$\r$\n'
FileWrite $0 'Set vdirObj= objWMIService.get("IIsWebVirtualDirSetting=$\'W3SVC/" & $WebName & "/ROOT/" & ${VDIRNAME} & "$\'")$\r$\n'
FileWrite $0 'vdirObj.delete_()$\r$\n'
FileClose $0

DetailPrint "Executing $TEMP\deleteVDir.vbs"
nsExec::Exec /TIMEOUT=20000 '"$SYSDIR\cscript.exe" "$TEMP\deleteVDir.vbs"'
Pop $1
StrCmp $1 "0" +2
DetailPrint "Error $1 in deleteVDir.vbs"
goto DeleteVDirEnd
DetailPrint "Virtual Directory ${VDIRNAME} successfully removed."
Delete "$TEMP\deleteVDir.vbs"
DeleteVDirEnd:
FunctionEnd


;-----------------------------------------------------------------------------------------

; DeleteVDirADSI Function
Function un.DeleteVDirADSI
  
;Open a VBScript File in the temp dir for writing
DetailPrint "Creating $TEMP\deleteVDir.vbs";
FileOpen $0 "$TEMP\deleteVDir.vbs" w

;Write the script:
;Delete the application object
FileWrite $0 "Set IISObject = GetObject($\"IIS://localhost/W3SVC/$WebName/ROOT/${VDIRNAME}$\")$\n"
FileWrite $0 "IISObject.AppDelete 'Delete the web application'$\n"
FileWrite $0 "If (Err.Number <> 0) Then$\n"
FileWrite $0 " MsgBox $\"Error trying to delete the application at [IIS://LocalHost/W3SVC/$WebName/ROOT/${VDIRNAME}]$\", vbCritical, $\"${PRODUCT_NAME}$\"$\n"
FileWrite $0 " WScript.Quit (Err.Number)$\n"
FileWrite $0 "End If$\n"

FileWrite $0 "Set IISObject = GetObject($\"IIS://LocalHost/W3SVC/$WebName/ROOT$\")$\n"
FileWrite $0 "IIsObject.Delete $\"IIsWebVirtualDir$\", $\"${VDIRNAME}$\"$\n"
FileWrite $0 "If (Err.Number <> 0) Then$\n"
FileWrite $0 " MsgBox $\"Error trying to delete the virtual directory '${VDIRNAME}' at 'IIS://LocalHost/W3SVC/$WebName/ROOT'$\", vbCritical, $\"${PRODUCT_NAME}$\"$\n"
FileWrite $0 " Wscript.Quit (Err.Number)$\n"
FileWrite $0 "End If$\n"

FileClose $0

DetailPrint "Executing $TEMP\deleteVDir.vbs"
nsExec::Exec /TIMEOUT=20000 '"$SYSDIR\cscript.exe" "$TEMP\deleteVDir.vbs"'
Pop $1
StrCmp $1 "0" +2
DetailPrint "Error $1 in deleteVDir.vbs"
goto DeleteVDirEnd
DetailPrint "Virtual Directory ${VDIRNAME} successfully removed."
Delete "$TEMP\deleteVDir.vbs"
DeleteVDirEnd:
FunctionEnd

;-----------------------------------------------------------------------------------------

Function CreateVDirOutputWMI

DetailPrint "Creating $TEMP\createVDirOutput.vbs";
FileOpen $0 "$TEMP\createVDirOutput.vbs" w

;http://www.vbsedit.com/scripts/iis/iis6/web/scr_676.asp
;http://forums.iis.net/t/1152839.aspx

FileWrite $0 'Dim objFSO$\n'
FileWrite $0 'Set objWMIService = GetObject ("winmgmts:{authenticationLevel=pktPrivacy}\\localhost\root\microsoftiisv2")$\r$\n'
 
FileWrite $0 'Set vdirObj= objWMIService.get("IIsWebVirtualDirSetting=$\'W3SVC/" & objItem.Name & "/ROOT$\'")$\r$\n'
FileWrite $0 'IUSRUserName = vdirObj.AnonymousUserName$\r$\n'	

FileWrite $0 'Set objShell = CreateObject("Wscript.Shell")$\n'
FileWrite $0 'Set objFSO = CreateObject("Scripting.FileSystemObject")$\n'
FileWrite $0 'strFolderName = "$INSTDIR\${VDIROUTPUT}"$\n'
FileWrite $0 'If objFSO.FolderExists(strFolderName) Then$\n'
FileWrite $0 'Set objFolder = objFSO.GetFolder(strFolderName)$\n'
FileWrite $0 'Else$\n'
FileWrite $0 'Set objFolder = objFSO.CreateFolder(strFolderName)$\n'
FileWrite $0 'End If$\n'
FileWrite $0 'Const SILENTMODE = 7$\n'
FileWrite $0 'strCommand = "cacls " & strFolderName & " /T /E /P " & IUSRUserName & ":C"$\n'
FileWrite $0 'Call objShell.Run(strCommand, SILENTMODE)$\n'
FileWrite $0 'Set objFSO = Nothing$\n'
FileWrite $0 'Set objFolder = Nothing$\n'

;FileWrite $0 'Set objShell = CreateObject("Wscript.Shell")$\n'
;FileWrite $0 'Set objFSO = CreateObject("Scripting.FileSystemObject")$\n'
;FileWrite $0 'strFolderName = "$INSTDIR\${VDIROUTPUT}"$\n'
;FileWrite $0 'Set objFolder = objFSO.CreateFolder(strFolderName)$\n'
;FileWrite $0 'intRunError = objShell.Run("%COMSPEC% /c Echo Y| cacls " & strFolderName & " /t /c /g everyone:F ", 2, True)$\n'
;FileWrite $0 'If intRunError <> 0 Then$\n'
;FileWrite $0 ' Wscript.Echo "Error assigning permissions for user $\n'
;FileWrite $0 'End If$\n'
;FileWrite $0 'Set objFSO = Nothing'

FileClose $0

DetailPrint "Executing $TEMP\createVDirOutput.vbs"
nsExec::Exec /TIMEOUT=20000 '"$SYSDIR\cscript.exe" "$TEMP\createVDirOutput.vbs"'
Pop $1
StrCmp $1 "0" CreateVDirOutputOK
DetailPrint "Error $1 in CreateVDirOutput.vbs"
Abort "Failed to create IIS output Virtual Directory"

CreateVDirOutputOK:
;MessageBox MB_YESNO|MB_ICONEXCLAMATION "Successfully created IIS virtual directory"
DetailPrint "Successfully created IIS output virtual directory"
Delete "$TEMP\createVDirOutput.vbs"
FunctionEnd

;-----------------------------------------------------------------------------------------

Function CreateVDirOutputADSI
  
;Var /Global tVAR
;Open a VBScript File in the temp dir for writing
DetailPrint "Creating $TEMP\createVDirOutput.vbs";
FileOpen $0 "$TEMP\createVDirOutput.vbs" w

FileWrite $0 'Dim objFSO$\n'
FileWrite $0 'Set IIsObject = GetObject ("IIS://localhost/w3svc")$\n'
FileWrite $0 'IUSRUserName = IIsObject.Get("AnonymousUserName")$\n'
;FileWrite $0 'IWAMUserName = IIsObject.Get("WAMUserName")$\n'
FileWrite $0 'Set objShell = CreateObject("Wscript.Shell")$\n'
FileWrite $0 'Set objFSO = CreateObject("Scripting.FileSystemObject")$\n'
FileWrite $0 'strFolderName = "$INSTDIR\${VDIROUTPUT}"$\n'
FileWrite $0 'If objFSO.FolderExists(strFolderName) Then$\n'
FileWrite $0 'Set objFolder = objFSO.GetFolder(strFolderName)$\n'
FileWrite $0 'Else$\n'
FileWrite $0 'Set objFolder = objFSO.CreateFolder(strFolderName)$\n'
FileWrite $0 'End If$\n'
FileWrite $0 'Const SILENTMODE = 7$\n'
FileWrite $0 'strCommand = "cacls " & strFolderName & " /T /E /P " & IUSRUserName & ":C"$\n'
FileWrite $0 'Call objShell.Run(strCommand, SILENTMODE)$\n'
FileWrite $0 'Set objFSO = Nothing$\n'
FileWrite $0 'Set objFolder = Nothing$\n'

; /config/
FileWrite $0 'Set objShell = CreateObject("Wscript.Shell")$\n'
FileWrite $0 'Set objFSO = CreateObject("Scripting.FileSystemObject")$\n'
FileWrite $0 'strFolderName = "$INSTDIR\w3perl\${DIRCFG}"$\n'
FileWrite $0 'Set objFolder = objFSO.GetFolder(strFolderName)$\n'
FileWrite $0 'strCommand = "cacls " & strFolderName & " /T /E /P " & IUSRUserName & ":C"$\n'
FileWrite $0 'Call objShell.Run(strCommand, SILENTMODE)$\n'
FileWrite $0 'Set objFSO = Nothing$\n'
FileWrite $0 'Set objFolder = Nothing$\n'

; /resources/admin/
FileWrite $0 'Set objShell = CreateObject("Wscript.Shell")$\n'
FileWrite $0 'Set objFSO = CreateObject("Scripting.FileSystemObject")$\n'
FileWrite $0 'strFolderName = "$INSTDIR\w3perl\${DIRRESADM}"$\n'
FileWrite $0 'Set objFolder = objFSO.GetFolder(strFolderName)$\n'
FileWrite $0 'strCommand = "cacls " & strFolderName & " /T /E /P " & IUSRUserName & ":C"$\n'
FileWrite $0 'Call objShell.Run(strCommand, SILENTMODE)$\n'
FileWrite $0 'Set objFSO = Nothing$\n'
FileWrite $0 'Set objFolder = Nothing$\n'

; /cgi-bin/w3perl/
FileWrite $0 'Set objShell = CreateObject("Wscript.Shell")$\n'
FileWrite $0 'Set objFSO = CreateObject("Scripting.FileSystemObject")$\n'
FileWrite $0 'strFolderName = "$INSTDIR\cgi-bin\w3perl"$\n'
FileWrite $0 'Set objFolder = objFSO.GetFolder(strFolderName)$\n'
FileWrite $0 'strCommand = "cacls " & strFolderName & " /T /E /P " & IUSRUserName & ":C"$\n'
FileWrite $0 'Call objShell.Run(strCommand, SILENTMODE)$\n'
FileWrite $0 'Set objFSO = Nothing$\n'
FileWrite $0 'Set objFolder = Nothing$\n'

; LogFileDir
FileWrite $0 'Set objShell = CreateObject("Wscript.Shell")$\n'
FileWrite $0 'Set objFSO = CreateObject("Scripting.FileSystemObject")$\n'
FileWrite $0 'strFolderName = "$LogFileDir"$\n'
FileWrite $0 'Set objFolder = objFSO.GetFolder(strFolderName)$\n'
FileWrite $0 'strCommand = "cacls " & strFolderName & " /T /E /P " & IUSRUserName & ":C"$\n'
FileWrite $0 'Call objShell.Run(strCommand, SILENTMODE)$\n'
FileWrite $0 'Set objFSO = Nothing$\n'
FileWrite $0 'Set objFolder = Nothing$\n'

;FileWrite $0 'Set objShell = CreateObject("Wscript.Shell")$\n'
;FileWrite $0 'Set objFSO = CreateObject("Scripting.FileSystemObject")$\n'
;FileWrite $0 'strFolderName = "$INSTDIR\${VDIROUTPUT}"$\n'
;FileWrite $0 'Set objFolder = objFSO.CreateFolder(strFolderName)$\n'
;FileWrite $0 'intRunError = objShell.Run("%COMSPEC% /c Echo Y| cacls " & strFolderName & " /t /c /g everyone:F ", 2, True)$\n'
;FileWrite $0 'If intRunError <> 0 Then$\n'
;FileWrite $0 ' Wscript.Echo "Error assigning permissions for user $\n'
;FileWrite $0 'End If$\n'
;FileWrite $0 'Set objFSO = Nothing'

;FileWrite $0 'Set objWMIService = GetObject("winmgmts:\\localhost\root\CIMV2")$\n'
;FileWrite $0 'Set colItems = objWMIService.ExecQuery("SELECT * FROM Win32_LogicalFileSecuritySetting WHERE Path=""$INSTDIR\${VDIROUTPUT}""",,48)$\n'
;FileWrite $0 'For Each objItem in colItems$\n'
;FileWrite $0 '    Wscript.Echo "Win32_LogicalFileSecuritySetting for file c:\Temp"$\n'
;FileWrite $0 '    Wscript.Echo "ControlFlags: " & objItem.ControlFlags$\n'
;FileWrite $0 '    Wscript.Echo "Description: " & objItem.Description$\n'
;FileWrite $0 '    Wscript.Echo "OwnerPermissions: " & objItem.OwnerPermissions$\n'
;FileWrite $0 '    Wscript.Echo "Path: " & objItem.Path$\n'
;FileWrite $0 '    Wscript.Echo "SettingID: " & objItem.SettingID$\n'
;FileWrite $0 'Next$\n'

FileClose $0

DetailPrint "Executing $TEMP\createVDirOutput.vbs"
nsExec::Exec /TIMEOUT=20000 '"$SYSDIR\cscript.exe" "$TEMP\createVDirOutput.vbs"'
Pop $1
StrCmp $1 "0" CreateVDirOutputOK
DetailPrint "Error $1 in $TEMP\CreateVDirOutput.vbs"
Abort "Failed to create IIS output Virtual Directory"

CreateVDirOutputOK:
;MessageBox MB_YESNO|MB_ICONEXCLAMATION "Successfully created IIS virtual directory"
DetailPrint "Successfully created IIS output virtual directory"
Delete "$TEMP\createVDirOutput.vbs"
FunctionEnd

;-----------------------------------------------------------------------------------------

; DeleteVDir Function
Function un.DeleteVDirOutput

;Open a VBScript File in the temp dir for writing
DetailPrint "Creating $TEMP\deleteVDirOutput.vbs";
FileOpen $0 "$TEMP\deleteVDirOutput.vbs" w

;Write the script:
;Delete the application object
FileWrite $0 "Set IISObject = GetObject($\"IIS://LocalHost/W3SVC/$WebName/ROOT/${VDIROUTPUT}$\")$\n"
FileWrite $0 "IISObject.AppDelete 'Delete the web application'$\n"
FileWrite $0 "If (Err.Number <> 0) Then$\n"
FileWrite $0 " MsgBox $\"Error trying to delete the application at [IIS://LocalHost/W3SVC/$WebName/ROOT/${VDIROUTPUT}]$\", vbCritical, $\"${PRODUCT_NAME}$\"$\n"
FileWrite $0 " WScript.Quit (Err.Number)$\n"
FileWrite $0 "End If$\n"

FileWrite $0 "Set IISObject = GetObject($\"IIS://LocalHost/W3SVC/$WebName/ROOT$\")$\n"
FileWrite $0 "IIsObject.Delete $\"IIsWebVirtualDir$\", $\"${VDIROUTPUT}$\"$\n"
FileWrite $0 "If (Err.Number <> 0) Then$\n"
FileWrite $0 " MsgBox $\"Error trying to delete the virtual directory '${VDIROUTPUT}' at 'IIS://LocalHost/W3SVC/$WebName/ROOT'$\", vbCritical, $\"${PRODUCT_NAME}$\"$\n"
FileWrite $0 " Wscript.Quit (Err.Number)$\n"
FileWrite $0 "End If$\n"

FileClose $0

DetailPrint "Executing $TEMP\deleteVDirOutput.vbs"
nsExec::Exec /TIMEOUT=20000 '"$SYSDIR\cscript.exe" "$TEMP\deleteVDirOutput.vbs"'
Pop $1
StrCmp $1 "0" +2
DetailPrint "Error $1 in deleteVDirOutput.vbs"
goto DeleteVDirOutputEnd
DetailPrint "Virtual Directory ${VDIROUTPUT} successfully removed."
Delete "$TEMP\deleteVDirOutput.vbs"
DeleteVDirOutputEnd:
FunctionEnd

;-----------------------------------------------------------------------------------------

Section "SectionPrincipale" SEC01

;Call ValidateCustom
  StrCmp $upgrade 1 0 +7
  ReadRegStr $R0 "${PRODUCT_UNINST_ROOT_KEY}" "${PRODUCT_DIR_REGKEY}" ""
  StrCpy $INSTDIR "$R0\"
  SetOutPath "$INSTDIR\w3perl"
  ReadINIStr $IP "$INSTDIR\w3perl\Config.txt" "Data" "IP"
 ReadINIStr $Port "$INSTDIR\w3perl\Config.txt" "Data" "Port"
  goto install_command
 
 ReadINIStr $0 "$PLUGINSDIR\pick_website.ini" "Field 2" "State"
 ReadINIStr $1 "$PLUGINSDIR\websites.ini" "$0" "WebRoot"
 ReadINIStr $LogFileDir "$PLUGINSDIR\websites.ini" "$0" "LogDir"
 ReadINIStr $LogType "$PLUGINSDIR\websites.ini" "$0" "LogType"
 ReadINIStr $LogPeriod "$PLUGINSDIR\websites.ini" "$0" "LogPeriod"
 ReadINIStr $LogTypeFormat "$PLUGINSDIR\websites.ini" "$0" "LogTypeFormat"
 ReadINIStr $WebName "$PLUGINSDIR\websites.ini" "$0" "Name"
 ReadINIStr $WebRoot "$PLUGINSDIR\websites.ini" "$0" "WebRoot"
 ReadINIStr $IP "$PLUGINSDIR\websites.ini" "$0" "IP"
 ReadINIStr $Timeout "$PLUGINSDIR\websites.ini" "$0" "Timeout"
 ReadINIStr $Port "$PLUGINSDIR\websites.ini" "$0" "Port"
 ReadINIStr $IIS_State "$PLUGINSDIR\websites.ini" "$0" "Status"
 ReadINIStr $2 "$PLUGINSDIR\pick_website.ini" "Field 4" "State"

 StrCpy $DIR_USER $2
 StrCmp $DIR_USER "" +3 0
 StrCpy $DIR_USER_URL "$2/"
 goto +2
 StrCpy $DIR_USER_URL "$2"
 
 Push $2
 Push "/"
 Call StrSlash
 Pop $R0
 StrCpy $INSTDIR "$WebRoot\$R0"
 SetOutPath "$INSTDIR\w3perl"

  ;StrCpy $PerlPath "$5"
  StrCpy $PerlPathBin $PerlPath
  StrCpy $PerlPathBin "$PerlPathBin" -9
  
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "PerlPath" "$PerlPathBin"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "InstallPath" "$INSTDIR\w3perl"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "InstallPath_URL" "$DIR_USER"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "WebRoot" "$WebRoot"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "CGIPath" "$INSTDIR\cgi-bin\w3perl"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "CGIServer" "$INSTDIR\cgi-bin"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "LogType" "$LogType"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "LogPeriod" "$LogPeriod"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "LogTypeFormat" "$LogTypeFormat"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "LogFileServer" "$LogFileDir"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "IP" "$IP"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "Port" "$Port"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "Status" "$IIS_State"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "Timeout" "$Timeout"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "Description" "$0"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "DirOutput" "${VDIROUTPUT}"
  WriteINIStr "$INSTDIR\w3perl\Config.txt" "Data" "ConfigFile" "${ConfigWin}"

;MessageBox MB_OK "upgrade $INSTDIR"
  install_command:
  FileOpen $0 $INSTDIR\w3perl\InitStats.bat w
  FileWrite $0 "$\"$INSTDIR\cgi-bin\w3perl\cron-w3perl.pl$\" -c $\"$INSTDIR\cgi-bin\w3perl\${ConfigWin}${PERLEXT}$\" -a"
  FileClose $0

  FileOpen $0 $INSTDIR\w3perl\UpdateStats.bat w
  FileWrite $0 "$\"$INSTDIR\cgi-bin\w3perl\cron-w3perl.pl$\" -c $\"$INSTDIR\cgi-bin\w3perl\${ConfigWin}${PERLEXT}$\" -e"
  FileClose $0
  
  SetOverwrite On
  File /r "${NSISDIR}\w3perl\*"
  
  ;StrCmp $5 perl.exe 0 +2
  ;SearchPath $5 perl.exe
   ;StrCmp $5 "" 0 +2
   ;StrCpy $5 perl.exe
  
  IntCmp $upgrade 0 0 0 +3
  nsExec::Exec '$PerlPath "$INSTDIR\w3perl\install.pl" -g "$INSTDIR\w3perl\Config.txt"'
  goto +3
  nsExec::Exec '$PerlPath "$INSTDIR\w3perl\upgrade.pl" -g "$INSTDIR\w3perl\Config.txt"'
  goto +10
  
  IntCmp $WMI 1 0 +3 0
  Call CreateVDirWMI
  goto +2
  Call CreateVDirADSI

  IntCmp $WMI 1 0 +3 0
  Call CreateVDirOutputWMI
  goto +2
  Call CreateVDirOutputADSI

  nsExec::Exec /TIMEOUT=20000 '"$SYSDIR\cscript.exe" "C:\Inetpub\AdminScripts\adsutil.vbs" set "w3svc/$WebName/root/${VDIRNAME}/CGITimeout" "36000"'

; IIS 7 appcmd set config /section:cgi /timeout:00:30:00
SectionEnd

;-----------------------------------------------------------------------------------------

Function LaunchLink
; check first IIS is running
  ;ExecShell open "${PRODUCT_WEB_INSTALL}$DIR_USER/${PRODUCT_WEB_ADMIN_URL}"
  ExecShell open "http://$IP:$Port/$DIR_USER_URL${PRODUCT_WEB_ADMIN_URL}"
FunctionEnd

;-----------------------------------------------------------------------------------------

Section -AdditionalIcons

  ;WriteIniStr "$INSTDIR\w3perl\Admin.url" "InternetShortcut" "URL" "${PRODUCT_WEB_INSTALL}$DIR_USER/${PRODUCT_WEB_ADMIN_URL}"
  WriteIniStr "$INSTDIR\w3perl\Admin.url" "InternetShortcut" "URL" "http://$IP:$Port/$DIR_USER_URL${PRODUCT_WEB_ADMIN_URL}"
  WriteIniStr "$INSTDIR\w3perl\Admin.url" "InternetShortcut" "IconFile" "$INSTDIR\w3perl\resources\favicon.ico"
  WriteIniStr "$INSTDIR\w3perl\Admin.url" "InternetShortcut" "IconIndex" "0"
  
  WriteIniStr "$INSTDIR\w3perl\Whats new.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE_NEW}?${PRODUCT_VERSION}"
  WriteIniStr "$INSTDIR\w3perl\Whats new.url" "InternetShortcut" "IconFile" "$INSTDIR\w3perl\resources\favicon.ico"
  WriteIniStr "$INSTDIR\w3perl\Whats new.url" "InternetShortcut" "IconIndex" "0"
  
  WriteIniStr "$INSTDIR\w3perl\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE_HOME}"
  WriteIniStr "$INSTDIR\w3perl\${PRODUCT_NAME}.url" "InternetShortcut" "IconFile" "$INSTDIR\w3perl\resources\favicon.ico"
  WriteIniStr "$INSTDIR\w3perl\${PRODUCT_NAME}.url" "InternetShortcut" "IconIndex" "0"
  
  WriteIniStr "$INSTDIR\w3perl\ViewStats.url" "InternetShortcut" "URL" "http://$IP:$Port/${PRODUCT_OUTPUT_STATS_URL}"
  WriteIniStr "$INSTDIR\w3perl\ViewStats.url" "InternetShortcut" "IconFile" "$INSTDIR\w3perl\resources\favicon.ico"
  WriteIniStr "$INSTDIR\w3perl\ViewStats.url" "InternetShortcut" "IconIndex" "0"

  SetShellVarContext all
  CreateDirectory "$SMPROGRAMS\W3Perl"
  CreateShortCut "$SMPROGRAMS\W3Perl\Admin.lnk" "$INSTDIR\w3perl\Admin.url" "" "$INSTDIR\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\Init Stats.lnk" "$INSTDIR\w3perl\InitStats.bat" "" "$INSTDIR\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\Update Stats.lnk" "$INSTDIR\w3perl\UpdateStats.bat" "" "$INSTDIR\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\Whats new.lnk" "$INSTDIR\w3perl\Whats new.url" "" "$INSTDIR\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\${PRODUCT_NAME}.lnk" "$INSTDIR\w3perl\${PRODUCT_NAME}.url" "" "$INSTDIR\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\View Stats.lnk" "$INSTDIR\w3perl\ViewStats.url" "" "$INSTDIR\w3perl\resources\favicon.ico" 0
  CreateShortCut "$SMPROGRAMS\W3Perl\Uninstall.lnk" "$INSTDIR\w3perl\uninst.exe"
SectionEnd

;-----------------------------------------------------------------------------------------

Section -Post
  WriteUninstaller "$INSTDIR\w3perl\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$\"$INSTDIR\w3perl\uninst.exe$\""
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "WebName" "$WebName"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$\"H:\nsis\logo_32x32.ico$\""
  ;WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$\"$INSTDIR\w3perl\resources\favicon.ico$\""
SectionEnd

;-----------------------------------------------------------------------------------------

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "$(^Name) has been successfully removed from your computer"
FunctionEnd

;-----------------------------------------------------------------------------------------

Function un.onInit
;!insertmacro MUI_UNGETLANGUAGE
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to remove $(^Name)?" IDYES +2
  Abort
FunctionEnd

;-----------------------------------------------------------------------------------------

Function skip_install
  StrCmp $upgrade 1 0 +2
  Abort
FunctionEnd

;-----------------------------------------------------------------------------------------

Section Uninstall
  
  ReadRegStr $0 ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_DIR_REGKEY}" ""
  StrCpy $INSTDIR "$0"
  
  ReadRegStr $0 ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "WebName"
  StrCpy $WebName "$0"
  
  Delete "$INSTDIR\w3perl\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\w3perl\Admin.url"
  Delete "$INSTDIR\w3perl\Whats new.url"
  Delete "$INSTDIR\w3perl\uninst.exe"
  
  Delete "$INSTDIR\w3perl\tools\Transfert_log_Unix2Unix\*"
  Delete "$INSTDIR\w3perl\tools\Transfert_log_NT2Unix\*"
  Delete "$INSTDIR\w3perl\tools\windows\*"
  Delete "$INSTDIR\w3perl\tools\*"
  Delete "$INSTDIR\w3perl\resources\counter\*"
  Delete "$INSTDIR\w3perl\resources\spip\*"
  Delete "$INSTDIR\w3perl\resources\os\*"
  Delete "$INSTDIR\w3perl\resources\css\*"
  Delete "$INSTDIR\w3perl\resources\js\jqplot\plugins\*"
  Delete "$INSTDIR\w3perl\resources\js\jqplot\*"
  Delete "$INSTDIR\w3perl\resources\js\jvectormap\*"
  Delete "$INSTDIR\w3perl\resources\js\*"
  Delete "$INSTDIR\w3perl\resources\lang\country\*"
  Delete "$INSTDIR\w3perl\resources\lang\help\*"
  Delete "$INSTDIR\w3perl\resources\lang\*"
  Delete "$INSTDIR\w3perl\resources\homepage\*"
  Delete "$INSTDIR\w3perl\resources\help\uk\*"
  Delete "$INSTDIR\w3perl\resources\help\admin\*"
  Delete "$INSTDIR\w3perl\resources\help\*"
  Delete "$INSTDIR\w3perl\resources\flags\*"
  Delete "$INSTDIR\w3perl\resources\pays\*"
  Delete "$INSTDIR\w3perl\resources\admin\*"
  Delete "$INSTDIR\w3perl\resources\*"
  Delete "$INSTDIR\w3perl\docs\img\*"
  Delete "$INSTDIR\w3perl\docs\uk\*"
  Delete "$INSTDIR\w3perl\docs\fr\*"
  Delete "$INSTDIR\w3perl\docs\*"
  Delete "$INSTDIR\w3perl\logs\*"
  Delete "$INSTDIR\w3perl\config\*"
  Delete "$INSTDIR\w3perl\admin\config\*"
  Delete "$INSTDIR\w3perl\admin\scripts\*"
  Delete "$INSTDIR\w3perl\admin\js\*"
  Delete "$INSTDIR\w3perl\admin\*"
  Delete "$INSTDIR\w3perl\*"
  
  RMDir "$INSTDIR\w3perl\tools\Transfert_log_Unix2Unix"
  RMDir "$INSTDIR\w3perl\tools\Transfert_log_NT2Unix"
  RMDir "$INSTDIR\w3perl\tools\windows"
  RMDir "$INSTDIR\w3perl\tools"
  RMDir "$INSTDIR\w3perl\resources\counter"
  RMDir "$INSTDIR\w3perl\resources\spip"
  RMDir "$INSTDIR\w3perl\resources\os"
  RMDir "$INSTDIR\w3perl\resources\css"
  RMDir "$INSTDIR\w3perl\resources\js\jqplot\plugins"
  RMDir "$INSTDIR\w3perl\resources\js\jqplot"
  RMDir "$INSTDIR\w3perl\resources\js\jvectormap"
  RMDir "$INSTDIR\w3perl\resources\js"
  RMDir "$INSTDIR\w3perl\resources\lang\country"
  RMDir "$INSTDIR\w3perl\resources\lang\help"
  RMDir "$INSTDIR\w3perl\resources\lang"
  RMDir "$INSTDIR\w3perl\resources\homepage"
  RMDir "$INSTDIR\w3perl\resources\help\uk"
  RMDir "$INSTDIR\w3perl\resources\help\admin"
  RMDir "$INSTDIR\w3perl\resources\help"
  RMDir "$INSTDIR\w3perl\resources\flags"
  RMDir "$INSTDIR\w3perl\resources\pays"
  RMDir "$INSTDIR\w3perl\resources\admin"
  RMDir "$INSTDIR\w3perl\resources"
  RMDir "$INSTDIR\w3perl\docs\img"
  RMDir "$INSTDIR\w3perl\docs\uk"
  RMDir "$INSTDIR\w3perl\docs\fr"
  RMDir "$INSTDIR\w3perl\docs"
  RMDir "$INSTDIR\w3perl\logs"
  RMDir "$INSTDIR\w3perl\config"
  RMDir "$INSTDIR\w3perl\cgi-bin\w3perl"
  RMDir "$INSTDIR\w3perl\cgi-bin"
  ;RMDir "$INSTDIR\w3perl\admin\help"
  RMDir "$INSTDIR\w3perl\admin\config"
  RMDir "$INSTDIR\w3perl\admin\scripts"
  RMDir "$INSTDIR\w3perl\admin\js"
  RMDir "$INSTDIR\w3perl\admin"
  RMDir "$INSTDIR\w3perl"

  Delete "$INSTDIR\cgi-bin\w3perl\tools\*"
  Delete "$INSTDIR\cgi-bin\w3perl\*"
  RMDir "$INSTDIR\cgi-bin\w3perl\tools"
  RMDir "$INSTDIR\cgi-bin\w3perl"
  RMDir "$INSTDIR\cgi-bin"
   
  SetShellVarContext all
  Delete "$SMPROGRAMS\W3Perl\Uninstall.lnk"
  Delete "$SMPROGRAMS\W3Perl\Admin.lnk"
  Delete "$SMPROGRAMS\W3Perl\Whats new.lnk"
  Delete "$SMPROGRAMS\W3Perl\Init Stats.lnk"
  Delete "$SMPROGRAMS\W3Perl\Update Stats.lnk"
  Delete "$SMPROGRAMS\W3Perl\View Stats.lnk"
  Delete "$SMPROGRAMS\W3Perl\${PRODUCT_NAME}.lnk"
  RMDir "$SMPROGRAMS\W3Perl"

  IntCmp $WMI 1 0 +3 0
  Call un.DeleteVDirWMI
  goto +2
  Call un.DeleteVDirADSI
  
;  Call un.DeleteVDirADSI
  ;Call un.DeleteVDirOutput
  
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_DIR_REGKEY}"
  SetAutoClose true

  IfFileExists "$INSTDIR\w3perl" 0 NoErrorMsg
    MessageBox MB_OK "Note: $INSTDIR\w3perl could not be removed!" IDOK 0 ; skipped if file doesn't exist
  NoErrorMsg:
  
SectionEnd
