#!/bin/sh

#########################################################################
# Upload logfiles file and then launch w3perl for weekly and full stats 
#
# This script upload logfiles from differents web server and compute
# stats for each of them from a crontab each night
# My provider don't allow to run more than one crontab per day.
#
# Run this script in a crontab to automatically upload logfile and update your stats
#
# Upload :
# You'll need to get as many netrc files as upload to do.
# .netrc file are needed to launch ftp session automatically
# syntax is : "default login <your_login> password <your_password>"
# this file should not be readable by other people as password are
# not crypted !
# Filename of netrc file could be netrc_<webdomain>
# They are moved to .netrc for upload and then deleted.
# Feel free to modify your ftp session. My own log file are located
# in the stats directory (cd stats)...and I upload only the current
# logfile. They are nammed old_access_log.1998Nov.gz on my server 
# (get $prefixlog.$year$month.gz)
#
# Stats :
# You'll need one configuration files for every stats
# They are loaded via the -c flag
# The -e flag is for incremental stats.

### Get logfiles data
# PATH   : Location where the logfile will be download
# PATHRC : Location of the netrc user file
# FTP    : Location of the ftp binary
# prefixlog : Name of your log filename

PATH=/var/w3perl/logs
PATHRC=/home/domisse
FTP=/usr/bin/ftp

PATHLOG=$PATH/futurequest
FILERC=$PATHRC/netrc_w3perl
FTP_SERVER=ftp.w3perl.com

### CONSTANT

FILERCACTIVE=$PATHRC/.netrc
prefixlog=access
errorlog=error

### Get the date and the name of the current logfilename.

day=`/bin/date +"%d"`
month=`/bin/date +"%m"`
year=`/bin/date +"%y"`

#
# First day of the month test
#

day=`/usr/bin/expr $day - 1`

if [ "$day" = "0" ]
   then
      month=`/usr/bin/expr $month - 1`
   else
      month=`/usr/bin/expr $month - 0`
fi

#
# First day of the year test
#

if [ "$month" = "0" ]
   then
      month=12;year=`/usr/bin/expr $year - 1`
    if [ $year -lt 10 ]
    then
      year=0$year
    fi
fi


if [ "$day" = "0" ]
then
if [ $month = "1" ] 
then day=31 
fi
if [ $month = "2" ] 
then day=28 
fi
if [ $month = "3" ] 
then day=31 
fi
if [ $month = "4" ] 
then day=30 
fi
if [ $month = "5" ] 
then day=31 
fi
if [ $month = "6" ] 
then day=30 
fi
if [ $month = "7" ] 
then day=31 
fi
if [ $month = "8" ] 
then day=31 
fi
if [ $month = "9" ] 
then day=30 
fi
if [ $month = "10" ] 
then day=31 
fi
if [ $month = "11" ] 
then day=30 
fi
if [ $month = "12" ] 
then day=31 
fi
fi

#
# add two digit for one digit month
#

if [ $month -lt 10 ]
   then
      month=0$month
fi

#
# add two digit for one digit day
#

if [ $day -lt 10 ]
   then
      day=0$day
fi

#
# get year 2000 compliant ;)
#

if [ $year -lt 95 ]
   then
      year="20"$year
   else
      year="19"$year
fi

########################## Upload #################################

### w3perl.com

cd $PATHLOG

echo "cd $PATHLOG"

/bin/mv $FILERC $FILERCACTIVE 

echo "mv $FILERC $FILERCACTIVE"

echo "$FTP $FTP_SERVER"

$FTP $FTP_SERVER <<EOF
bin
pass
cd logs
get $prefixlog.$year$month$day.gz
get $errorlog
EOF

echo "mv $FILERCACTIVE $FILERC"

/bin/mv $FILERCACTIVE $FILERC

exit

######################## Compute stats #####################################

### Incremental stats

/var/w3perl/cgi-bin/w3perl/cron-w3perl.pl -c /var/w3perl/cgi-bin/w3perl/config-w3perl.pl -e
